--
-- kOOL - the church tool
-- www.churchtool.org
--
-- IMPORTANT: Run update_R38.php before applying this file, as the newsletter tables will be deleted in this update
-- 
-- DB changes needed for update from R37 to R38
-- Important: Update DB before updating source
--



-- New settings
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ( 'daten_pdf_week_start', '1'), ( 'res_pdf_week_start', '1');


-- New setting for rota
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ( 'dp_months_back', '3');

-- New filter for donations
INSERT INTO `ko_filter` ( `id` , `typ` , `dbcol` , `name` , `allow_neg` , `sql1` , `sql2` , `sql3` , `numvars` , `var1` , `code1` , `var2` , `code2` , `var3` , `code3`) VALUES ( NULL , 'leute', 'ko_donations.date', 'donation', 0, 'YEAR(`date`) = ''[VAR1]''', '`account` = ''[VAR2]''', '', 2, 'year', 'FCN:ko_specialfilter_donation', 'account', 'FCN:ko_specialfilter_donation_account', '', '');


-- New module tracking
ALTER TABLE `ko_admin` ADD `tracking_admin` TEXT NOT NULL AFTER `donations_admin` ;
ALTER TABLE `ko_admingroups` ADD `tracking_admin` TEXT NOT NULL AFTER `donations_admin` ;

CREATE TABLE `ko_tracking` (
  `id` mediumint(9) unsigned NOT NULL auto_increment,
  `group_id` mediumint(9) NOT NULL default '0',
  `name` varchar(200) collate latin1_german1_ci NOT NULL,
  `label_value` varchar(200) collate latin1_german1_ci NOT NULL,
  `types` text collate latin1_german1_ci NOT NULL,
  `mode` varchar(10) collate latin1_german1_ci NOT NULL,
  `filter` text collate latin1_german1_ci NOT NULL,
  `date_mode` varchar(100) collate latin1_german1_ci NOT NULL,
  `date_eventgroup` mediumint(9) NOT NULL,
  `date_weekdays` varchar(20) collate latin1_german1_ci NOT NULL,
  `dates` text collate latin1_german1_ci NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `group_id` (`group_id`)
);

CREATE TABLE `ko_tracking_entries` (
  `id` mediumint(8) unsigned NOT NULL auto_increment,
  `lid` mediumint(9) NOT NULL,
  `tid` mediumint(9) NOT NULL,
  `date` date NOT NULL,
  `type` varchar(200) NOT NULL,
  `value` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `tidliddate` (`tid`,`lid`,`date`),
  KEY `tid` (`tid`),
  KEY `tiddate` (`tid`,`date`)
);

CREATE TABLE `ko_tracking_groups` (
  `id` mediumint(9) unsigned NOT NULL auto_increment,
  `name` varchar(200) NOT NULL,
  PRIMARY KEY  (`id`),
  KEY `name` (`name`)
);


-- Help links for tracking module
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'tracking', '', 'en', '89', '', ''), ( NULL , 'tracking', '', 'de', '89', '', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'tracking', 'submenu_export', 'en', '89', '1013', ''), ( NULL , 'tracking', 'submenu_export', 'de', '89', '1023', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'kota', 'ko_tracking', 'en', '89', '1010', ''), ( NULL , 'kota', 'ko_tracking', 'de', '89', '1020', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'tracking', 'enter_tracking', 'en', '89', '1011', ''), ( NULL , 'tracking', 'enter_tracking', 'de', '89', '1021', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'tracking', 'list_trackings', 'en', '89', '1028', ''), ( NULL , 'tracking', 'list_trackings', 'de', '89', '1029', '');
INSERT INTO `ko_help` ( `id` , `module` , `type` , `language` , `t3_page` , `t3_content` , `text`) VALUES ( NULL , 'admin', 'submenu_news', 'en', '40', '1036', ''), ( NULL , 'admin', 'submenu_news', 'de', '40', '1037', '');



-- Set filter code fields to LONGTEXT to hold long select input (e.g. for families)
ALTER TABLE `ko_filter` CHANGE `code1` `code1` LONGTEXT NOT NULL , CHANGE `code2` `code2` LONGTEXT NOT NULL , CHANGE `code3` `code3` LONGTEXT NOT NULL;

-- Add new (optional) family field email
ALTER TABLE `ko_familie` ADD `famemail` ENUM( '', 'husband', 'wife' ) NOT NULL;

-- New AddChildren filter
INSERT INTO `ko_filter` (`id`, `typ`, `dbcol`, `name`, `allow_neg`, `sql1`, `sql2`, `sql3`, `numvars`, `var1`, `code1`, `var2`, `code2`, `var3`, `code3`) VALUES(NULL, 'leute', '', 'addchildren', 0, 'YEAR(CURDATE())-YEAR(`geburtsdatum`) >= ''[VAR1]''', 'YEAR(CURDATE())-YEAR(`geburtsdatum`) <= ''[VAR2]''', '', 3, 'age_min', '<input type="text" name="var1" size="12" maxlength="3" onkeydown="if ((event.which == 13) || (event.keyCode == 13)) { this.form.submit_filter.click(); return false;} else return true;" />', 'age_max', '<input type="text" name="var2" size="12" maxlength="3" onkeydown="if ((event.which == 13) || (event.keyCode == 13)) { this.form.submit_filter.click(); return false;} else return true;" />', 'only_children', '<input type="checkbox" name="var3" value="1" />');
INSERT INTO `ko_filter` (`id` , `typ` , `dbcol` , `name` , `allow_neg` , `sql1` , `sql2` , `sql3` , `numvars` , `var1` , `code1` , `var2` , `code2` , `var3` , `code3`) VALUES ( NULL , 'leute', '', 'addparents', '0', '', '', '', '1', 'only_parents', '<input type="checkbox" name="var1" value="1" />', '', '', '', '');



-- Remove newsletter module
-- IMPORTANT: Run update_R38.php before applying these changes
DELETE FROM `ko_news` WHERE `type` IN ('3', '4', '5');
DROP TABLE `ko_newsletter`;
DROP TABLE `ko_newsletter_mod`;
DROP TABLE `ko_news_sms`;
DROP TABLE `ko_news_type`;
ALTER TABLE `ko_news` DROP `newsletter_id`, DROP `recipients`, DROP `image`, DROP `start`, DROP `stop`;
ALTER TABLE `ko_news` CHANGE `link` `link` VARCHAR( 255 ) NOT NULL;
ALTER TABLE `ko_news` CHANGE `cdate` `cdate` DATE NOT NULL DEFAULT '0000-00-00';
ALTER TABLE `ko_admin` DROP `news_admin`;
ALTER TABLE `ko_admingroups` DROP `news_admin`;
DELETE FROM `ko_userprefs` WHERE `key` IN ('submenu_news_left', 'submenu_news_right', 'show_limit_news', 'default_view_news', 'submenu_news_left_closed', 'submenu_news_right_closed');
DELETE FROM `ko_settings` WHERE `key` IN ('show_limit_news', 'default_view_news');


-- New setting for birthday filter
INSERT INTO `ko_settings` ( `key` , `value`) VALUES ( 'birthday_filter', '');
