<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

if(!in_array($_GET['action'], array('jsongetevents', 'fcsetdate', 'pdfcalendar', 'fceditevent', 'fcdelevent'))) {
	//Request session id
	if(!isset($_GET["sesid"])) exit;
	 
	//Start session
	if(FALSE === session_id($_GET["sesid"])) exit;
}
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');
 
error_reporting(0);
$ko_path = "../../";
require_once($ko_path."inc/ko.inc");
$ko_path = "../";
require_once($BASE_PATH."inc/kota.inc");


// Plugins einlesen:
$hooks = hook_include_main("daten");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include_once($hook);
 
 
//Smarty-Templates-Engine laden
require_once($BASE_PATH."inc/smarty.inc");
 
//Rechte auslesen
list($item_view, $item_new, $item_edit, $item_mod) = ko_get_admin("daten", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
 
require_once($BASE_PATH."daten/inc/daten.inc");

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);
 
 
if(isset($_GET) && isset($_GET["action"])) {
 	$action = format_userinput($_GET["action"], "alphanum");
 	switch($action) {

		case 'pdfcalendar':
			if(!$group_view) continue;

			//No pdf export for day view
			if($_SESSION['cal_view'] == 'agendaDay') {
				print 'daten_pdf_link@@@: not available';
				break;
			}

			//Start pdf
			define('FPDF_FONTPATH',$BASE_PATH.'fpdf/schriften/');
			require_once($BASE_PATH.'fpdf/fpdf.php');
			$pdf = new FPDF('L', 'mm', 'A4');
			$pdf->Open();
			$pdf->SetAutoPageBreak(true, 10);
			$pdf->SetMargins(5, 5, 5);  //left, top, right
			$pdf->AddFont('arial','','arial.php');
			$pdf->AddFont('arialb','','arialb.php');

			//Set months and filename for year and month view
			if($_SESSION['show'] == 'cal_jahr') {
				for($i=1; $i<=12; $i++) {
					$months[] = $i;
				}
				$filename = getLL('daten_filename_pdf').$_SESSION['cal_jahr'].'_'.strftime('%d%m%Y_%H%M%S', time()).'.pdf';
				$add = 4;
			} else if($_SESSION['cal_view'] == 'month') {
				$months[] = $_SESSION['cal_monat'];
				$filename = getLL('daten_filename_pdf').str_to_2($_SESSION['cal_monat']).'_'.$_SESSION['cal_jahr'].'_'.strftime('%d%m%Y_%H%M%S', time()).'.pdf';
				$add = 7;
			}
			else if($_SESSION['cal_view'] == 'agendaWeek') {
				$filename = ko_daten_cal_woche(strftime('%V', mktime(1,1,1, $_SESSION['cal_monat'], $_SESSION['cal_tag'], $_SESSION['cal_jahr'])), $_SESSION['cal_jahr'], 'pdf');
				$file = $ko_path.'download/pdf/'.$filename;
				$filename = substr($filename, 0, 7+strlen(getLL('daten_filename_pdf'))).'.pdf';  //Fr Link-Text Erstellungszeit entfernen
				print 'daten_pdf_link@@@: <a href="'.$file.'">'.$filename.'</a>';
				break;
			} else break;

			$monthly_title = ko_get_setting('daten_monthly_title');
			$show_comment = ko_get_setting("daten_pdf_show_comment");
			$show_time = ko_get_setting("daten_pdf_show_time");
			foreach($months as $month) {
				$month = str_to_2($month);
				$data = array();

				//Get all events
				apply_daten_filter($z_where, $z_limit, 'immer', 'immer');
				$startstamp = mktime(1,1,1, (int)$month, 1, $_SESSION['cal_jahr']);
				$endstamp = mktime(1,1,1, ($month == 12 ? 1 : $month+1), 0, ($month == 12 ? $_SESSION['cal_jahr']+1 : $_SESSION['cal_jahr']));
				$z_where .= ' AND `enddatum` >= \''.strftime('%Y-%m-%d', $startstamp).'\' AND `startdatum` <= \''.strftime('%Y-%m-%d', $endstamp).'\'';
				ko_get_events($events, $z_where);

				//Calendar weeks
				$kw = array();
				$week_inc = 7*24*60*60;
				$stamp = $startstamp;
				while($stamp < $endstamp+$week_inc) {
					$kw[] = str_to_2(strftime('%V', $stamp));
					$stamp += $week_inc;
				}

				foreach($events as $event) {
					$content = array();
					//Set title according to setting
					if($show_comment) {
						$content['text'] = $event['eventgruppen_name'];
						$content['kommentar'] = $event['kommentar'];
					} else {
						if($monthly_title == 'kommentar') {
							$content['text'] = $event['komentar'];
						} else if($monthly_title == 'both') {
							$content['text'] = $event['eventgruppen_name'].($event['kommentar'] ? ': '.$event['kommentar'] : '');
						} else {
							$content['text'] = $event['eventgruppen_name'];
						}
					}

					//color
					$content['farbe'] = $event['eventgruppen_farbe'];

					//Time
					if($show_time) {
						if($event['startzeit'] == '00:00:00' && $event['endzeit'] == '00:00:00') {
							$content['zeit'] = getLL('time_all_day');
						} else {
							if($show_time == 1) {  //Only show start time
								$content['zeit'] = substr($event['startzeit'], 3, 2) == '00' ? substr($event['startzeit'], 0, 2) : substr($event['startzeit'], 0, -3);
							} else if($show_time == 2) {  //Show start and end time
								$content['zeit']  = substr($event['startzeit'], 3, 2) == '00' ? substr($event['startzeit'], 0, 2) : substr($event['startzeit'], 0, -3);
								$content['zeit'] .= '-';
								$content['zeit'] .= substr($event['endzeit'], 3, 2) == '00' ? substr($event['endzeit'], 0, 2) : substr($event['endzeit'], 0, -3);
							}
						}
					} else {
						$content['zeit'] = '';
					}

					//Multiday events
					if($event['startdatum'] != $event['enddatum']) {
						$date = $event['startdatum'];
						while((int)str_replace('-', '', $date) <= (int)str_replace('-', '', $event['enddatum'])) {
							if(substr($date, 5, 2) == $month) {
								$data[(int)substr($date, -2)]['inhalt'][] = $content;
							}
							$date = add2date($date, 'tag', 1, TRUE);
						}
					} else {
						$data[(int)substr($event['startdatum'], -2)]['inhalt'][] = $content;
					}
				}//foreach(events)

				ko_export_cal_one_month($pdf, $month, $_SESSION['cal_jahr'], $kw, $data, getLL('daten_events'), $show_comment);
			}//foreach(months)

			$file = $BASE_PATH.'download/pdf/'.$filename;
			$ret = $pdf->Output($file);
			$filename2 = substr($filename, 0, strlen(getLL('daten_filename_pdf'))+$add).'.pdf';  //Fr Link-Text Erstellungszeit entfernen

			print 'daten_pdf_link@@@: <a href="'.$ko_path.'download/pdf/'.$filename.'">'.$filename2.'</a>';
		break;

 

		case "setsortevent":
			if(!$group_view) continue;

			$_SESSION["sort_events"] = format_userinput($_GET["sort"], "alphanum+", TRUE, 30);
			$_SESSION["sort_events_order"] = format_userinput($_GET["sort_order"], "alpha", TRUE, 4);
			
			$mode = $_SESSION["show"] == "list_events_mod" ? "mod" : "all";

			print "main_content@@@";
			print ko_list_events($mode, FALSE);
		break;



		case "setsorteventgroups":
			if(!$group_edit) continue;

			$_SESSION["sort_tg"] = format_userinput($_GET["sort"], "alphanum+", TRUE, 30);
			$_SESSION["sort_tg_order"] = format_userinput($_GET["sort_order"], "alpha", TRUE, 4);

			print "main_content@@@";
			print ko_list_groups("all", FALSE);
		break;



		case 'fcsetdate':
			if(!$group_view) continue;

			if($_GET['ymd']) {
				list($y, $m, $d) = explode('-', $_GET['ymd']);
				if($d) $_SESSION['cal_tag'] = intval($d);
				if($m) $_SESSION['cal_monat'] = intval($m);
				if($y) $_SESSION['cal_jahr'] = intval($y);
			}
			if($_GET['view']) $_SESSION['cal_view'] = format_userinput($_GET['view'], 'alpha');

			//Redraw mwselect box
			$sel = ko_calendar_mwselect($_SESSION['cal_view']);
			print 'mwselect@@@'.$sel;
		break;



		case "setjahr":
			if(!$group_view) continue;

			$_SESSION["cal_jahr_jahr"] = format_userinput($_GET["set_year"], "uint", TRUE, 4);
			$_SESSION["cal_jahr_start"] = format_userinput($_GET["set_start"], "uint", TRUE, 2);
			$num = (int)ko_get_userpref($_SESSION["ses_userid"], "cal_jahr_num");
			if($num == 0) $num = 6;  //Default

			print "main_content@@@";
			print ko_daten_cal_jahr($num, $_SESSION["cal_jahr_start"], "html", FALSE);
		break;


		case "setstart":
			if(!$group_view) continue;

			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION["show_start"] = format_userinput($_GET["set_start"], "uint"))) {
    	  $_SESSION["show_start"] = 1;
	    }

			print "main_content@@@";
			if($_SESSION["show"] == "all_events") {
				print ko_list_events("all", FALSE);
			} else if($_SESSION["show"] == "all_groups") {
				print ko_list_groups("all", FALSE);
			}
		break;

		case "itemlist":
		case "itemlistgroup":
			if(!$group_view) continue;

			//ID and state of the clicked field
			$id = format_userinput($_GET["id"], "js");
			$state = $_GET["state"] == "true" ? "checked" : "";

			//Single event group selected
			if($action == "itemlist") {
				if($state == "checked") {  //Select it
					if(!in_array($id, $_SESSION["show_tg"])) $_SESSION["show_tg"][] = $id;
				} else {  //deselect it
					if(in_array($id, $_SESSION["show_tg"])) $_SESSION["show_tg"] = array_diff($_SESSION["show_tg"], array($id));
				}
			}
			//Calendar selected or unselected
			else if($action == "itemlistgroup") {
				$groups = db_select_data("ko_eventgruppen", "WHERE `calendar_id` = '$id'", "*", "ORDER BY name ASC");
				foreach($groups as $gid => $group) {
					if($state == "checked") {  //Select it
						if(!in_array($gid, $_SESSION["show_tg"])) $_SESSION["show_tg"][] = $gid;
					} else {  //Deselect it
						if(in_array($gid, $_SESSION["show_tg"])) $_SESSION["show_tg"] = array_diff($_SESSION["show_tg"], array($gid));
					}
				}//foreach(groups)
			}

			//Save userpref
			sort($_SESSION["show_tg"]);
			ko_save_userpref($_SESSION["ses_userid"], "show_daten_tg", implode(",", $_SESSION["show_tg"]));

			//Redraw content for list and year view (month and week are done by fullCalendar)
			if($_SESSION['show'] == 'all_events') {
				print "main_content@@@";
				ko_list_events("all", FALSE);
			} else if($_SESSION['show'] == 'cal_jahr') {
				print "main_content@@@";
				$num = (int)ko_get_userpref($_SESSION["ses_userid"], "cal_jahr_num");
				if($num == 0) $num = 6;
				ko_daten_cal_jahr($num, $_SESSION["cal_jahr_start"], FALSE);
			}

			//Find position of submenu for redraw
			if($action == "itemlistgroup") {
				if(in_array("itemlist_termingruppen", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
				else $pos = "right";
				if(in_array($_SESSION['show'], array('all_events', 'cal_jahr'))) print '@@@';
				print submenu_daten("itemlist_termingruppen", $pos, "open", 2);
			}
		break;


		case "itemlisttogglegroup":
			if(!$group_view) continue;

			//ID and state of the clicked field
			$id = format_userinput($_GET["id"], "js");
			if(isset($_SESSION["daten_calendar_states"][$id])) {
				$_SESSION["daten_calendar_states"][$id] = $_SESSION["daten_calendar_states"][$id] ? 0 : 1;
			} else {
				$_SESSION["daten_calendar_states"][$id] = ($_GET["state"] == 1 ? 0 : 1);
			}
			
			//Don't redraw the submenu, as this is done in JS so the list doesn't scroll of the mouse's position
		break;


		case "itemlistsave":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_termingruppen", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			if($_GET["name"] == "") continue;
			$new_value = implode(",", $_SESSION["show_tg"]);
			$user_id = $group_mod && $_GET['global'] == 'true' ? '-1' : $_SESSION['ses_userid'];
			ko_save_userpref($user_id, format_userinput($_GET["name"], "js", FALSE, 0, array("allquotes")), $new_value, "daten_itemset");

			print submenu_daten("itemlist_termingruppen", $pos, "open", 2);
		break;


		case "itemlistopen":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_termingruppen", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') $value = ko_get_userpref('-1', substr($name, 3), 'daten_itemset');
			else $value = ko_get_userpref($_SESSION['ses_userid'], $name, 'daten_itemset');
			$_SESSION["show_tg"] = explode(",", $value[0]["value"]);
			ko_save_userpref($_SESSION["ses_userid"], "show_daten_tg", $value[0]["value"]);

			print submenu_daten("itemlist_termingruppen", $pos, "open", 2);
			if($_SESSION['show'] == 'all_events') {
				print "@@@main_content@@@";
				ko_list_events("all", FALSE);
			} else if($_SESSION['show'] == 'cal_jahr') {
				print "@@@main_content@@@";
				print ko_daten_cal_jahr($num, $_SESSION["cal_jahr_start"], "html", FALSE);
			}
		break;


		case "itemlistdelete":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_termingruppen", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') {
				if($group_mod) ko_delete_userpref('-1', substr($name, 3), 'daten_itemset');
			} else ko_delete_userpref($_SESSION['ses_userid'], $name, 'daten_itemset');

			print submenu_daten("itemlist_termingruppen", $pos, "open", 2);
		break;



		case "calselect":
			if(!$group_new) continue;

			//GET data
			$id = format_userinput($_GET["cid"], "uint", FALSE, 11, array(), "-");
			$element = format_userinput($_GET["element"], "text");

			$values = array();
			kota_ko_event_eventgruppen_id_dynselect($v, $d, $group_new);
			if($id == "-") {  //Back to index
				foreach($v as $vid => $_v) {
					$suffix = substr($vid, 0, 1) == "i" ? "-->" : "";
					$values[] = $vid.",".$d[$vid].$suffix;
				}
			} else {  //Show event groups for the chosen calendar
				//Add up link
				$values[] = "i-,".str_replace(",", "", getLL("form_peopleselect_up"));
				foreach($v["i".$id] as $gid => $g) {
					$values[] = $gid.",".$d[$gid];
				}
			}
			$value = implode("#", $values);

			print "$element@@@$value";
		break;



		case 'jsongetevents':
			$data = array();
			$monthly_title = ko_get_setting('daten_monthly_title');
			$title_length = ko_get_setting('daten_title_length');

			for($i=0; $i<2; $i++) {
				if($i == 1 && !$group_new) continue;

				//Get all events
				if($i==0) {
					apply_daten_filter($z_where, $z_limit, 'immer', 'immer');
					$z_where .= ' AND `enddatum` >= \''.strftime('%Y-%m-%d', (int)$_GET['start']).'\' AND `startdatum` <= \''.strftime('%Y-%m-%d', (int)$_GET['end']).'\'';
					ko_get_events($events, $z_where, '', 'ko_event', 'ORDER BY startdatum,startzeit,eventgruppen_name ASC');
				} else {
					if($_SESSION['ses_userid'] != ko_get_guest_id()) $mod_where = $group_mod ? '' : ' AND e._user_id = \''.$_SESSION['ses_userid'].'\' ';
					else $mod_where = ' AND 1=2 ';
					ko_get_events_mod($events, $z_where);
				}

				foreach($events as $event) {
					//Only show allowed moderations
					if($i == 1 && (!$group_mod[$event['eventgruppen_id']] && $event['_user_id'] != $_SESSION['ses_userid']) ) continue;

					//Set title according to setting
					switch($monthly_title) {
						case 'kommentar':
							$title = $event['kommentar'] ? $event['kommentar'] : $event['eventgruppen_name'];
						break;
						case 'both':
							$title = $event['eventgruppen_name'].($event['kommentar'] ? ': '.$event['kommentar'] : '');
						break;
						default:
							$title = $event['eventgruppen_name'];
					}
					if(strlen($title) > $title_length) $title = substr($title, 0, $title_length).'..';

					//Format time for tooltip
					if($event['startzeit'] == '00:00:00' && $event['endzeit'] == '00:00:00') $time = getLL('time_all_day');
					else $time = substr($event['startzeit'], 0, -3).' - '.substr($event['endzeit'], 0, -3);

					$comment = $event['kommentar'] ? $event['kommentar'] : '';
					$room = $event['room'] ? $event['room'] : '';

					$tooltip = '';

					//Moderated events
					if($i == 1) {
						if($event['_delete'] == 1 && $event['_event_id'] > 0) $mod_mode = 'delete';
						else if($event['_delete'] == 0 && $event['_event_id'] > 0) $mod_mode = 'edit';
						else $mod_mode = 'new';
						$tooltip .= '<b>'.getLL('daten_mod_open').': '.getLL('daten_mod_list_title_'.$mod_mode).'</b><br />';
						//Add user who entered the moderation request
						if($event['_user_id']) {
							ko_get_login($event['_user_id'], $login);
							if($login['leute_id']) {
								ko_get_person_by_id($login['leute_id'], $person);
								$tooltip .= utf8_encode(getLL('by')).': '.$person['vorname'].' '.$person['nachname'].' ('.$login['login'].')<br />';
							} else {
								$tooltip .= utf8_encode(getLL('by')).': '.$login['login'].'<br />';
							}
						}
						$tooltip .= '<br />';
					}

					//Tooltip-Text
					$tooltip .= $event['eventgruppen_name'].'<br />';
					$tooltip .= '<b>'.strftime($DATETIME['ddmy'], strtotime($event['startdatum']));
					if($event['startdatum'] != $event['enddatum']) $tooltip .= ' - '.strftime($DATETIME['ddmy'], strtotime($event['enddatum']));
					$tooltip .= '</b><br />';
					$tooltip .= getLL('res_time').': '.$time.'<br />';
					$tooltip .= $comment?'<b>'.$comment.'</b><br />':'';
					$tooltip .= $room?getLL('daten_location').': '.$room:'';

					//Add editIcons according to access rights
					if($i == 0) {
						if($item_new[$event['id']]) {
							$deleteIcon = '<input type="image" src="../images/icon_trash.png" onclick="c=confirm(\''.utf8_encode(getLL('daten_delete_event_confirm')).'\');if(!c) return false; sendReq(\'inc/ajax.php\', \'action,id\', \'fcdelevent,'.$event['id'].'\'); $(\'#ko_calendar\').fullCalendar(\'removeEvents\', \''.$event['id'].'\'); tooltip.hide(); return false;" title="'.utf8_encode(getLL('daten_delete_event')).'" />';
							$editIcons = $deleteIcon;
						} else {
							$editIcons = '';
						}
					}
					//Add links to approve or delete a moderation
					else {
						$checkIcon = $group_mod[$event['eventgruppen_id']] ? '<input type="image" src="../images/button_check.png" title="'.utf8_encode(getLL('daten_mod_confirm')).'" onclick="c1=confirm(\''.utf8_encode(getLL('daten_mod_confirm_confirm')).'\');if(!c1) return false; c = confirm(\''.utf8_encode(getLL('daten_mod_confirm_confirm2')).'\');set_hidden_value(\'mod_confirm\', c);set_action(\'daten_mod_'.$mod_mode.'_approve\');set_hidden_value(\'id\', \''.$event['id'].'\')" />' : '';

						$deleteIcon = '<input type="image" src="../images/button_delete.gif" title="'.utf8_encode(getLL('daten_mod_decline')).'" onclick="c1=confirm(\''.utf8_encode(getLL('daten_mod_decline_confirm')).'\');if(!c1) return false;'.($group_mod[$event['eventgruppen_id']] ? 'c = confirm(\''.utf8_encode(getLL('daten_mod_decline_confirm2')).'\');set_hidden_value(\'mod_confirm\', c);' : '').'set_action(\'daten_mod_delete\');set_hidden_value(\'id\', \''.$event['id'].'\');" />';

						$editIcons = $checkIcon.'&nbsp;'.$deleteIcon;
					}

					//Build data array for fullCalendar
					$data[] = array('id' => $event['id'],
						'start' => $event['startdatum'].'T'.$event['startzeit'],
						'end' => $event['enddatum'].'T'.$event['endzeit'],
						'title' => utf8_encode($title),
						'allDay' => $event['startzeit'] == '00:00:00' && $event['endzeit'] == '00:00:00',
						'url' => ($i==0 && $item_new[$event['id']]) ? 'index.php?action=edit_termin&id='.$event['id'] : '',
						'editable' => ($i==0 ? $item_new[$event['id']] : FALSE),
						'className' => 'eg'.$event['eventgruppen_id'].($i==1?' fc-modEvent':''),
						'kOOL_tooltip' => utf8_encode($tooltip),
						'kOOL_editIcons' => $editIcons,
					);
				}
			}

			//Show birthdays as allDay events
			if(ko_get_userpref($_SESSION['ses_userid'], 'show_birthdays') && ko_module_installed('leute')) {
				list($item_view, $item_new, $item_edit, $item_gs) = ko_get_admin('leute', $_SESSION['ses_userid'], $l_v, $l_n, $l_e, $l_m);
				if($item_view) {
					$startmonth = (int)strftime('%m', (int)$_GET['start']);
					$endmonth = (int)strftime('%m', (int)$_GET['end']);
					$curmonth = (int)$_SESSION['cal_monat'];
					$curyear = (int)$_SESSION['cal_jahr'];
					//Get birthdays from db
					$where = 'WHERE DAYOFYEAR(`geburtsdatum`) >= DAYOFYEAR(\''.strftime('%Y-%m-%d', (int)$_GET['start']).'\') AND DAYOFYEAR(`geburtsdatum`) <= DAYOFYEAR(\''.strftime('%Y-%m-%d', (int)$_GET['end']).'\') AND `deleted` = \'0\' AND `hidden` = \'0\'';
					//Allow plugins to add to the query
					$where .= ko_get_birthday_filter();
					$bds = db_select_data('ko_leute', $where, 'id, (YEAR(CURDATE())-YEAR(`geburtsdatum`)) AS `age`, geburtsdatum, vorname, nachname');

					foreach($bds as $bd) {
						$birthdays[strftime('%m%d', strtotime($bd['geburtsdatum']))][] = $bd;
					}
					foreach($birthdays as $day => $birthday) {
						//Calculate correct year for this birthday
						$year = $curyear;
						$thismonth = (int)substr($bd, 0, 2);
						if($thismonth == $startmonth) {
							if($startmonth > $curmonth) $year = $curyear-1;
						} else if($thismonth == $endmonth) {
							if($endmonth < $curmonth) $year = $curyear+1;
						}
						//Create tooltip with all birthdays on this day
						$tooltip = '';
						foreach($birthday as $b) {
							//Only add people the user has view access for
							if($item_view[$b['id']]) $tooltip .= $b['vorname'].' '.$b['nachname'].' ('.$b['age'].')<br />';
						}
						if($tooltip) {
							$tooltip = '<b>'.getLL('fm_birthdays_title').': '.strftime($DATETIME['dM'], mktime(1,1,1, substr($day, 0, 2), substr($day, 2, 2), $year)).'</b><br />'.$tooltip;
							$data[] = array('id' => 'bd'.$day,
								'start' => $year.'-'.substr($day, 0, 2).'-'.substr($day, 2, 2),
								'end' => $year.'-'.substr($day, 0, 2).'-'.substr($day, 2, 2),
								'allDay' => true,
								'title' => '',
								'editable' => FALSE,
								'className' => 'fc-birthday',
								'kOOL_tooltip' => utf8_encode($tooltip),
							);
						}
					}
				}//if(item_view)
			}//if(show_birthdays)

			print json_encode($data);
		break;



		case 'fcdelevent':
			$id = format_userinput($_GET['id'], 'uint');
			if(!$id) continue;
			do_del_termin($id);
		break;



		case 'fceditevent':
			$id = format_userinput($_GET['id'], 'uint');
			$mode = format_userinput($_GET['mode'], 'alpha');
			$dayDelta = format_userinput($_GET['dayDelta'], 'int');
			$minuteDelta = format_userinput($_GET['minuteDelta'], 'int');

			//Check access
			if($item_new[$id]) {
				//Get current event entry
				ko_get_event_by_id($id, $event);
				$new = $event;
				$new_res = array();
				//Get first reservation if any to get the res times
				if($event['reservationen']) {
					$current_res = db_select_data('ko_reservation', 'WHERE `id` IN (\''.implode("','", explode(',', $event['reservationen'])).'\')');
					$first_res = array_shift($current_res);
				}

				//Adjust start and end date
				if($dayDelta != 0) {
					if($mode == 'drop') $new['startdatum'] = add2date($event['startdatum'], 'tag', $dayDelta, TRUE);
					$new['enddatum'] = add2date($event['enddatum'], 'tag', $dayDelta, TRUE);
					if($event['reservationen']) {
						$new_res['startdatum'] = $new['startdatum'];
						$new_res['enddatum'] = $new['enddatum'];
					}
				}
				//Adjust start and end time
				if($minuteDelta != 0) {
					if($mode == 'drop') {  //Drop changes start and end time
						$new['startzeit'] = add2time($event['startzeit'], $minuteDelta);
						//Adjust reservation time with the same delta
						if($event['reservationen']) $new_res['startzeit'] = add2time($first_res['startzeit'], $minuteDelta);
					}
					//Add 2h to events dropped from allDay to an hour, so start and end won't be the same after dropping
					$add = $event['startzeit'] == '00:00:00' && $event['endzeit'] == '00:00:00' ? 120 : 0;
					//Resize only changes end time
					$new['endzeit'] = add2time($event['endzeit'], $minuteDelta+$add);
					//Adjust reservation time with the same delta
					if($event['reservationen']) $new_res['endzeit'] = add2time($first_res['endzeit'], $minuteDelta+$add);
				}

				//Check for drop on allDay (minuteDelta and dayDelta 0)
				if($minuteDelta == 0 && $dayDelta == 0) {
					$new['startzeit'] = $new['endzeit'] = $new_res['startzeit'] = $new_res['endzeit'] = '00:00';
				}

				//Update event
				db_update_data('ko_event', 'WHERE `id` = \''.$id.'\'', $new);

				//Update res
				if($event['reservationen'] && sizeof($new_res) > 0) {
					//TODO: Overlapping check is not done! (ko_res_check_double())
					db_update_data('ko_reservation', 'WHERE `id` IN (\''.implode("','", explode(',', $event['reservationen'])).'\')', $new_res);
				}

				//Send notification
				ko_daten_send_notification($data, 'update', $event);

				//Log-Meldung erstellen
				ko_log_diff("edit_termin", array_merge(array("name" => $eventgroup["name"]), $data));

				print TRUE;
			} else {
				print FALSE;
			}
		break;


	}//switch(action);
}//if(GET[action])
?>
