<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Session-ID verlangen
if(!isset($_GET["sesid"])) exit;
 
//Session laden
if(FALSE === session_id($_GET["sesid"])) exit;
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');
 
error_reporting(0);
$ko_path = "../../";
require_once($ko_path."inc/ko.inc");
$ko_path = "../";
require_once($BASE_PATH."inc/kota.inc");


// Plugins einlesen:
$hooks = hook_include_main("dp");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include_once($hook);
 
 
//Smarty-Templates-Engine laden
require_once($BASE_PATH."inc/smarty.inc");
 
//Rechte auslesen
ko_get_admin("dp", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
 
require_once($BASE_PATH."dp/inc/dp.inc");

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);

 
if(isset($_GET) && isset($_GET["action"])) {
 	$action = format_userinput($_GET["action"], "alphanum");
 	switch($action) {
 
 		case "setstart":
 			if(!$group_view) continue;
			//Start fr Listenansicht setzen
			if(FALSE === ($_SESSION["show_start"] = format_userinput($_GET["set_start"], "uint"))) {
    	  $_SESSION["show_start"] = 1;
	    }

			print "main_content@@@";
			print ko_list_dienste(FALSE);
		break;


		//Change the status of a month in the monat-submenu with the open- or close-icons
		case "setmonthstatus":
			if(!$group_mod) continue;

			if($_GET["status"] == "open") {
				$new_status = 1;
			} else if($_GET["status"] == "closed") {
				$new_status = 2;
			} else continue;

			$id = str_to_2($_SESSION["show_monat"])."-".$_SESSION["show_jahr"];
			$sort = $_SESSION["show_jahr"].str_to_2($_SESSION["show_monat"]);
		
			if(ko_dp_get_monat_status($id) == 0) {  //Monat noch nie erffnet
				db_insert_data("ko_dp_monat", array("id" => $id, "status" => $new_status, "sort" => $sort));
			} else {
				db_update_data("ko_dp_monat", "WHERE `id` = '$id'", array("status" => $new_status));
			}
			//Refresh the views
			if($_SESSION["show"] == "show_dienst") {
				print "main_content@@@";
				ko_show_dp($_SESSION["show_dienste"], FALSE);
				print "@@@";
			} else if($_SESSION["show"] == "create_dp") {
				print "main_content@@@";
				ko_dp_show_create_dp(FALSE);
				print "@@@";
			} else if($_SESSION["show"] == "list_dienste") {
				print "main_content@@@";
				ko_list_dienste(FALSE);
				print "@@@";
			}
			print submenu_dp("monat", $pos, "open", 2);
		break;


		//Select a month to be displayed from the monat-submenu
		case "setmonthyear":
			if(!$group_view) continue;

			$id = format_userinput($_GET["monthyear"], "int", TRUE, 7);
			if(!$id) continue;

			$temp = explode("-", $id);
			$m = (int)$temp[0];
			$y = (int)$temp[1];
			if($m && $y && sizeof($temp) == 2 && ($group_mod || ko_dp_get_monat_status($id) != 0)) {
				$_SESSION["show_monat"] = $m;
				$_SESSION["show_jahr"] = $y;
			} else continue;

			//Refresh the views
			if($_SESSION["show"] == "show_dienst") {
				print "main_content@@@";
				ko_show_dp($_SESSION["show_dienste"], FALSE);
				print "@@@";
			} else if($_SESSION["show"] == "create_dp") {
				print "main_content@@@";
				ko_dp_show_create_dp(FALSE);
				print "@@@";
			} else if($_SESSION["show"] == "list_dienste") {
				print "main_content@@@";
				ko_list_dienste(FALSE);
				print "@@@";
			}
			print submenu_dp("monat", $pos, "open", 2);
		break;


		case "itemlist":
			if(!$group_view) continue;

			//ID and state of the clicked field
			$id = format_userinput($_GET["id"], "js");
			$state = $_GET["state"] == "true" ? "checked" : "";

			if($state == "checked") {  //Select it
				if(!in_array($id, $_SESSION["show_dienste"])) $_SESSION["show_dienste"][] = $id;
				//Move it to the place according to the list-order
				ko_get_dienste($dienste);
				foreach($dienste as $i_i => $i) {
					if(!$group_view[$i_i]) continue;
					if(in_array($i_i, $_SESSION["show_dienste"])) $new_value[] = $i_i;
				}
				$_SESSION["show_dienste"] = $new_value;
			} else {  //deselect it
				if(in_array($id, $_SESSION["show_dienste"])) $_SESSION["show_dienste"] = array_diff($_SESSION["show_dienste"], array($id));
			}
			//Save userpref
			ko_save_userpref($_SESSION["ses_userid"], "show_dp_dienste", implode(",", $_SESSION["show_dienste"]));

			print "main_content@@@";
			switch($_SESSION["show"]) {
				case "list_dienste":
					ko_list_dienste(FALSE);
				break;
				case "create_dp":
					ko_dp_show_create_dp(FALSE);
				break;
				case "show_dienst":
					ko_show_dp($_SESSION["show_dienste"], FALSE);
				break;
			}
		break;


		case "itemlistsave":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_dienste", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			if($_GET["name"] == "") continue;
			$new_value = implode(",", $_SESSION["show_dienste"]);
			$user_id = ($group_mod && $_GET['global'] == 'true') ? '-1' : $_SESSION['ses_userid'];
			ko_save_userpref($user_id, format_userinput($_GET["name"], "js", FALSE, 0, array("allquotes")), $new_value, "dp_itemset");

			print submenu_dp("itemlist_dienste", $pos, "open", 2);
		break;


		case "itemlistopen":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_dienste", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') $value = ko_get_userpref('-1', substr($name, 3), "dp_itemset");
			else $value = ko_get_userpref($_SESSION['ses_userid'], $name, "dp_itemset");
			$_SESSION["show_dienste"] = explode(",", $value[0]["value"]);
			ko_save_userpref($_SESSION["ses_userid"], "show_dp_dienste", $value[0]["value"]);

			print "main_content@@@";
			switch($_SESSION["show"]) {
				case "list_dienste":
					ko_list_dienste(FALSE);
				break;
				case "create_dp":
					ko_dp_show_create_dp(FALSE);
				break;
				case "show_dienst":
					ko_show_dp($_SESSION["show_dienste"], FALSE);
				break;
			}
			print "@@@";
			print submenu_dp("itemlist_dienste", $pos, "open", 2);
		break;


		case "itemlistdelete":
			if(!$group_view) continue;

			//Find position of submenu for redraw
			if(in_array("itemlist_dienste", explode(",", $_SESSION["submenu_left"]))) $pos = "left";
			else $pos = "right";

			//save new value
			$name = format_userinput($_GET['name'], 'js', FALSE, 0, array(), '@');
			if($name == "") continue;

			if(substr($name, 0, 3) == '@G@') {
				if($group_mod) ko_delete_userpref('-1', substr($name, 3), "dp_itemset");
			} else ko_delete_userpref($_SESSION['ses_userid'], $name, "dp_itemset");

			print submenu_dp("itemlist_dienste", $pos, "open", 2);
		break;

	}//switch(action);
}//if(GET[action])
?>
