<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

ob_start();  //Ausgabe-Pufferung starten

$ko_path = "../";
$ko_menu_akt = "dp";

include_once($ko_path . "inc/ko.inc");
include_once("inc/dp.inc");
include_once($ko_path."inc/mime_mail.inc");

if(!ko_module_installed("dp")) {
	header("Location: ".$BASE_URL."index.php");  //Absolute URL
}

ob_end_flush();  //Puffer flushen

$onload_code = "";
$error = $info = 0;

//*** Rechte auslesen
ko_get_admin("dp", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);


//Smarty-Templates-Engine laden
require_once("$ko_path/inc/smarty.inc");

//kOOL Table Array
include_once($ko_path . "inc/kota.inc");


//*** Plugins einlesen:
$hooks = hook_include_main("dp");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include_once($hook);


//*** Action auslesen:
if($_POST["action"]) {
	$do_action=$_POST["action"];
	$action_mode = "POST";
} else if($_GET["action"]) {
	$do_action=$_GET["action"];
	$action_mode = "GET";
} else {
	$do_action = $action_mode = "";
}

switch($do_action) {

	// Anzeige
	case "show_dp":
		if(!$group_view) continue;

		//Set month and year if set
		$id = format_userinput($_GET["date"], "int", FALSE, 10);
		if($id) {
			$temp = explode("-", $id);
			$y = (int)$temp[0];
			$m = (int)$temp[1];
			$d = (int)$temp[2];
			if($m && $y && sizeof($temp) >= 2 && ($group_mod || ko_dp_get_monat_status("$m-$y") != 0)) {
				$_SESSION["show_monat"] = $m;
				$_SESSION["show_jahr"] = $y;
			}
		}

		$_SESSION["show"] = "show_dienst";
	break;

	case "list_dienste":
		if(!$group_new) continue;
		$_SESSION["show"] = "list_dienste";
		$_SESSION["show_start"] = 1;
	break;

	case "list_superdienste":
		if(!$group_mod) continue;
		$_SESSION["show"] = "list_superdienste";
		$_SESSION["show_start"] = 1;
	break;

	case "dp_settings_div":
		if(!$group_mod) continue;
		$_SESSION["show"] = "dp_settings_div";
	break;



	//Erfassen
	case "submit_erfassen":
		if(!$_SESSION["show_dienste"] || sizeof($_SESSION["show_dienste"]) == 0) continue;
		if(!$group_new) continue;
		$log_message = "";

	  ko_get_dp_events($events, $_SESSION["show_monat"], $_SESSION["show_jahr"]);

		//Dienste, bei denen ein freies Textfeld erlaubt ist
		$freetext_dienste = explode(",", ko_get_setting("dp_freetext_dienste"));

		foreach($events as $e_i => $e) {

			foreach($_SESSION["show_dienste"] as $d) {
				$save_string = "";
				$save = FALSE;

				//Nur die Dienste speichern, die angezeigt und editierbar waren
				ko_get_dienste($ad, $d);
				$tgs = explode(",", $ad[$d]["tg"]);
				if($group_new[$d] && in_array($e["eventgruppen_id"], $tgs)) {
					$save = TRUE;  //Nur Dienste speichern, die bearbeitet werden knnen und sollen

					$spalten = (int)$ad[$d]["maxleute"];
					for($s=1; $s<=$spalten; $s++) {
						if(format_userinput($_POST["sel_".$e["id"]."_".$d."_".$s], "uint")) {
							$save_string .= format_userinput($_POST["sel_".$e["id"]."_".$d."_".$s], "uint").",";
						}
					}//for(s=1..spalten)
					//Freie Text-Einteilung speichern
					if($_POST["txt_".$e["id"]."_".$d] && $group_new[$d] && in_array($d, $freetext_dienste)) {
						$save_string .= format_userinput($_POST["txt_".$e["id"]."_".$d], "text").",";
					}

				}//if(group_new || in_array(eventgruppen_id, tgs))

				if($save) {
					if($save_string) $save_string = substr($save_string, 0, -1);
					if($save_string) $log_message .= "d($d), e(".$e["id"]."): $save_string; ";
					ko_dp_save_einteilung($d, $e["id"], $save_string);
				}
			}//foreach(show_dienste)

		}//foreach(events)

		ko_log("dp_erfassen", $_SESSION["show_monat"].".".$_SESSION["show_jahr"].": ".substr($log_message, 0, -2));

		$info = 1;
	break;



	//Vorlagen
	case "dp_save_template":
		if(!$_SESSION["show_dienste"] || sizeof($_SESSION["show_dienste"]) == 0) continue;
		$id = format_userinput($_POST["id"], "uint", FALSE, 0, array(), "_");
		if(!$group_new || !$id) continue;

		$temp = explode("_", $id);
		if(sizeof($temp) != 2) continue;
		$tg_id = $temp[0];
		$template_id = $temp[1];
		$event_id = format_userinput($_POST["event_id"], "uint");
		
		$save_string = "";


		foreach($_SESSION["show_dienste"] as $d) {
			$save = FALSE;

			//Nur die Dienste speichern, die angezeigt und editierbar waren
			ko_get_dienste($ad, $d);
			$tgs = explode(",", $ad[$d]["tg"]);
			if($group_new[$d] && in_array($tg_id, $tgs)) {
				$save = TRUE;  //Nur Dienste speichern, die bearbeitet werden knnen und sollen

				ko_get_einteilung($leute, $d, $event_id);
				$save_string .= $d.":".implode(",", $leute).";";

			}//if(group_new || in_array(eventgruppen_id, tgs))

		}//foreach(show_dienste)
		if($save_string) {
			$save_string = substr($save_string, 0, -1);
			ko_save_userpref($_SESSION["ses_userid"], $template_id, $save_string, "dp_template_".$tg_id);
		}
	break;


	case "dp_save_global_template":
		if(!$_SESSION["show_dienste"] || sizeof($_SESSION["show_dienste"]) == 0) continue;
		$id = format_userinput($_POST["id"], "uint", FALSE, 0, array(), "_");
		if(!$group_new || !$id) continue;

		$temp = explode("_", $id);
		if(sizeof($temp) != 2) return false;
		$tg_id = $temp[0];
		$template_id = $temp[1];
		$event_id = format_userinput($_POST["event_id"], "uint");
		
		$save_string = "";


		foreach($_SESSION["show_dienste"] as $d) {
			$save = FALSE;

			//Nur die Dienste speichern, die angezeigt und editierbar waren
			ko_get_dienste($ad, $d);
			$tgs = explode(",", $ad[$d]["tg"]);
			if($group_new[$d] && in_array($tg_id, $tgs)) {
				$save = TRUE;  //Nur Dienste speichern, die bearbeitet werden knnen und sollen

				ko_get_einteilung($leute, $d, $event_id);
				$save_string .= $d.":".implode(",", $leute).";";

			}//if(group_new || in_array(eventgruppen_id, tgs))

		}//foreach(show_dienste)
		if($save_string) {
			$save_string = substr($save_string, 0, -1);
			ko_save_userpref($_SESSION["ses_userid"], "global", $save_string, "dp_template");
		}
	break;

	
	case "dp_open_template":
		if(!$_SESSION["show_dienste"] || sizeof($_SESSION["show_dienste"]) == 0) continue;
		$id = format_userinput($_POST["id"], "uint", FALSE, 0, array(), "_");
		if(!$group_new || !$id) continue;

		$temp = explode("_", $id);
		if(sizeof($temp) != 2) return false;
		$tg_id = $temp[0];
		$template_id = $temp[1];
		$event_id = format_userinput($_POST["event_id"], "uint");

		$value_ = ko_get_userpref($_SESSION["ses_userid"], $template_id, "dp_template_".$tg_id);
		$value = $value_[0]["value"];
		$dienste = explode(";", $value);
		foreach($dienste as $ad) {
			$dienst = explode(":", $ad);
			$d_id = $dienst[0];
			$leute = $dienst[1];
			
			ko_dp_save_einteilung($d_id, $event_id, $leute);
		}//foreach(dienste as ad)
		
		$info = 8;
	break;


	case "dp_open_global_template":
		if(!$_SESSION["show_dienste"] || sizeof($_SESSION["show_dienste"]) == 0) continue;
		$id = format_userinput($_POST["id"], "uint", FALSE, 0, array(), "_");
		if(!$group_new || !$id) continue;

		$temp = explode("_", $id);
		if(sizeof($temp) != 2) return false;
		$tg_id = $temp[0];
		$template_id = $temp[1];
		$event_id = format_userinput($_POST["event_id"], "uint");

		$value_ = ko_get_userpref($_SESSION["ses_userid"], "global", "dp_template");
		$value = $value_[0]["value"];
		$dienste = explode(";", $value);
		foreach($dienste as $ad) {
			$dienst = explode(":", $ad);
			$d_id = $dienst[0];
			$leute = $dienst[1];
			
			ko_dp_save_einteilung($d_id, $event_id, $leute);
		}//foreach(dienste as ad)
		
		$info = 8;
	break;




	//Neu:
	case "new_dienst":
		if(!$group_mod) continue;

		$_SESSION["show"] = "new_dienst";
		$onload_code = "form_set_first_input();".$onload_code;
	break;

	case "submit_new_dienst":
		if(!$group_mod) continue;

		$new_id = kota_submit_multiedit($error, "", "new_dienst");
		if(!$error) {
			ko_dp_create_dienstfilter();
			$info = 2;
			$_SESSION["show"] = "list_dienste";

			while(strlen($new_id) < 4) $new_id = "0".$new_id;
			$_SESSION["show_dienste"][] = $new_id;
		}
	break;



	case "new_superdienst":
		if(!$group_mod) continue;

		$_SESSION["show"] = "new_superdienst";
		$onload_code = "form_set_first_input();".$onload_code;
	break;


	case "submit_new_superdienst":
	case "submit_edit_superdienst":
		if(!$group_mod) continue;

		$mode = $do_action == "submit_edit_superdienst" ? "edit" : "new";

		list($table, $cols, $id, $hash) = explode("@", $_POST["id"]);
		if($mode == "edit" && !$id) {
			$error = 2;
		} else {
			$diensteliste = format_userinput($_POST["koi"]["ko_dp_superdienste"]["dienste"][$id], "intlist");
			$dienste = explode(",", $diensteliste);

			//Bestehende Dienste auslesen
			ko_get_dienste($alle_dienste);
			$alle_dienste_ids = array();
			foreach($alle_dienste as $d) $alle_dienste_ids[] = $d["id"];

			foreach($dienste as $i => $dienst) {
				if(trim($dienst) == "" || !in_array($dienst, $alle_dienste_ids)) {  //Nur bestehende Dienst erlauben
					unset($dienste[$i]);
				}
			}

			//Auf berlappende TGs testen
			$tgs = array();
			$error = 0;
			foreach($dienste as $d) {
				if($alle_dienste[$d]["tg"] != "") {  //Dienste ohne TGs ignorieren
					$tgs_ = explode(",", $alle_dienste[$d]["tg"]);
					foreach($tgs_ as $tg) if(in_array($tg, $tgs)) $error = 3;
					$tgs = array_merge($tgs, explode(",", $alle_dienste[$d]["tg"]));
				}
			}

			if(!$error) {
				kota_submit_multiedit($error, "", ($mode == "edit" ? "edit_superdienst" : "new_superdienst"));

				$info = 10;
				$_SESSION["show"] = "list_superdienste";
			}//if(!error)
			else {
				$_SESSION["show"] = $mode == "edit" ? "list_superdienste" : "new_superdienst";
			}
		}
	break;




	//Bearbeiten
	case "edit_dienst":
		if(!$group_edit) continue;

		$_SESSION["show"] = "edit_dienst";
		$onload_code = "form_set_first_input();".$onload_code;
	break;

	case "submit_edit_dienst":
		if(!$group_edit) continue;

		kota_submit_multiedit($error, "", "edit_dienst");
		if(!$error) {
			ko_dp_create_dienstfilter();
			$info = 3;
			$_SESSION["show"] = "list_dienste";
		}
	break;



	case "edit_superdienst":
		if(!$group_mod) continue;

		$_SESSION["show"] = "edit_superdienst";
		$onload_code = "form_set_first_input();".$onload_code;
	break;





	//Multiedit
	case "multiedit":
		if(!$group_edit) continue;

		//Zu bearbeitende Spalten
		$columns = explode(",", format_userinput($_POST["id"], "alphanumlist"));
		foreach($columns as $column) {
			$do_columns[] = $column;
		}
		if(sizeof($do_columns) < 1) $error = 4;

		//Zu bearbeitende Eintrge
		$do_ids = array();
		foreach($_POST["chk"] as $c_i => $c) {
			if($c) {
				if(FALSE === ($edit_id = format_userinput($c_i, "uint", TRUE))) {
					trigger_error("Not allowed multiedit_id: ".$c_i, E_USER_ERROR);
				}
				if($group_edit[$edit_id]) $do_ids[] = $edit_id;
			}
		}
		if(sizeof($do_ids) < 1) $error = 4;

		//Daten fr Formular-Aufruf vorbereiten
		if(!$error) {
			$order = "ORDER BY name ASC";
			$_SESSION["show_back"] = $_SESSION["show"];
			$_SESSION["show"] = "multiedit";
		}
		$onload_code = "form_set_first_input();".$onload_code;
	break;



	case "submit_multiedit":
		if(!$group_edit) continue;
		kota_submit_multiedit($error, $item_edit);

		if(!$error) $info = 8;
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "list_dienste";
	break;





	//Lschen
	case "delete_dienst":
		if(!$group_mod) continue;

		$id = format_userinput($_POST["id"], "uint");
		if(!$id) continue;

		ko_get_dienste($dd_, $id);
		$dd = $dd_[$id];
		$log_verantwortlich = "";
		$vv = explode(",", $dd["verantwortlich"]);
		foreach($vv as $v) {
			ko_get_person_by_id($v, $ap);
			$log_verantwortlich .= $ap["vorname"] . " " . $ap["nachname"] . " ($v), ";
		}
		$log_verantwortlich = substr($log_verantwortlich, 0, -2);
		$log_message = $dd["name"] . " (" . $dd["id"] . "): TGs: ".$dd["tg"].", Verantwortlich: $log_verantwortlich, MaxLeute: ".$dd["maxleute"];

		db_delete_data("ko_dp_dienste", "WHERE `id` = '$id'");
		$info = 4;

		ko_log("del_dienst", $log_message);

		//Alle Diensteinteilungen in ko_dp_einteilung zu diesem Dienst lschen
		db_delete_data("ko_dp_einteilung", "WHERE `dienst` = '$id'");

		//Alle zugewiesenen Leute aus diesem Dienst entfernen
		ko_get_leute_by_dienst($d_leute, $id);
		foreach($d_leute as $p) {
			ko_dp_remove_person_from_dienst($p, $id, "dienst");
		}

		//Alle zugewiesenen Leiter dieses Dienstes entfernen
		ko_get_leiter_by_dienst($d_leiter, $id);
		foreach($d_leiter as $p) {
			ko_dp_remove_person_from_dienst($p, $id, "dienstleiter");
		}

		//Dienste aus Dienstgruppe lschen, falls er in einem vorkommt
		ko_get_superdienste($sd);
		foreach($sd as $d) {
			$sd_dienste = explode(",", $d["dienste"]);
			$new_sd_dienste = array(); $different = FALSE;
			foreach($sd_dienste as $s) {
				if($s != $id) $new_sd_dienste[] = $s;
				else $different = TRUE;
			}
			if($different) {
				db_update_data("ko_dp_superdienste", "WHERE `id` = '".$d["id"]."'", array("dienste" => implode(",", $new_sd_dienste)));
			}
		}//foreach(sd as s)
				
		
		//Filter-Select-Code anpassen
		ko_dp_create_dienstfilter();
	break;


	case "delete_superdienst":
		if(!$group_mod) continue;

		$id = format_userinput($_POST["id"], "uint");
		if(!$id) continue;

		ko_get_superdienste($sd, $id);
		if(!$sd[$id]["name"]) continue;

		db_delete_data("ko_dp_superdienste", "WHERE `id` = '$id'");

		$log_message = $sd["name"]." (".$sd["id"]."): ".$sd["dienste"];
		ko_log("del_superdienst", $log_message);
		$info = 9;
	break;




	//DP erstellen
	case "create_dp":
	case "save_create_dp":
		if(!$group_mod) continue;

		//Angaben speichern, falls gewnscht
		if($do_action == "save_create_dp") {
			ko_set_setting("dp_titel", format_userinput($_POST["txt_titel"], "text"));
			ko_set_setting("dp_fontsize", format_userinput($_POST["sel_fontsize"], "uint"));
			ko_set_setting("dp_namenformat", format_userinput($_POST["sel_namen"], "uint"));
			ko_set_setting("dp_dienste", format_userinput($_POST["rd_dienste"], "uint"));
			ko_set_setting("dp_mark_empty", format_userinput($_POST["rd_mark_empty"], "uint"));
		}

		$_SESSION["show"] = "create_dp";
	break;


	case "do_create_dp":
	case "do_create_dp_neutral":
	case "do_create_dp_fm":
		if(!$group_mod) continue;

		$p_id = ($do_action == "do_create_dp" && format_userinput($_POST["sel_dp_person"], "uint")) ? format_userinput($_POST["sel_dp_person"], "uint") : 0;

		if((int)ko_get_setting("dp_dienste") == 2) {  //Nur ausgewhlte Dienste verwenden
			$dienste = array();
			ko_get_dienste($alle_dienste);
			foreach($alle_dienste as $d) {
				if(in_array($d["id"], $_SESSION["show_dienste"])) {
					$dienste[$d["id"]] = $d;
				}
			}
		} else {  //Alle Dienste verwenden
			ko_get_dienste($dienste);
		}
		if($do_action == "do_create_dp_fm") {
			$id = explode("-", $_POST["id"]);
			if(FALSE !== ($monat = format_userinput($id[0], "uint", TRUE, 2)) && FALSE !== ($jahr = format_userinput($id[1], "uint", TRUE, 4))) {
				$pdf_filename = ko_dp_create_pdf($monat, $jahr, $dienste, 0);
				//File speichern
				$file = "dp_$monat-$jahr.pdf";
				rename($pdf_filename, $ko_path."download/dp/".$file);
			} else {
				trigger_error("Not allowed id: ".$_POST["id"], E_USER_ERROR);
				exit;
			}
		} else {
			$pdf_filename = ko_dp_create_pdf($_SESSION["show_monat"], $_SESSION["show_jahr"], $dienste, $p_id);

			//Fileshare-Datei speichern, falls gewnscht
			if(ko_module_installed("fileshare", $_SESSION["ses_userid"]) && ko_get_userpref($_SESSION["ses_userid"], "save_files_as_share") == 1) {
				ko_fileshare_save_file_as_share($_SESSION["ses_userid"], $pdf_filename);
			}

			$pdf_filename = substr($pdf_filename, 1);
			$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=$pdf_filename', 400, 300);";
		}
	break;


	case "do_send_dp":
		if(!$group_mod) continue;

		//Endlose Ausfhrung
		set_time_limit(0);

		//Gewnschte Dienste auslesen
		if((int)ko_get_setting("dp_dienste") == 1) {  //Alle verwenden
			ko_get_dienste($dienste);
		} else if((int)ko_get_setting("dp_dienste") == 2) {  //Nur ausgewhlte verwenden
			$dienste = array();
			ko_get_dienste($alle_dienste);
			foreach($alle_dienste as $d) {
				if(in_array($d["id"], $_SESSION["show_dienste"])) {
					$dienste[$d["id"]] = $d;
				}
			}
		} else {
			continue;
		}

		//Gewnschte Dienste fr den Versand auslesen
		if((int)$_POST["rd_rec_dienste"] == 1) {  //Alle verwenden
			ko_get_dienste($rec_dienste);
		} else if($_POST["rd_rec_dienste"] == 2) {  //Nur ausgewhlte verwenden
			$rec_dienste = array();
			ko_get_dienste($alle_dienste);
			foreach($alle_dienste as $d) {
				if(in_array($d["id"], $_SESSION["show_dienste"])) {
					$rec_dienste[$d["id"]] = $d;
				}
			}
		} else {
			continue;
		}
		$betreff = $_POST["txt_betreff"];
		$mailtext = $_POST["txt_mailtext"];

		//Titeldaten fr XLS-Datei
		$cols = array("anrede", "vorname", "nachname", "adresse", "adresse_zusatz", "plz", "ort", "land", "telp", "telg");
    $leute_col_name = ko_get_leute_col_name();
    $header = array();
    foreach($cols as $c) {
	    $header[] = $leute_col_name[$c];
	  }

		$row = 0;
		$ohne_email = $my_list = "";
		$dp_sent = array();  //Alle Leute, an die der DP gesendet wurde (vermeiden von Doppelsendungen)
		foreach($rec_dienste as $d_) {  //Nur durch die Empfnger-Dienste durchgehen
			$d = $d_["id"];
			ko_get_leute_by_dienst($leute, $d);
			foreach($leute as $l) {
				ko_get_person_by_id($l, $p);
				if(in_array($l, $dp_sent)) continue;
				else $dp_sent[] = $l;

				if(!ko_get_leute_email($p, $email)) {
					$ohne_email .= $p["vorname"]." ".$p["nachname"]." ".getLL("from")." ".$p["ort"].", ";
					$my_list .= $p["id"].",";
					$col = 0;
					foreach($cols as $c) {
						$data[$row][$col++] = sql2datum($p[strtolower($leute_col_name[$c])]);
					}
					$row++;
				}//if(!ko_get_leute_email())
				else {
					$filename = ko_dp_create_pdf($_SESSION["show_monat"], $_SESSION["show_jahr"], $dienste, $p["id"]);
					if(defined('DEBUG_EMAIL') && DEBUG_EMAIL) {
						print '<h2>Email sent</h2>';
						print 'From: '.ko_get_setting('info_email').'<br />';
						print '<b>To: '.ko_html($email).'</b><br />';
						print '<b>Subject: '.ko_html($betreff).'</b><br />';
						print '<hr>'.nl2br($mailtext).'<hr>';
						print 'Attachment: <a href="'.$filename.'">'.$filename.'</a><br />';
					} else {
						$fp = fopen($filename, "r");
						$attachment = fread($fp, filesize($filename));
						fclose($fp);
						$mail_dp = new mime_mail();
						$mail_dp->from = "kOOL <".ko_get_setting("info_email").">";
						if(defined('EMAIL_SET_RETURN_PATH') && EMAIL_SET_RETURN_PATH == TRUE) $mail_dp->headers = 'Return-Path: <'.ko_get_setting('info_email').'>';
						$mail_dp->to = $email;
						$mail_dp->subject = $betreff;
						$mail_dp->body = $mailtext;
						$mail_dp->add_attachment("$attachment", "dienstplan_".$_SESSION["show_jahr"]."-".$_SESSION["show_monat"].".pdf", "application/pdf");
						$ok = $mail_dp->send();
						unset($mail_dp);
					}

					$log_sent .= "$email ($l), ";
				}
			}//foreach(leute as l)
		}//foreach(send as d)

		if($ohne_email != "") {
			$ohne_email = substr($ohne_email, 0, -2);
			$my_list = substr($my_list, 0, -1);
      $dateiname = $ko_path."download/excel/".getLL("dp_filename_no_email").strftime("%d%m%Y_%H%M%S", time()) . ".xls";
      ko_export_to_excel($header, $data, $dateiname, getLL("dp_no_email"));
			$send_info  = getLL("dp_no_email_title")."<br />$ohne_email";
			$send_info .= '<br /><a href="'.$dateiname.'">'.getLL("dp_excel_file").'</a>&nbsp;&nbsp;';
			$send_info .= '<input type="image" src="'.$ko_path.'images/icon_export_my_list.png" onclick="set_action('."'export_to_mylist'".');set_hidden_value('."'id', '".$my_list."'".');this.submit;" title="'.getLL("dp_export_to_mylist").'" /> &nbsp;&nbsp;';
			$send_info .= '<input type="image" src="'.$ko_path.'images/icon_exportadd_my_list.png" onclick="set_action('."'exportadd_to_mylist'".');set_hidden_value('."'id', '".$my_list."'".');this.submit;" title="'.getLL("dp_export_add_to_mylist").'" />';
			$send_info .= '<br /><br />';

			//Fileshare-Datei speichern, falls gewnscht
			if(ko_module_installed("fileshare", $_SESSION["ses_userid"]) && ko_get_userpref($_SESSION["ses_userid"], "save_files_as_share") == 1) {
				ko_fileshare_save_file_as_share($_SESSION["ses_userid"], $dateiname);
			}
    }

		ko_log("dp_send", "Subject: ".format_userinput($betreff, "text").", Recipients: ".substr($log_sent,0,-2).", No email: $ohne_email");

		$info = 6;
	break;



	case "export_to_mylist":
	case "exportadd_to_mylist":
		if($_POST["id"]) {
			if($do_action == "export_to_mylist") $_SESSION["my_list"] = array();
      foreach(explode(",", format_userinput($_POST["id"], "intlist")) as $c) {
	      if($c) $_SESSION["my_list"][$c] = $c;
      }
			ko_save_userpref($_SESSION["ses_userid"], "leute_my_list", serialize($_SESSION["my_list"]));
    }
	break;




	//Excel-Export
	case "do_excel":
		if(!$group_view) continue;

		$header = array();
		$header[] = "Dienstplan\n".$_SESSION["show_monat"]."-".$_SESSION["show_jahr"];
		ko_get_dp_events($events, $_SESSION["show_monat"], $_SESSION["show_jahr"]);
		foreach($events as $e_i => $e) {
			//Titelzeile
			ko_get_eventgruppe_by_id($e["eventgruppen_id"], $grp);
			if(defined("DP_HEADER_FORMAT")) {
				$e_titel = strtr(DP_HEADER_FORMAT, array("DATE" => sql2datum($e["startdatum"]), "TIME" => substr($e["startzeit"], 0, -3), "OCLOCK" => getLL("time_oclock"), "EG_NAME" => $grp["name"], "ROOM" => $e["room"]));
			} else {
				$e_titel  = sql2datum($e["startdatum"])."\n";
				$e_titel .= $grp["name"]."\n";
				$e_titel .= substr($e["startzeit"], 0, -3)." ".getLL("time_oclock");
			}
	    $header[] = $e_titel;
		}

		//Angezeigte Dienste auslesen
		$ad = $_SESSION["show_dienste"];
		if(sizeof($ad) == 0) continue;

		$dienste = array();
		foreach($ad as $s) {
			ko_get_dienste($dienste_, $s);
			$dienste[] = $dienste_[$s];
		}

		$mark_empty  = ko_get_setting("dp_mark_empty");

		$data = array();
		foreach($dienste as $d) {
			if(!$d["id"]) continue;

	    $zeile = array();
	    //Dienstname
	    $zeile[] = $d["name"];

	    foreach($events as $e) {
				if(in_array($e["eventgruppen_id"], explode(",", $d["tg"]))) {
					ko_get_einteilung($la, $d["id"], $e["id"]);
					$txt = "";
					foreach($la as $l) {  //Alle Leute auslesen
						if(is_numeric($l)) {
							ko_get_person_by_id($l, $p);
							$txt .= $p["vorname"]." ".$p["nachname"].", ";
						} else {
							$txt .= $l.", ";
						}
					}//foreach(la)
					$zeile[] = ($txt) ? substr($txt, 0, -2) : ($mark_empty ? getLL("dp_empty") : "");
				} else {
					$zeile[] = "-";
				}
			}//foreach(events)
			$data[] = $zeile;
		}//foreach(dienste)

		$filename = getLL("dp_filename_dp").strftime("%d%m%Y_%H%M%S", time()).".xls";
		$title = getLL("dp_roster")." ".strftime($GLOBALS["DATETIME"]["MY"], mktime(1,1,1, $_SESSION["show_monat"], 1, $_SESSION["show_jahr"]));
		ko_export_to_excel($header, $data, ($ko_path."download/excel/".$filename), $title);
		$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=download/excel/$filename', 400, 300);";

		//Fileshare-Datei speichern, falls gewnscht
		if(ko_module_installed("fileshare", $_SESSION["ses_userid"]) && ko_get_userpref($_SESSION["ses_userid"], "save_files_as_share") == 1) {
			ko_fileshare_save_file_as_share($_SESSION["ses_userid"], "../download/excel/".$filename);
		}
	break;




	//Mail
	case "dp_erinnern":
		if(!$group_mod) continue;

		//Titeldaten fr XLS-Datei
		$cols = array("anrede", "vorname", "nachname", "adresse", "adresse_zusatz", "plz", "ort", "land", "telp", "telg");
    $leute_col_name = ko_get_leute_col_name();
    $header = array();
    foreach($cols as $c) {
	    $header[] = $leute_col_name[$c];
	  }

    //Liste aller ausgewhlten Dienste
		$liste = "[" . getLL("dp_mail_var_teamleader") . "] ";
		$ohne_email = "";
		$row = 0;
		$none = TRUE;
		foreach($_POST["chk"] as $c_i => $c) {
			$none = FALSE;
			$liste .= format_userinput($c_i, "uint") . ",";

			//Dienstleiter ohne Email raussuchen
			ko_get_leiter_by_dienst($leiter, $c_i);
			foreach($leiter as $l) {
				ko_get_person_by_id($l, $p);
				if(!$p["email"]) {
					$ohne_email .= $p["vorname"]." ".$p["nachname"]." ".getLL("from")." ".$p["ort"].", ";
					//Daten fr XLS-Datei speichern
					$col = 0;
					foreach($cols as $c) {
						$data[$row][$col++] = sql2datum($p[strtolower($leute_col_name[$c])]);
					}
					$row++;
				}//if(!p[email])
			}//foreach(leiter)
		}//foreach(chk)
		if($none) {
			$error = 1;
			continue;
		}
		$liste = substr($liste, 0, -1);
		$ohne_email = substr($ohne_email, 0, -2);

		if($ohne_email != "") {
      $dateiname = $ko_path."download/excel/".getLL("dp_filename_no_email").strftime("%d%m%Y_%H%M%S", time()).".xls";
      ko_export_to_excel($header, $data, $dateiname, getLL("dp_no_email"));
      $smarty->assign("xls_filename", $dateiname);
    }

		$betreff = "[".getLL("dp_roster")."] ".strftime($GLOBALS["DATETIME"]["MY"], mktime(1,1,1, (int)$_SESSION["show_monat"], 1, $_SESSION["show_jahr"]));

		//Deadline berechnen
		$temptag = 32;
		$tempfound = 0;
		$prev_monat = $akt_monat = $_SESSION["show_monat"];
		$prev_jahr = $akt_jahr = $_SESSION["show_jahr"];
		addmonth($prev_monat, $prev_jahr, -1);
		while(!checkdate(($prev_monat), --$temptag, $prev_jahr));  //Finde letzten Tag des letzten Monats
		while((int)$tempfound != (int)ko_get_setting("dp_deadline_woche") && $temptag > 0) {  //Gehe rckwrts durch Monat, bis DEADLINE_WOCHE mal DEADLINE_TAG gefunden wurde
		  $tempdate = getdate(mktime(1, 1, 1, $prev_monat, $temptag--, $prev_jahr));
		  if((int)$tempdate["wday"] == (int)ko_get_setting("dp_deadline_tag")) $tempfound++;
		}//while(tempfound != DEADLINE_WOCHE)
		$deadline = ($temptag+1) . "." . $prev_monat . "." . $prev_jahr;

		//Deadline in Mailtext bereits ersetzen
		$text = ko_get_setting("dp_mailtext_1");
		$text = str_replace("<DEADLINE>", $deadline, $text);

		$smarty->assign("txt_empfaenger", $liste);
		$smarty->assign("to_readonly", TRUE);
		$smarty->assign("cc_readonly", TRUE);
		$smarty->assign("bcc_readonly", TRUE);
    $smarty->assign("tpl_ohne_email", ($ohne_email == "" ? "keine" : ko_html($ohne_email)));
		$p = ko_get_logged_in_person();
		$smarty->assign("tpl_show_bcc_an_mich", ($p["email"] ? TRUE : FALSE));
    $smarty->assign("tpl_show_send", TRUE);

		$smarty->assign("txt_betreff", $betreff);
		$smarty->assign("txt_emailtext", ko_html($text));

		//Log wird bei Email-Versand gemacht

		$_SESSION["show"] = "dp_erinnern";
	break;


	case "submit_email":
		if(!$group_mod) continue;

		if(substr($_POST["txt_empfaenger"], 0, strlen(getLL("dp_mail_var_teamleader"))+2 ) != "[" . getLL("dp_mail_var_teamleader") . "]") continue;

		$email_headers = array("From" => ko_get_setting("info_email"));
		$bcc = "";
		if($_POST["rd_bcc_an_mich"] == "ja") {
			$m = ko_get_logged_in_person();
			$email = $m["email"] != "" ? $m["email"] : "";
			$bcc .= ($bcc == "") ? $email : "; $email";
			if($bcc != "") $email_headers["BCC"] = $bcc;
		}
		$log_message = $_SESSION["show_monat"] . "-" . $_SESSION["show_jahr"] . ": ";

		$dienste = explode(",", substr($_POST["txt_empfaenger"], strlen(getLL("dp_mail_var_teamleader"))+3));
		foreach($dienste as $d) {
			//Mailtext erstellen
			ko_get_dienste($dienst_, $d);
			$dienst = $dienst_[$d];
			$dienst_tgs = explode(",", $dienst["tg"]);

			$log_message .= $dienst["name"]." (".$d."): ";

			ko_get_dp_events($events, $_SESSION["show_monat"], $_SESSION["show_jahr"]);
			$anlassliste = "";
			foreach($events as $e_i => $e) {

				if(in_array($e["eventgruppen_id"], $dienst_tgs)) {
					ko_get_eventgruppe_by_id($e["eventgruppen_id"], $tg);
					$anlassliste .= "- ".$tg["name"]." (".strftime($GLOBALS["DATETIME"]["DdmY"], strtotime($e["startdatum"]));
					if($e["enddatum"] != $e["startdatum"] && $e["enddatum"] != "0000-00-00") {
						$anlassliste .= "-".strftime($GLOBALS["DATETIME"]["DdmY"], strtotime($e["enddatum"]));
					}
					$anlassliste .= " ".getLL("time_at")." ".substr($e["startzeit"], 0, -3)." ".getLL("time_oclock").")";

					//Bisherige Einteilung anzeigen, falls vorhanden
					ko_get_einteilung($leute_akt, $d, $e["id"]);
					if(sizeof($leute_akt) > 0) {
						$anlassliste .= ": ";
						foreach($leute_akt as $l) {
							if(is_numeric($l)) {
								ko_get_person_by_id($l, $l_);
								$anlassliste .= $l_["vorname"] . " " . $l_["nachname"] . ", ";
							} else {
								$anlassliste .= $l.", ";
							}
						}
						$anlassliste = substr($anlassliste, 0, -2);
					}

					$anlassliste .= "\n";
				}//if(in_array(e[eventruppen_id], dienst_tgs))
			}//foreach(events as e)

			$trans = array("<" . getLL("dp_mail_var_teamname") . ">" => $dienst["name"],
					"<" . getLL("dp_mail_var_month") . ">" => strftime("%B", mktime(1,1,1, (int)$_SESSION["show_monat"], 1, $_SESSION["show_jahr"])),
					"<" . getLL("dp_mail_var_year") . ">"  => strftime("%Y", mktime(1,1,1, (int)$_SESSION["show_monat"], 1, $_SESSION["show_jahr"])),
					"<" . getLL("dp_mail_var_deadline") . ">" => "...",
					"<" . getLL("dp_mail_var_events") . ">" => $anlassliste);
			$mail_text = strtr($_POST["txt_emailtext"], $trans);

			//Mail an alle Dienstleiter verschicken
			$to = "";
			ko_get_leiter_by_dienst($leiter, $d);
			foreach($leiter as $l) {
				ko_get_leute_email($l, $email);
				if($email) $to .= $email.", ";
			}//foreach(leiter);
			if($to) ko_send_email(substr($to, 0, -2), $_POST["txt_betreff"], ko_emailtext($mail_text), $email_headers);

			$log_message .= $to ? $to : "-";

		}//foreach(dienste)

		ko_log("dp_sendmail_1", substr($log_message, 0, -2));
		$info = 5;
		$_SESSION["show"] = "list_dienste";
	break;




	case "dp_dienst_erstellen":
		if(!$group_view) continue;

		//Markierte Dienste
		$d = array();
		foreach($_POST["chk"] as $c_i => $c) {
			if($c && $group_view[$c_i]) $d[] = format_userinput($c_i, "uint");
		}

		//Start- und Stop-Angaben
		$m = $startm = format_userinput($_POST["sel_dienst_erstellen_start"], "uint");
		$stopm  = format_userinput($_POST["sel_dienst_erstellen_stop"], "uint");
		$mm = array();
		while($stopm >= $m) {
			$m_j = substr($m, 0, 4);
			$m_m = substr($m, 4, 2);
			$mm[] = str_to_2($m_m)."-".$m_j;
			addmonth($m_m, $m_j, 1);
			$m = $m_j.str_to_2($m_m);
		}

		$filename = ko_dp_create_dienste_pdf($d, $mm);

		$pdf_filename = substr($filename, 1);
		$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=$pdf_filename', 400, 300);";
	break;



	//Settings
	case "submit_dp_settings_div":
		if(!$group_mod) continue;

		ko_set_setting("dp_mailtext_1", format_userinput($_POST["txt_mail1"], "text"));
		ko_set_setting("dp_mailtext_2", format_userinput($_POST["txt_mail2"], "text"));
		ko_set_setting("dp_deadline_woche", format_userinput($_POST["sel_deadline_woche"], "uint"));
		ko_set_setting("dp_deadline_tag", format_userinput($_POST["sel_deadline_tag"], "uint"));
		ko_set_setting("dp_superdienste", format_userinput($_POST["rd_superdienste"], "uint"));
		ko_set_setting("dp_freetext_dienste", format_userinput($_POST["sel_freetext_dienste"], "intlist"));
		ko_set_setting("dp_teamrole", format_userinput($_POST["sel_group_teamrole"], "intlist"));
		ko_set_setting("dp_leaderrole", format_userinput($_POST["sel_group_leaderrole"], "intlist"));
		ko_set_setting("dp_orderby", format_userinput($_POST["sel_group_orderby"], "alpha"));
		ko_set_setting("dp_use_presets", format_userinput($_POST["sel_group_presets"], "uint"));
		ko_set_setting("dp_commentrow", format_userinput($_POST["sel_group_commentrow"], "alphanum"));
		ko_set_setting("dp_use_colors", format_userinput($_POST["sel_group_use_colors"], "uint"));
		ko_set_setting("dp_months_back", format_userinput($_POST["sel_months_back"], "uint"));

		$info = 7;
		ko_log("dp_save_settings", "Div: Deadline(".format_userinput($_POST["sel_deadline_woche"], "uint").".".format_userinput($_POST["sel_deadline_tag"], "uint")."), Superteams: ".format_userinput($_POST["rd_superdienste"], "uint").", Mailtexts...");
	break;



	//Submenus
  case "move_sm_left":
  case "move_sm_right":
    ko_submenu_actions("dp", $do_action);
  break;


	//Default:
  default:
		if(!hook_action_handler($do_action))
      include_once($ko_path."inc/abuse.inc");
  break;


}//switch(do_action)


//HOOK: Plugins erlauben, die bestehenden Actions zu erweitern
hook_action_handler_add($do_action);



//*** Rechte neu auslesen
ko_get_admin("dp", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);



//*** Default-Werte auslesen
if(!isset($_SESSION["show_dienste"]) || $_SESSION["show_dienste"] == "") {
  $show_dienste_string = ko_get_userpref($_SESSION["ses_userid"], "show_dp_dienste");
  if($show_dienste_string) {
    $_SESSION["show_dienste"] = explode(",", $show_dienste_string);
  } else {
		ko_get_dienste($di);
    $_SESSION["show_dienste"] = array_keys($di);
  }
}
$_SESSION["show_limit"] = ko_get_userpref($_SESSION["ses_userid"], "show_limit_dp");
if(!$_SESSION["show_limit"]) $_SESSION["show_limit"] = ko_get_setting("show_limit_dp");

if(!$_SESSION["show_start"]) {
  $_SESSION["show_start"] = 1;
}

if($_SESSION["show_monat"] == "" || $_SESSION["show_jahr"] == "") {
	$inc = 0;
	get_heute($tag, $monat, $jahr);
	$found = FALSE;

	while(!$found) {
    $id = str_to_2($monat)."-".$jahr;
		if(ko_dp_get_monat_status($id) == 1) {
			$_SESSION["show_monat"] = $monat;
			$_SESSION["show_jahr"] = $jahr;
			$found = TRUE;
		}

		$inc++;
		if($inc >= 10) {  //Maximal 10 Monate voraus nach einem offenen suchen, sonst einfach aktuellen whlen
			$found = TRUE;
			get_heute($tag, $monat, $jahr);
			$_SESSION["show_monat"] = $monat;
			$_SESSION["show_jahr"] = $jahr;
		}
    if(!$found) addmonth($monat, $jahr, 1);

	}//while(!$found)
}

//Include submenus
ko_set_submenues();


//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);
?>



<!DOCTYPE html 
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php print $_SESSION["lang"]; ?>" lang="<?php print $_SESSION["lang"]; ?>">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title><?php print "$HTML_TITLE: ".getLL("module_".$ko_menu_akt); ?></title>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>kOOL.css" />
<!--[if lte IE 6]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie6.css" />
<![endif]-->
<!--[if IE 7]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie7.css" />
<![endif]-->
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ko.css" />
<?php
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/kOOL.js\'></script>';
include($ko_path.'inc/js-sessiontimeout.inc');
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/popup.js\'></script>';
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/ajax.js\'></script>';
include("inc/js-dp.inc");
?>
</head>

<body onload="session_time_init();<?php if(isset($onload_code)) print $onload_code; ?>">

<script language="javaScript" type="text/javascript" src="<?php print $ko_path."inc/";?>tooltip.js"></script>

<?php
/*
 * Gibt bei erfolgreichem Login das Men aus, sonst einfach die Loginfelder
 */
include($ko_path . "menu.php");
?>


<form action="index.php" method="post" name="formular" enctype="multipart/form-data">  <!-- Hauptformular -->
<input type="hidden" name="action" id="action" value="" />
<input type="hidden" name="id" id="id" value="" />
<input type="hidden" name="event_id" id="event_id" value="" />  <!-- Vorlagen beim Erfassen -->

<table width="100%">
<tr>

<td class="main_left" name="main_left" id="main_left">
<?php
print ko_get_submenu_code("dp", "left");
?>
</td>


<td class="main" name="main_content" id="main_content">
<?php
if($info) {
	$info_txt = getLL("info_dp_".$info);
	print '<div class="infotxt">'.$info_txt.'</div><br />';
}
if($error) {
	$error_txt = getLL("error_dp_".$error);
	ko_error_log(getLL("module_dp"), $error, $error_txt, $do_action);
	print '<div class="errortxt">'.$error_txt.'</div><br />';
}


switch($_SESSION["show"]) {
	case "show_dienst":
		ko_show_dp($_SESSION["show_dienste"]);
	break;

	case "list_dienste":
		ko_list_dienste();
	break;

	case "list_superdienste":
		ko_list_superdienste();
	break;

	case "new_dienst":
		ko_formular_dienst("new");
	break;

	case "new_superdienst":
		ko_formular_superdienst("new");
	break;

	case "edit_dienst":
		ko_formular_dienst("edit", format_userinput($_POST["id"], "uint"));
	break;

	case "edit_superdienst":
		ko_formular_superdienst("edit", format_userinput($_POST["id"], "uint"));
	break;

	case "dp_erinnern":
		$smarty->assign("tpl_title1", getLL('leute_email_title1'));
		$smarty->assign("tpl_body1", getLL('leute_email_body1'));
		$smarty->assign("tpl_all_recip", getLL('leute_email_all_recipients'));
		$smarty->assign("tpl_no_email", getLL('leute_email_no_email'));
		$smarty->assign("tpl_xls_file", getLL('leute_email_xls_file'));
		$smarty->assign("tpl_title2", getLL('leute_email_title2'));
		$smarty->assign("tpl_body2", getLL('leute_email_body2'));
		$smarty->assign("tpl_more", getLL('leute_email_more'));
		$smarty->assign("tpl_to", getLL('leute_email_to'));
		$smarty->assign("tpl_cc", getLL('leute_email_cc'));
		$smarty->assign("tpl_bcc", getLL('leute_email_bcc'));
		$smarty->assign("tpl_subject", getLL('leute_email_subject'));
		$smarty->assign("tpl_text", getLL('leute_email_text'));
		$smarty->assign("tpl_bcc_me", getLL('leute_email_bcc_me'));
		$smarty->assign("tpl_yes", getLL('yes'));
		$smarty->assign("tpl_no", getLL('no'));
		$smarty->assign("tpl_send", getLL('leute_email_send'));
		$smarty->assign("tpl_error_no_subject", getLL("leute_email_error_no_subject"));
		$smarty->display("ko_formular_email.tpl");
	break;

	case "create_dp":
		ko_dp_show_create_dp($send_info);
	break;

	case "dp_settings_div":
		ko_dp_show_settings_div();
	break;

	case "multiedit":
		ko_multiedit_formular("ko_dp_dienste", $do_columns, $do_ids, $order, array("cancel" => "list_dienste"));
	break;


	default:
		//HOOK: Plugins erlauben, neue Show-Cases zu definieren
    hook_show_case($_SESSION["show"]);
  break;
}//switch(show)

//HOOK: Plugins erlauben, die bestehenden Show-Cases zu erweitern
hook_show_case_add($_SESSION["show"]);

?>
</td>

<td class="main_right" name="main_right" id="main_right">

<?php
print ko_get_submenu_code("dp", "right");
?>

</td>
</tr>

<?php include($ko_path . "footer.php"); ?>

</table>

</form> <!-- //Hauptformular -->


</body>
</html>
