<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

function ko_groups_list($output=TRUE) {
	global $smarty, $ko_path;
	global $all_groups;

	//Immer alle Gruppen anzeigen, deshalb fr ko_get_admin setting auf 1 setzen
	$orig_value = ko_get_setting("show_passed_groups");
	ko_set_setting("show_passed_groups", 1);
	ko_get_admin("groups", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod, FALSE);
	if(!is_array($all_groups)) ko_get_groups($all_groups);
	ko_set_setting("show_passed_groups", $orig_value);

	$z_where = $z_limit = "";
	//apply_groups_filter($z_where, $z_limit);
	if($_SESSION["show_gid"] == "NULL") {
		$z_where = "AND `pid` IS NULL";
	} else {
		$z_where = "AND `pid` = '".$_SESSION["show_gid"]."'";
	}
	if($_SESSION["show_start"] && $_SESSION["show_limit"]) $z_limit  = "LIMIT ".($_SESSION["show_start"]-1).", ".$_SESSION["show_limit"];

	$rows = db_get_count("ko_groups", "id", $z_where);
	ko_get_groups($groups, $z_where, $z_limit);

	//Check for tracking rights
	$show_tracking = FALSE;
	if(ko_module_installed('tracking', $_SESSION['ses_userid'])) {
		$add_tracking = ko_get_admin_all('tracking_admin', $_SESSION['ses_userid']) == 4;
		ko_get_admin('tracking', $_SESSION['ses_userid'], $tv, $tn, $te, $tm);
		$show_tracking = TRUE;
	}

	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = ($_SESSION["show_limit"]+$_SESSION["show_start"]-1 > $rows) ? $rows : ($_SESSION["show_limit"]+$_SESSION["show_start"]-1);
  $smarty->assign('tpl_stats', $_SESSION["show_start"]." - ".$stats_end." ".getLL("list_oftotal")." ".$rows);

	//Links fr Prev und Next-Page vorbereiten
  if($_SESSION["show_start"] > 1) {
		$smarty->assign("tpl_prevlink_link", "javascript:sendReq('../groups/inc/ajax.php', 'action,set_start,sesid', 'setstart,".(($_SESSION["show_start"]-$_SESSION["show_limit"] < 1) ? 1 : ($_SESSION["show_start"]-$_SESSION["show_limit"])).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_prevlink_link', '');
  }
  if(($_SESSION["show_start"]+$_SESSION["show_limit"]-1) < $rows) {
		$smarty->assign("tpl_nextlink_link", "javascript:sendReq('../groups/inc/ajax.php', 'action,set_start,sesid', 'setstart,".($_SESSION["show_limit"]+$_SESSION["show_start"]).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_nextlink_link', '');
  }


	//Motherline fr Listen-Titel
	if($_SESSION["show_gid"] == "NULL") {
		$list_title = '<a href="#">'.getLL("groups_list_top").'</a>';
	} else {
		$list_title = '<a href="?action=list_groups&amp;gid=NULL">'.getLL("groups_list_top").'</a>&nbsp;&nbsp;/&nbsp;&nbsp;';
		$m = ko_groups_get_motherline($_SESSION["show_gid"], $all_groups);
		$value = array();
		//Link fr jede hierarchisch hher liegende Gruppe
		foreach($m as $g) {
			$list_title .= '<a href="?action=list_groups&amp;gid='.$g.'">'.$all_groups[$g]["name"].'</a>&nbsp;&nbsp;/&nbsp;&nbsp;';
		}
		//Aktuelle Gruppe auch anzeigen
		$list_title .= $all_groups[$_SESSION["show_gid"]]["name"];
	}

	$smarty->assign("tpl_list_title", getLL("groups_groups"));
	$smarty->assign("tpl_list_subtitle", $list_title);


	//Header-Informationen
	$smarty->assign("tpl_show_3cols", TRUE);
	if($show_tracking) $smarty->assign('tpl_show_tracking_col', TRUE);

	$show_cols = array(getLL('groups_listheader_name'), getLL('groups_listheader_numpeople'), getLL('groups_listheader_subgroups'), getLL('groups_listheader_description'), getLL('groups_listheader_roles'), getLL('groups_listheader_start'), getLL('groups_listheader_dummy'));
  $sort_cols = array('name', '', '', 'description', '', 'start', 'type');
  foreach($show_cols as $c_i => $c) {
    $tpl_table_header[$c_i]["sort"] = $sort_cols[$c_i];
    $tpl_table_header[$c_i]["name"] = $show_cols[$c_i];
  }
  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("sort", array("show" => TRUE,
																"action" => "setsortgroups",
																"akt" => $_SESSION["sort_groups"],
																"akt_order" => $_SESSION["sort_groups_order"])
	);
	$smarty->assign("module", "groups");
	$smarty->assign("sesid", session_id());

	//Multiedit-Spalten definieren
	if($group_edit) {
		$smarty->assign("tpl_show_editrow", TRUE);
		$edit_columns = array('name', '', '', 'description', 'roles', 'start', 'type');
		$smarty->assign("tpl_edit_columns", $edit_columns);
	} else {
		$smarty->assign("tpl_show_editrow", FALSE);
	}


	//Liste fllen
	foreach($groups as $l_i => $l) {
		if(!$group_view[$l_i]) continue;
		//Checkbox
		$tpl_list_data[$l_i]["show_checkbox"] = TRUE;

		//Edit-Button
		if($group_edit[$l_i]) {
			$tpl_list_data[$l_i]["show_edit_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_edit"] = getLL("groups_edit_group");
			$tpl_list_data[$l_i]["onclick_edit"] = "javascript:set_action('edit_group');set_hidden_value('id', '$l_i');this.submit";
		}

		//Delete-Button
		if($group_mod[$l_i] && db_get_count("ko_groups", "id", "AND `pid` = '$l_i'") == 0) {
			$tpl_list_data[$l_i]["show_delete_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_delete"] = getLL("groups_delete_group");
			$tpl_list_data[$l_i]["onclick_delete"] = "javascript:c = confirm('".getLL("groups_delete_group_confirm")."');if(!c) return;set_action('delete_group');set_hidden_value('id', '$l_i');";
		}

		//Tracking
		if($show_tracking && $l['type'] != 1) {
			//Find a tracking for this group
			$tracking = db_select_data('ko_tracking', 'WHERE `filter` = \'g'.$l_i.'\'', '*', '', 'LIMIT 0,1', TRUE);
			if(isset($tracking['id']) && $tv[$tracking['id']]) {  //Found a tracking with access to it
				$tpl_list_data[$l_i]['tracking_mode'] = 'show';
				$tpl_list_data[$l_i]['alt_tracking'] = getLL('tracking_group_show');
				$tpl_list_data[$l_i]['onclick_tracking'] = "javascript:jumpToUrl('".$ko_path."tracking/index.php?action=enter_tracking&amp;id=".$tracking['id']."'); return false;";
			} else if($add_tracking) {  //No tracking so show add link if access rights are 4@ALL
				$tpl_list_data[$l_i]['tracking_mode'] = 'add';
				$tpl_list_data[$l_i]['alt_tracking'] = getLL('tracking_group_add');
				$tpl_list_data[$l_i]['onclick_tracking'] = "javascript:sendReq('".$ko_path."groups/inc/ajax.php', 'action,id,sesid', 'addgrouptracking,$l_i,".session_id()."', do_element); return false;";
			} else {  //else don't show anything
				$tpl_list_data[$l_i]['tracking_mode'] = '';
			}
		}

		//Index
		$tpl_list_data[$l_i]["id"] = $l_i;

		$num_subgroups = db_get_count("ko_groups", "id", "AND `pid` = '$l_i'");

		//Name
		if($num_subgroups > 0) {
			$tpl_list_data[$l_i][1] = '<a href="?action=list_groups&amp;gid='.$l_i.'"><b>'.ko_html($l["name"]).'</b></a>';
		} else {
			$tpl_list_data[$l_i][1] = ko_html($l["name"]);
		}

		//ezmlm
		if($l["ezmlm_list"]) {
			$tpl_list_data[$l_i][1] .= '&nbsp;<sup onmouseover="tooltip.show(\''.$l["ezmlm_list"].'\');" onmouseout="tooltip.hide();">'.getLL("ezmlm_ml").'</sup>';
		}

		//Number of members
		$num = db_get_count('ko_leute', 'id', "AND `groups` REGEXP 'g$l_i' AND deleted = '0' ".ko_get_leute_hidden_sql());
		$tpl_list_data[$l_i][2] = '&nbsp;<a href="'.$ko_path.'leute/index.php?action=set_group_filter&amp;id='.$l_i.'">'.$num.'</a>';

		//Anzahl Subgruppen
		$tpl_list_data[$l_i][3] = $num_subgroups;

		//Beschreibung
		$tpl_list_data[$l_i][4] = ko_html(substr($l["description"], 0, 30).(strlen($l["description"]) > 30 ? "..." : ""));

		//Roles
		$value = array();
		foreach(explode(",", $l["roles"]) as $role) {
			ko_get_grouproles($roles, "AND `id` = '$role'");
			$link = $ko_path.'leute/index.php?action=set_group_filter&amp;id='.$l_i.'&amp;rid='.$role;
			$value[] = '<a href="'.$link.'">'.ko_html($roles[$role]["name"]).'</a>';
		}
		$tpl_list_data[$l_i][5] = implode(", ", $value);

		//Start and stop
		$tpl_list_data[$l_i][6] = ko_html(sql2datum($l['start']));
		if($l['stop'] != '0000-00-00') $tpl_list_data[$l_i][5] .= ' - '.ko_html(sql2datum($l['stop']));

		//Platzhalter (Type)
		$tpl_list_data[$l_i][7] = $l["type"] == 1 ? 'x' : '';
	}//foreach(groups)


	//Footer
	if($group_edit) {
		$list_footer[] = array("label" => getLL("groups_list_footer_rights_label"),
													 "button" => '<input type="submit" onclick="c=confirm(\''.getLL("groups_list_footer_rights_button_confirm").'\');if(!c) return false;set_action(\'propagate_rights\');" value="'.getLL("groups_list_footer_rights_button").'" />');
		$smarty->assign("show_list_footer", TRUE);
		$smarty->assign("list_footer", $list_footer);
	}

	$smarty->assign("help", ko_get_help("groups", "list_groups"));

	$smarty->assign('tpl_list_cols', array(1, 2, 3, 4, 5, 6, 7));
  $smarty->assign('tpl_list_data', $tpl_list_data);
	if($output) {
		$smarty->display('ko_list.tpl');
	} else {
		print $smarty->fetch('ko_list.tpl');
	}
}//ko_groups_list()




function ko_groups_list_datafields() {
	global $smarty, $ko_path;
	global $group_all_edit;

	if(!$group_all_edit) return;

	$rows = db_get_count("ko_groups_datafields", "id", "");
	$datafields = db_select_data("ko_groups_datafields", "", "*", "ORDER BY reusable DESC, description ASC");

	//Statistik ber Suchergebnisse und Anzeige
  $smarty->assign('tpl_stats', "1 - ".$rows." ".getLL("list_oftotal")." ".$rows);

	//Links fr Prev und Next-Page vorbereiten
  $smarty->assign('tpl_prevlink_link', '');
  $smarty->assign('tpl_nextlink_link', '');


	//Header-Informationen
	$smarty->assign("tpl_show_3cols", TRUE);

	$show_cols = array(getLL("groups_listheader_name"), getLL("groups_listheader_type"), getLL("groups_listheader_reusable"), getLL("groups_listheader_role_usedin"), getLL("groups_listheader_options"));
  $sort_cols = array("name", "type", "");
  foreach($show_cols as $c_i => $c) {
    $tpl_table_header[$c_i]["name"] = $show_cols[$c_i];
  }
  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("sort", array("show" => FALSE));


	//Liste fllen
	foreach($datafields as $l_i => $l) {
		//Prfen, ob Datenfeld noch irgendwo verwendet wird, dann kann man es nicht lschen
		$groups = db_select_data("ko_groups", "WHERE `datafields` REGEXP '$l_i'");
		$num = sizeof($groups);
		$do_delete = $num == 0;
		$used_in = array();
		foreach($groups as $group) {
			$used_in[] = $group["name"];
		}

		//Checkbox
		$tpl_list_data[$l_i]["show_checkbox"] = TRUE;

		//Edit-Button
		$tpl_list_data[$l_i]["show_edit_button"] = TRUE;
		$tpl_list_data[$l_i]["alt_edit"] = getLL("groups_edit_datafield");
		$tpl_list_data[$l_i]["onclick_edit"] = "javascript:set_action('edit_datafield');set_hidden_value('id', '$l_i');this.submit";

		//Delete-Button
		if($do_delete) {
			$tpl_list_data[$l_i]["show_delete_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_delete"] = getLL("groups_delete_datafield");
			$tpl_list_data[$l_i]["onclick_delete"] = "javascript:c = confirm('".getLL("groups_delete_datafield_confirm")."');if(!c) return;set_action('delete_datafield');set_hidden_value('id', '$l_i');";
		}

		//Index
		$tpl_list_data[$l_i]["id"] = $l_i;

		//Name
		$tpl_list_data[$l_i][1] = ko_html($l["description"]);

		//Type
		$tpl_list_data[$l_i][2] = getLL("groups_datafields_".$l["type"]);

		//Reusable
		$tpl_list_data[$l_i][3] = $l["reusable"] ? getLL("yes") : getLL("no");

		//Verwendet in Gruppen
		$tpl_list_data[$l_i][4] = ($num > 10) ? '"'.$num.' '.getLL("groups_groups").'"' : ko_html(implode(", ", $used_in));

		//Options (for select and multiselect)
		$tpl_list_data[$l_i][5] = implode(", ", unserialize($l["options"]));;
	}//foreach(login)

	$smarty->assign("help", ko_get_help("groups", "list_datafields"));

	$smarty->assign("tpl_list_title", getLL("groups_datafields_list_title"));
	$smarty->assign('tpl_list_cols', array(1, 2, 3, 4, 5));
  $smarty->assign('tpl_list_data', $tpl_list_data);
	$smarty->display('ko_list.tpl');
}//ko_groups_list_datafields()





function ko_groups_list_roles() {
	global $smarty, $ko_path;

	//Immer alle Gruppen anzeigen, deshalb fr ko_get_admin setting auf 1 setzen
	$orig_value = ko_get_setting("show_passed_groups");
	ko_set_setting("show_passed_groups", 1);
	ko_get_admin("groups", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod, FALSE);
	ko_set_setting("show_passed_groups", $orig_value);

	$z_where = $z_limit = "";
	//apply_groups_filter($z_where, $z_limit);

	$rows = db_get_count("ko_grouproles", "id", $z_where);
	ko_get_grouproles($roles, $z_where, $z_limit);

	//Statistik ber Suchergebnisse und Anzeige
  $smarty->assign('tpl_stats', "1 - ".$rows." ".getLL("list_oftotal")." ".$rows);

	//Links fr Prev und Next-Page vorbereiten
  $smarty->assign('tpl_prevlink_link', '');
  $smarty->assign('tpl_nextlink_link', '');


	//Header-Informationen
	$smarty->assign("tpl_show_3cols", TRUE);

	$show_cols = array(getLL("groups_listheader_role_name"), getLL("groups_listheader_role_usedin"));
  $sort_cols = array("name", "");
  foreach($show_cols as $c_i => $c) {
    $tpl_table_header[$c_i]["name"] = $show_cols[$c_i];
  }
  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("sort", array("show" => FALSE));


	//Liste fllen
	foreach($roles as $l_i => $l) {
		//Prfen, ob alle Gruppen, in denen diese Rolle verwendet wird, bearbeitbar sind
		$groups = db_select_data("ko_groups", "WHERE `roles` REGEXP '$l_i'");
		$used_in = ""; $used_in_num = 0;
		if(sizeof($groups) > 0) {  //Gruppen testen, die diese Rolle haben
			$do_edit = TRUE; $do_view = FALSE;
			foreach($groups as $group) {
				if(!$group_edit[$group["id"]]) {
					$do_edit = FALSE;
				}
				if($group_view[$group["id"]]) $do_view = TRUE;
				$used_in .= $group["name"].", ";
				$used_in_num++;
			}
		} else {  //Rolle noch nicht zugewiesen
			if($group_view["all"]) $do_view = TRUE; else $do_view = FALSE;
			if($group_edit["all"]) $do_edit = TRUE; else $do_edit = FALSE;
		}


		if(!$do_view) continue;

		//Checkbox
		$tpl_list_data[$l_i]["show_checkbox"] = TRUE;

		//Edit-Button
		if($do_edit) {
			$tpl_list_data[$l_i]["show_edit_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_edit"] = getLL("groups_edit_role");
			$tpl_list_data[$l_i]["onclick_edit"] = "javascript:set_action('edit_role');set_hidden_value('id', '$l_i');this.submit";
		}

		//Delete-Button
		if($do_edit) {
			$tpl_list_data[$l_i]["show_delete_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_delete"] = getLL("groups_delete_role");
			$tpl_list_data[$l_i]["onclick_delete"] = "javascript:set_action('delete_role');set_hidden_value('id', '$l_i');";
		}

		//Index
		$tpl_list_data[$l_i]["id"] = $l_i;

		//Name
		$tpl_list_data[$l_i][1] = ko_html($l["name"]);

		//Verwendet in Gruppen
		$tpl_list_data[$l_i][2] = ($used_in_num > 15) ? '"'.$used_in_num.' '.getLL("groups_groups").'"' : ko_html(substr($used_in, 0, -2));
	}//foreach(login)

	$smarty->assign("help", ko_get_help("groups", "list_roles"));

	$smarty->assign("tpl_list_title", getLL("groups_roles_list_title"));
	$smarty->assign('tpl_list_cols', array(1, 2));
  $smarty->assign('tpl_list_data', $tpl_list_data);
	$smarty->display('ko_list.tpl');
}//ko_groups_list_roles()







function ko_groups_formular_group($mode, $id = "") {
	global $ko_path, $smarty, $db;
  global $group_all_edit, $g_view;
	global $all_groups;
	global $js_calendar;

  if($mode == "edit" && $id) {
    if(!$group_all_edit) return;

		//Daten zu dieser Gruppe auslesen
		$group = $all_groups[$id];
		$txt_name = ko_html($group["name"]);
		$txt_description = ko_html($group["description"]);
		$groups_selected = $group["pid"];
		$chk_type = ko_html($group["type"]);
		$start = $group["start"] == "0000-00-00" ? "" : sql2datum($group["start"]);
		$stop = $group["stop"] == "0000-00-00" ? "" : sql2datum($group["stop"]);
		//Berechtigungen
		//View
		$rights_view_avalues = $rights_view_aoutput = array();
		foreach(explode(",", $group["rights_view"]) as $gid) {
			if(!$gid) continue;
			ko_get_login($gid, $login);
			if($login["leute_id"]) {
				ko_get_person_by_id($login["leute_id"], $p);
			} else {
				$p = array("vorname" => $login["login"], "nachname" => "");
			}
			$rights_view_avalues[] = $gid;
			$rights_view_aoutput[] = $p["vorname"]." ".$p["nachname"];
		}
		$rights_new_avalues = $rights_new_aoutput = array();
		//New
		foreach(explode(",", $group["rights_new"]) as $gid) {
			if(!$gid) continue;
			ko_get_login($gid, $login);
			if($login["leute_id"]) {
				ko_get_person_by_id($login["leute_id"], $p);
			} else {
				$p = array("vorname" => $login["login"], "nachname" => "");
			}
			$rights_new_avalues[] = $gid;
			$rights_new_aoutput[] = $p["vorname"]." ".$p["nachname"];
		}
		$rights_edit_avalues = $rights_edit_aoutput = array();
		//Edit
		foreach(explode(",", $group["rights_edit"]) as $gid) {
			if(!$gid) continue;
			ko_get_login($gid, $login);
			if($login["leute_id"]) {
				ko_get_person_by_id($login["leute_id"], $p);
			} else {
				$p = array("vorname" => $login["login"], "nachname" => "");
			}
			$rights_edit_avalues[] = $gid;
			$rights_edit_aoutput[] = $p["vorname"]." ".$p["nachname"];
		}
		//Roles
		$roles_avalues = $roles_aoutput = array();
		foreach(explode(",", $group["roles"]) as $rid) {
			ko_get_grouproles($role, "AND `id` = '$rid'");
			$roles_avalues[] = $rid;
			$roles_aoutput[] = $role[$rid]["name"];
		}
		//datafields for this group
		$datafields_avalues = $datafields_aoutput = array(); $ids = array();
		foreach(explode(",", $group["datafields"]) as $f) {
			if(!$f) continue;
			$ids[] = $f;
		}
		if($ids != "") {
			$where = "WHERE `id` IN ('".implode("','", $ids)."')";
		} else {
			$where = "WHERE 1=2";
		}
		$fields = db_select_data("ko_groups_datafields", $where, "*");
		foreach($ids as $_id) {
			$datafields_avalues[] = $fields[$_id]["id"];
			$datafields_aoutput[] = $fields[$_id]["description"]." (".getLL("groups_datafields_".$fields[$_id]["type"]).")";
		}

  } else if($mode == "neu") {
    if(!$group_all_edit) return;

		//select displayed group as mothergroup
		$groups_selected = $_SESSION["show_gid"];
  } else return;


	//Gruppen
	$groups_values[] = "";
	$groups_output[] = "";
	$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
	foreach($groups as $grp) {
		if($grp["id"] == $id) continue;
		if(!$g_view[$grp["id"]]) continue;
	  //Kein Kreis-Vererbungen erlauben
		$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
		if(in_array($id, $mother_line)) continue;
		//Hierarchie darstellen
		$pre = "";
		$depth = sizeof($mother_line);
		for($i=0; $i<$depth; $i++) $pre .= "&nbsp;&nbsp;";
		$groups_values[] = $grp["id"];
		$groups_output[] = $pre.ko_html($grp["name"]);
	}

	//Rollen
	$roles_values = $roles_output = array();
	ko_get_grouproles($roles);
	foreach($roles as $role) {
		$roles_values[] = $role["id"];
		$roles_output[] = $role["name"];
	}

	//Logins mit Groups-Modul
	$logins_values = $logins_output = array();
	ko_get_logins($logins, "AND (`disabled` = '' OR `disabled` = '0')");
	foreach($logins as $l) {
		if(!ko_module_installed("groups", $l["id"])) continue;
		if($l["leute_id"]) {
			ko_get_person_by_id($l["leute_id"], $p);
		} else {
			$p = array("vorname" => $l["login"], "nachname" => "");
		}
		//Fr die jeweiligen Stufen nur die Benutzer anzeigen, die nicht eh schon globale Rechte fr diese Stufe haben
		//TODO: Geht nicht fr Rechte aus Benutzergruppen
		if($l["groups_admin"] == 0){
			$logins_view_values[] = $logins_new_values[] = $logins_edit_values[] = $l["id"];
			$logins_view_output[] = $logins_new_output[] = $logins_edit_output[] = $p["vorname"]." ".$p["nachname"];
		} else if($l["groups_admin"] == 1){
			$logins_new_values[] = $logins_edit_values[] = $l["id"];
			$logins_new_output[] = $logins_edit_output[] = $p["vorname"]." ".$p["nachname"];
		} else if($l["groups_admin"] == 2){
			$logins_edit_values[] = $l["id"];
			$logins_edit_output[] = $p["vorname"]." ".$p["nachname"];
		}
	}

	//datafields
	$datafields_values = $datafields_output = array();
	$all_fields = db_select_data("ko_groups_datafields", "WHERE reusable = '1'", "*", "ORDER BY description ASC");
	foreach($all_fields as $f) {
		$datafields_values[] = $f["id"];
		$datafields_output[] = $f["description"]." (".getLL("groups_datafields_".$f["type"]).")";
	}


	//Formular aufbauen
	$rowcounter = 0;
	$gc = 0;
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_name"),
															 "type" => "text",
															 "name" => "txt_name",
															 "value" => (isset($_POST["txt_name"]) ? ko_html($_POST["txt_name"]) : $txt_name),
															 "params" => 'size="40"',
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_description"),
															 "type" => "textarea",
															 "name" => "txt_description",
															 "value" => (isset($_POST["txt_description"]) ? ko_html($_POST["txt_description"]) : $txt_description),
															 "params" => 'cols="40" rows="4"',
															 );
	if($mode == "neu") $params = 'size="0" onchange="get_rights_from_mother(document.formular.chk_motherrights, this.options[this.selectedIndex].value);"';
	else $params = 'size="0"';
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_parentgroup"),
															 "type" => "select",
															 "name" => "sel_parentgroup",
															 "values" => $groups_values,
															 "descs" => $groups_output,
															 "value" => $groups_selected,
															 "params" => $params,
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_type"),
															 "type" => "checkbox",
															 "name" => "chk_type",
															 "value" => 1,
															 "params" => 'onclick="if(this.checked) unset_vis(\'frmgrp_1\'); else set_vis(\'frmgrp_1\');" '.($chk_type==1 ? 'checked="checked"' : ''),
															 );
	if($mode == "neu") {
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("form_groups_motherrights"),
																 "type" => "checkbox",
																 "name" => "chk_motherrights",
																 "value" => "0",
																 "params" => 'onclick="get_rights_from_mother(this, document.formular.sel_parentgroup.options[document.formular.sel_parentgroup.selectedIndex].value);"',
																 );

	}//if(mode==neu)
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_cal1"),
															 "type" => "html",
															 "value" => $js_calendar->make_input_field(array(), array("name" => "txt_datum", "value" => $start)),
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_cal2"),
															 "type" => "html",
															 "value" => $js_calendar->make_input_field(array(), array("name" => "txt_datum2", "value" => $stop)),
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ");
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_roles"),
															 "type" => "doubleselect",
															 "js_func_add" => "double_select_add",
															 "name" => "sel_roles",
															 "values" => $roles_values,
															 "descs" => $roles_output,
															 "avalues" => $roles_avalues,
															 "avalue" => implode(",", $roles_avalues),
															 "adescs" => $roles_aoutput,
															 "params" => 'size="7"'
															 );
	//data fields
	$frmgroup[++$gc] = array("titel" => getLL("form_groups_datafields"), "state" => ($chk_type==1 ? "closed" : "open"), "colspan" => 'colspan="2"');
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_datafields_select"),
															 "type" => "doubleselect",
															 "js_func_add" => "double_select_add",
															 "headerclass" => "formular_header_datafields",
															 "name" => "sel_datafields",
															 "values" => $datafields_values,
															 "descs" => $datafields_output,
															 "avalues" => $datafields_avalues,
															 "avalue" => implode(",", $datafields_avalues),
															 "adescs" => $datafields_aoutput,
															 "params" => 'size="7"',
															 "show_moves" => TRUE,
															 );
	$html  = '<table border="0"><tr><td valign="top">';
	$html .= '<div style="font-size:9px;font-weight:700;">'.getLL("form_groups_datafields_new_description").'</div>';
	$html .= '<input type="text" size="25" name="txt_new_datafield" /><br />';
	$html .= '<div style="font-size:9px;font-weight:700;">'.getLL("form_groups_datafields_new_type").'</div>';
	$html .= '<select size="0" name="sel_new_datafield" onchange="if(this.selectedIndex==3 || this.selectedIndex==4) set_vis(\'new_datafield_options\'); else unset_vis(\'new_datafield_options\');" />';
	$html .= '<option value="text">'.getLL("groups_datafields_text").'</option>';
	$html .= '<option value="textarea">'.getLL("groups_datafields_textarea").'</option>';
	$html .= '<option value="checkbox">'.getLL("groups_datafields_checkbox").'</option>';
	$html .= '<option value="select">'.getLL("groups_datafields_select").'</option>';
	$html .= '<option value="multiselect">'.getLL("groups_datafields_multiselect").'</option>';
	$html .= '</select>';
	$html .= '<br /><input type="checkbox" name="chk_new_datafield_reusable" id="chk_new_datafield_reusable" value="1" /><label for="chk_new_datafield_reusable">'.getLL("groups_datafields_reusable").'</label><br />';
	$html .= '<div style="margin-top:8px;"><input type="button" onclick="do_submit_new_datafield(\''.session_id().'\');" value="'.getLL("form_groups_datafields_new_create").'" /></div>';
	$html .= '</td><td valign="top">';
	$html .= '<div name="new_datafield_options" id="new_datafield_options" style="visibility:hidden; display:none;">';
	$html .= '<div style="font-size:9px;font-weight:700;">'.getLL("form_groups_datafields_new_options").'</div>';
	$html .= '<textarea name="txt_new_datafield_options" cols="20" rows="5"></textarea>';
	$html .= '</div>';
	$html .= '</td></tr></table>';
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][1] = array("desc" => getLL("form_groups_datafields_create"),
															 "type" => "html",
															 "headerclass" => "formular_header_datafields",
															 "value" => $html,
															 );
	//user-rights
	ko_get_admin("groups", $_SESSION["ses_userid"], $_group_view, $_group_new, $_group_edit, $_group_mod, FALSE);
	if((is_array($_group_edit) && $_group_edit["all"]) || (!is_array($_group_edit) && $_group_edit)) {
		$frmgroup[++$gc] = array("titel" => getLL("form_groups_rights"), "state" => "closed", "colspan" => 'colspan="2"');
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_rights_view"),
																 "type" => "doubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_view",
																 "values" => $logins_view_values,
																 "descs" => $logins_view_output,
																 "avalues" => $rights_view_avalues,
																 "avalue" => implode(",", $rights_view_avalues),
																 "adescs" => $rights_view_aoutput,
																 "params" => 'size="7"'
																 );
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_rights_new"),
																 "type" => "doubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_new",
																 "values" => $logins_new_values,
																 "descs" => $logins_new_output,
																 "avalues" => $rights_new_avalues,
																 "avalue" => implode(",", $rights_new_avalues),
																 "adescs" => $rights_new_aoutput,
																 "params" => 'size="7"'
																 );
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("form_groups_rights_edit"),
																 "type" => "doubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_edit",
																 "values" => $logins_edit_values,
																 "descs" => $logins_edit_output,
																 "avalues" => $rights_edit_avalues,
																 "avalue" => implode(",", $rights_edit_avalues),
																 "adescs" => $rights_edit_aoutput,
																 "params" => 'size="7"'
																 );
	}//if(group_edit)

	//EZMLM export
	if(defined("EXPORT2EZMLM") && EXPORT2EZMLM) {
		$frmgroup[++$gc] = array("titel" => getLL("form_groups_ezmlm"), "state" => $group["ezmlm_list"] == "" ? "closed" : "open", "colspan" => 'colspan="2"');
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_ezmlm_list"),
																 "type" => "text",
																 "name" => "txt_ezmlm_list",
														 		 "value" => (isset($_POST["txt_ezmlm_list"]) ? ko_html($_POST["txt_ezmlm_list"]) : $group["ezmlm_list"]),
																 "params" => 'size="40"'
																 );
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_ezmlm_moderator"),
																 "type" => "text",
																 "name" => "txt_ezmlm_moderator",
														 		 "value" => (isset($_POST["txt_ezmlm_moderator"]) ? ko_html($_POST["txt_ezmlm_moderator"]) : $group["ezmlm_moderator"]),
																 "params" => 'size="40"'
																 );
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("form_groups_ezmlm_export"),
																 "type" => "checkbox",
																 "name" => "chk_ezmlm_export",
																 "value" => 1,
																 );
	}



	$smarty->assign("tpl_titel", ($mode == "neu") ? getLL("groups_new_group") : getLL("groups_edit_group"));
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_id", $id);
	$smarty->assign("tpl_action", ( ($mode == "neu") ? "submit_new_group" : "submit_edit_group") );
	if($mode == 'edit') {
		$smarty->assign('tpl_submit_as_new', getLL('groups_as_new_group'));
		$smarty->assign('tpl_action_as_new', 'submit_new_group');
	}
	$smarty->assign("tpl_cancel", "list_groups");
	$smarty->assign("tpl_groups", $frmgroup);
	$smarty->assign("help", ko_get_help("groups", "new_group"));

	$smarty->display('ko_formular.tpl');
}//ko_groups_formular_group()




function ko_groups_formular_role($mode, $id = "") {
	global $ko_path, $smarty, $db;
  global $group_edit;

  if($mode == "edit" && $id) {
    if(!$group_edit) return;

		//Daten zu dieser Gruppe auslesen
		ko_get_grouproles($role_, "AND id = '$id'");
		$role = $role_[$id];
		$txt_name = ko_html($role["name"]);
		$txt_description = ko_html($group["description"]);
  } else if($mode == "neu") {
    if(!$group_edit) return;
  } else return;


	//Formular aufbauen
	$rowcounter = 0;
	$gc = 0;
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_role_name"),
															 "type" => "text",
															 "name" => "txt_name",
															 "value" => (isset($_POST["txt_name"]) ? ko_html($_POST["txt_name"]) : $txt_name),
															 "params" => 'size="40"',
															 );


	$smarty->assign("tpl_titel", ( ($mode == "neu") ? getLL("groups_new_role") : getLL("groups_edit_role")) );
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_id", $id);
	$smarty->assign("tpl_action", ( ($mode == "neu") ? "submit_new_role" : "submit_edit_role") );
	$smarty->assign("tpl_cancel", "list_roles");
	$smarty->assign("tpl_groups", $frmgroup);

	$smarty->display('ko_formular.tpl');
}//ko_groups_formular_role()




function ko_groups_formular_datafield($mode, $id = "") {
	global $ko_path, $smarty, $db;
  global $group_all_edit;

	if($mode != "edit" || !$id || !$group_all_edit) return FALSE;

	//Daten zu diesem Datenfeld auslesen
	$df = db_select_data("ko_groups_datafields", "WHERE id = '$id'", "*", "", "", TRUE);

	$df_values = array("text", "textarea", "checkbox", "select", "multiselect");
	$df_output = array(getLL("groups_datafields_text"), getLL("groups_datafields_textarea"), getLL("groups_datafields_checkbox"), getLL("groups_datafields_select"), getLL("groups_datafields_multiselect"));

	//Formular aufbauen
	$rowcounter = 0;
	$gc = 0;
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("help"),
															 "type" => "html",
															 "value" => getLL("form_groups_datafield_help"),
															 "colspan" => 'colspan="2"',
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ", "colspan" => 'colspan="2"');
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_datafield_description"),
															 "type" => "text",
															 "name" => "txt_description",
															 "value" => ko_html($df["description"]),
															 "params" => 'size="40"',
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_datafield_reusable"),
															 "type" => "checkbox",
															 "name" => "chk_reusable",
															 "value" => 1,
															 "params" => ($df["reusable"] ? 'checked="checked"' : ''),
															 );
	$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_datafield_type"),
															 "type" => "select",
															 "name" => "sel_type",
															 "values" => $df_values,
															 "descs" => $df_output,
															 "value" => $df["type"],
															 "params" => 'size = "0"',
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_datafield_options"),
															 "type" => "textarea",
															 "name" => "txt_options",
															 "value" => implode("\n", unserialize($df["options"])),
															 "params" => 'cols="30" rows="6"',
															 );


	$smarty->assign("tpl_titel", getLL("groups_edit_datafield"));
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_id", $id);
	$smarty->assign("tpl_action", "submit_edit_datafield");
	$smarty->assign("tpl_cancel", "list_datafields");
	$smarty->assign("tpl_groups", $frmgroup);

	$smarty->display('ko_formular.tpl');
}//ko_groups_formular_datafield()






function ko_groups_rights_formular($id) {
	global $ko_path, $smarty;
	global $all_groups;

	//***Rechte auslesen:
	ko_get_admin("groups", $_SESSION["ses_userid"], $g_view, $g_new, $g_edit, $g_mod, FALSE);
	if(!$g_edit["all"]) return false;
	if(!$id || ($id == ko_get_root_id() && $_SESSION["ses_userid"] != ko_get_root_id()) ) return FALSE;

	//Daten zu diesem Login auslesen
	$login = db_select_data("ko_admin", "WHERE `id` = '$id'", "id,login,leute_id");
	ko_get_admin("groups", $id, $gv, $gn, $ge, $gm, FALSE);
	
	//Berechtigungen
	$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
	//View
	if($gv["all"]) {
		$show_view = FALSE;
	} else {
		$show_view = TRUE;

		$rights_view_avalues = $rights_view_aoutput = array();
		reset($groups);
		foreach($groups as $g) {
			if(!in_array($g["id"], array_keys($gv))) continue;
			$name = $g["name"];
			$depth = sizeof(ko_groups_get_motherline($g["id"], $all_groups));
			for($i=0; $i<$depth; $i++) $name = "&nbsp;&nbsp;".$name;
			$rights_view_avalues[] = "g".$g["id"];
			$rights_view_aoutput[] = $name;
		}
	}//if..else(gv[all])

	//New
	if($gn["all"]) {
		$show_new = FALSE;
	} else {
		$show_new = TRUE;

		$rights_new_avalues = $rights_new_aoutput = array();
		reset($groups);
		foreach($groups as $g) {
			if(!in_array($g["id"], array_keys($gn))) continue;
			$name = $g["name"];
			$depth = sizeof(ko_groups_get_motherline($g["id"], $all_groups));
			for($i=0; $i<$depth; $i++) $name = "&nbsp;&nbsp;".$name;
			$rights_new_avalues[] = "g".$g["id"];
			$rights_new_aoutput[] = $name;
		}
	}//if..else(gn[all])

	//Edit
	if($ge["all"]) {
		$show_edit = FALSE;
	} else {
		$show_edit = TRUE;

		$rights_edit_avalues = $rights_edit_aoutput = array();
		reset($groups);
		foreach($groups as $g) {
			if(!in_array($g["id"], array_keys($ge))) continue;
			$name = $g["name"];
			$depth = sizeof(ko_groups_get_motherline($g["id"], $all_groups));
			for($i=0; $i<$depth; $i++) $name = "&nbsp;&nbsp;".$name;
			$rights_edit_avalues[] = "g".$g["id"];
			$rights_edit_aoutput[] = $name;
		}
	}//if..else(ge[all])

	if($login[$id]["leute_id"]) {
		ko_get_person_by_id($login[$id]["leute_id"], $p);
		$login_name = $p["vorname"]." ".$p["nachname"]." (".$login[$id]["login"].")";
	} else {
		$login_name = $login[$id]["login"];
	}


	//Formular aufbauen
	$rowcounter = 0;
	$gc = 0;
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("form_groups_rights_login"),
															 "type" => "html",
															 "value" => $login_name,
															 );
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ");

	if($show_view) {
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_rights_rights_view"),
																 "type" => "dyndoubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_view",
																 "avalues" => $rights_view_avalues,
																 "avalue" => implode(",", $rights_view_avalues),
																 "adescs" => $rights_view_aoutput,
																 "params" => 'size="7"',
																 "nochecklist" => TRUE,
																 );
	}//if(show_view)
	else {
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_rights_rights_view"),
																 "type" => "html",
																 "value" => getLL("form_groups_all_groups")
																 );
	}
	if($show_new) {
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_rights_rights_new"),
																 "type" => "dyndoubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_new",
																 "avalues" => $rights_new_avalues,
																 "avalue" => implode(",", $rights_new_avalues),
																 "adescs" => $rights_new_aoutput,
																 "params" => 'size="7"',
																 "nochecklist" => TRUE,
																 );
	}//if(show_new)
	else {
		$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("form_groups_rights_rights_new"),
																 "type" => "html",
																 "value" => getLL("form_groups_all_groups")
																 );
	}

	if($show_edit) {
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_rights_rights_edit"),
																 "type" => "dyndoubleselect",
															 	 "js_func_add" => "double_select_add",
																 "name" => "sel_rights_edit",
																 "avalues" => $rights_edit_avalues,
																 "avalue" => implode(",", $rights_edit_avalues),
																 "adescs" => $rights_edit_aoutput,
																 "params" => 'size="7"',
																 "nochecklist" => TRUE,
																 );
	}//if(show_edit)
	else {
		$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("form_groups_rights_rights_edit"),
																 "type" => "html",
																 "value" => getLL("form_groups_all_groups")
																 );
	}


	$smarty->assign("tpl_titel", getLL("groups_rights_title"));
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_id", $id);
	$smarty->assign("tpl_action", "submit_edit_login_rights");
	$smarty->assign("tpl_cancel", "list_rights");
	$smarty->assign("tpl_groups", $frmgroup);

	$smarty->display('ko_formular.tpl');
}//ko_groups_rights_formular()






function ko_groups_list_rights() {
	global $smarty, $ko_path;

	//***Rechte auslesen:
	ko_get_admin("groups", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod, FALSE);
	if(!$group_edit["all"]) return false;

	$z_where = $z_limit = "";
	$z_where = " AND 1=1 ";

	if($_SESSION["ses_userid"] != ko_get_root_id()) {
		$z_where = " AND `id` <> '".ko_get_root_id()."' ";
	}

	$rows = db_get_count("ko_admin", "id", $z_where);
	$select_where = "WHERE".substr($z_where, 4);  //Erstes AND mit WHERE ersetzen
	$select_where .= " AND (`disabled` = '' OR `disabled` = '0')";
	$_logins = db_select_data("ko_admin", $select_where, "id,login,leute_id", "ORDER BY login ASC");
	//Find logins with group module installed
	$logins = array();
	foreach($_logins as $login) {
		if(ko_module_installed("groups", $login["id"])) {
			$logins[$login["id"]] = $login;
		} else {
			$rows--;
		}
	}

	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = $rows;
  $smarty->assign('tpl_stats', "1 - ".$stats_end." ".getLL("list_oftotal")." ".$rows);

	//Don't show page browser here
  $smarty->assign('tpl_prevlink_link', '');
  $smarty->assign('tpl_nextlink_link', '');


	//Header-Informationen
	$smarty->assign("tpl_show_3cols", TRUE);

	$show_cols = array(getLL("groups_listheader_rights_user"), getLL("groups_listheader_rights_read"), getLL("groups_listheader_rights_assign"), getLL("groups_listheader_rights_edit"));
  foreach($show_cols as $c_i => $c) {
    $tpl_table_header[$c_i]["sort"] = "";
    $tpl_table_header[$c_i]["name"] = $show_cols[$c_i];
  }
  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("show_sort", FALSE);


	//Liste fllen
	foreach($logins as $l_i => $l) {
		//Rechte fr dieses Login auslesen
		ko_get_admin("groups", $l["id"], $lv, $ln, $le, $lm, FALSE);

		//Checkbox
		$tpl_list_data[$l_i]["show_checkbox"] = TRUE;

		//Edit-Button
		if($lv["all"] && $ln["all"] && $le["all"]) {  //Wenn schon alle ALL-Rechte vergeben sind, dann nicht bearbeiten lassen
			$tpl_list_data[$l_i]["show_edit_button"] = FALSE;
		} else {
			$tpl_list_data[$l_i]["show_edit_button"] = TRUE;
			$tpl_list_data[$l_i]["alt_edit"] = getLL("groups_edit_rights");
			$tpl_list_data[$l_i]["onclick_edit"] = "javascript:set_action('edit_login_rights');set_hidden_value('id', '$l_i');this.submit";
		}

		//Delete-Button
		$tpl_list_data[$l_i]["show_delete_button"] = FALSE;

		//Index
		$tpl_list_data[$l_i]["id"] = $l_i;

		//Name
		if($l["leute_id"]) {
			ko_get_person_by_id($l["leute_id"], $p);
			$login_name = $p["vorname"]." ".$p["nachname"]." (".$l["login"].")";
		} else {
			$login_name = $l["login"];
		}
		$tpl_list_data[$l_i][1] = ko_html($login_name);

		//View-Rechte
		if($lv["all"]) {
			$tpl_list_data[$l_i][2] = getLL("groups_rights_all_groups");
		} else if(sizeof($lv) > 0) {
			$tpl_list_data[$l_i][2] = sizeof($lv)." ".getLL("groups_groups");
		}

		//new-Rechte
		if($ln["all"]) {
			$tpl_list_data[$l_i][3] = getLL("groups_rights_all_groups");
		} else if(sizeof($ln) > 0) {
			$tpl_list_data[$l_i][3] = sizeof($ln)." ".getLL("groups_groups");
		}

		//View-Rechte
		if($le["all"]) {
			$tpl_list_data[$l_i][4] = getLL("groups_rights_all_groups");
		} else if(sizeof($le) > 0) {
			$tpl_list_data[$l_i][4] = sizeof($le)." ".getLL("groups_groups");
		}

	}//foreach(groups)

	$smarty->assign("help", ko_get_help("groups", "list_rights"));

	$smarty->assign("tpl_list_title", getLL("groups_rights_list_title"));
	$smarty->assign('tpl_list_cols', array(1, 2, 3, 4));
  $smarty->assign('tpl_list_data', $tpl_list_data);
	$smarty->display('ko_list.tpl');
}//ko_groups_list_rights()





/**
  * Fragt vor dem Lschen einer Rolle nochmals genau nach
	*/
function ko_delete_role($id) {
	if(!$id) return;

	print '<div style="padding:10px; background-color:#aa5500; color:white; font-weight:900; display:block;">';
	print getLL("groups_delete_role_confirm1").'<br />';
	print getLL("groups_delete_role_confirm2").'<br /><br />';
	print getLL("groups_delete_role_confirm3").'<br />';
	print '</div>';
	print '<input type="submit" name="ja" value="'.getLL("yes").'" onclick="javascript:'."set_action('do_delete_role');set_hidden_value('id', '$id');".'" />&nbsp;&nbsp;&nbsp;';
	print '<input type="submit" name="nein" value="'.getLL("no").'" onclick="javascript:'."set_action('list_roles');".'" />';
}//ko_delete_role()







/**
  * berprft bestehende Gruppeneinteilungen aller Leute und bereinigt Probleme mit nicht mehr vorhandenen Gruppen/Rollen
	*/
function ko_update_groups_and_roles() {
	global $all_groups;

	//Alle Gruppen und Rollen
	$all_group_ids = array_keys($all_groups);
	ko_get_grouproles($all_roles);
	$all_role_ids = array_keys($all_roles);

	//Durch alle Personen durchgehen
	$leute = db_select_data("ko_leute", "WHERE `groups` <> '' AND deleted = 0");
	foreach($leute as $p) {
		$groups = explode(",", $p["groups"]);
		foreach($groups as $g_i => $group) {
			if(!$group) continue;
			$g = ko_groups_decode($group, "group_id");
			$r = ko_groups_decode($group, "role_id");
			//current motherline
			$m = ko_groups_decode($group, "mother_line");
			//correct motherline
			$motherline = ko_groups_get_motherline($g, $all_groups);

			if(!in_array($g, $all_group_ids)) {  //Group has been deleted
				$g = "";
			} else if(array_unique(array_merge($motherline, $m)) != $m) {  //Fix Parent-Relationsships (group or a group in the motherline has been moved)
				$m = $motherline;
			}
			if(!in_array($r, $all_role_ids)) {  //Rolle gelscht
				$groups[$g_i] = "g".implode(":g", $m).":g".$g;
				$r = "";
			}
			//Neuen Wert zusammenbauen
			if($g) {
				$groups[$g_i]  = sizeof($m) > 0 ? "g".implode(":g", $m).":" : "";
				$groups[$g_i] .= "g$g";
				$groups[$g_i] .= $r ? ":r$r" : "";
			} else {
				unset($groups[$g_i]);
			}
		}//foreach(groups as g_i => group)

		//Falls gendert, so in DB speichern
		$groups = array_unique($groups);
		if(implode(",", $groups) != $p["groups"]) {
			db_update_data("ko_leute", "WHERE `id` = '".$p["id"]."'", array("groups" => implode(",", $groups)));
		}

	}//foreach(leute as p)
}//ko_update_groups_and_roles()





/**
  * Stellt sicher, dass View-Rechte auf der ganzen Mutterlinie vorhanden sind, wenn Rechte fr eine tiefliegende Gruppe vorhanden sind
	* Wird nach submit_group_edit aufgerufen
	*/
function ko_update_groups_rights($gid) {
	global $all_groups;

	//Logins whlen, die View-Rechte bentigen
	$logins = array_unique(array_merge(explode(",", $all_groups[$gid]["rights_view"]), explode(",", $all_groups[$gid]["rights_new"]), explode(",", $all_groups[$gid]["rights_edit"])));

	//Ganze Mutterlinie durchgehen
	$motherline = ko_groups_get_motherline($gid, $all_groups);
	foreach($motherline as $id) {
		$do_update = FALSE; $add_rights = array();
		$group = $all_groups[$id];
		$rights_view = explode(",", $group[$id]["rights_view"]);
		foreach($logins as $login) {
			if(!$login) continue;
			ko_get_login($login, $l);
			if($l["groups_admin"] < 1 && !in_array($login, $rights_view)) {  //Login hat weder globale noch lokale View-Rechte
				$do_update = TRUE;
				$add_rights[] = $login;
			}
		}//foreach(logins as login)

		//Falls ntig, view-Rechte fr diese Gruppen anpassen, damit alle Logins View-Rechte haben, die in darunterliegende Gruppen Rechte haben
		if($do_update) {
			$new_array = array_merge($rights_view, $add_rights);
			foreach($new_array as $i => $v) if(!$v) unset($new_array[$i]);
			$new_value = implode(",", $new_array);
			db_update_data("ko_groups", "WHERE `id` = '$id'", array("rights_view" => $new_value));
		}//if(do_update)
	}//foreach(motherline as id)
}//ko_update_groups_rights()



/**
  *
	*/
/*
function ko_update_groups_datafields($gid, &$datafields) {
	global $all_groups;

	//get all kid groups
	$kids = db_select_data("ko_groups", "WHERE `pid` = '$gid'";
	foreach($kids as $kid) {
		ko_update_groups_datafields($kid["id"], $datafields);
	}
	//get current datafields
	$group = db_select_data("ko_groups", "WHERE `id` = '$gid'", "", "", "", TRUE);
	//add datafields from above
	$new_df = implode(",", array_unique(array_merge(explode(",", $group["datafields"]), explode(",", $datafields))));
	print "group: ".$group["id"].": ".$new_df."<br />";
	db_update_data("ko_groups", "WHERE `id` = '$gid'", array("datafields" => $new_df));
}//ko_update_groups_datafields()
*/



/**
  * Displays settings
	*/
function ko_groups_settings() {
	global $smarty, $ko_path;

	//build form
	$gc = 0;
	$rowcounter = 0;
	$value = ko_get_userpref($_SESSION["ses_userid"], "groups_show_top");
	$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("groups_settings_show_top"),
			"type" => "checkbox",
			"name" => "chk_groups_show_top",
			"value" => 1,
			"params" => ($value == 1 ? 'checked="checked"' : ''),
			);

	//display the form
	$smarty->assign("tpl_titel", getLL("groups_settings_form_title"));
	$smarty->assign("tpl_submit_value", getLL("save"));
	$smarty->assign("tpl_action", "submit_groups_settings");
	$smarty->assign("tpl_cancel", "list_groups");
	$smarty->assign("tpl_groups", $frmgroup);

	$smarty->display('ko_formular.tpl');
}//ko_groups_settings()



/**
 * Export address to EZMLM mailinglist
 * All members of the given group will be added to the appropriate ezmlm mailinglist set for this group
 */
function ko_export_group_to_ezmlm($gid) {
	$group = db_select_data("ko_groups", "WHERE `id` = '$gid' ".ko_get_groups_zwhere(), "*", "", "", TRUE);
	if(!check_email($group["ezmlm_list"]) || !check_email($group["ezmlm_moderator"])) return FALSE;

	$emails = array();
	$persons = db_select_data("ko_leute", "WHERE `groups` REGEXP 'g$gid'", "id,email");
	foreach($persons as $person) {
		if(check_email($person["email"])) $emails[] = strtolower($person["email"]);
	}
	$emails = array_unique($emails);
	foreach($emails as $email) {
		ko_ezmlm_subscribe($group["ezmlm_list"], $group["ezmlm_moderator"], $email);
	}
}//ko_export_group_to_ezmlm()

?>
