<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

$ko_path = "../";
$ko_menu_akt = "ical";

include_once($ko_path."inc/ko.inc");
include_once($ko_path."daten/inc/daten.inc");


$auth = FALSE;
if(!isset($_GET["ko_guest"])) {
	if (!isset($_SERVER['PHP_AUTH_USER'])) {
		header("WWW-Authenticate: Basic realm=\"kOOL\"");
		header("HTTP/1.0 401 Unauthorized");
	} else {
		$user = format_userinput($_SERVER["PHP_AUTH_USER"], "text", TRUE, 32);
		$pw = md5($_SERVER["PHP_AUTH_PW"]);
		$result = $db->query("SELECT id,login FROM ko_admin WHERE `login` = '$user' AND `password` = '$pw'");
		if($result->numRows() == 1) {
			$row = $result->fetchRow(DB_FETCHMODE_ASSOC);
			if($row["login"] == $user) {
				$auth = TRUE;
				$_SESSION["ses_username"] = $row["login"];
				$_SESSION["ses_userid"]   = $row["id"];
			}
		}
	}
}
if(!$auth) {
	//header("HTTP/1.0 404 Not Found");
	//exit;
	$_SESSION["ses_username"] = "ko_guest";
	$_SESSION["ses_userid"] = ko_get_guest_id();
}


if(!ko_module_installed("daten")) {
	header("HTTP/1.0 404 Not Found");
}
//***Rechte auslesen:
list($item_view, $item_new, $item_edit, $item_mod) = ko_get_admin("daten", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);


//get itemset named "ical" if there is one (but not for ko_gueset)
$use_itemset = FALSE;
if($_SESSION["ses_username"] != "ko_guest") {
	$itemsets = ko_get_userpref($_SESSION["ses_userid"], "", "daten_itemset");
	foreach($itemsets as $itemset) {
		if(strtolower($itemset["key"]) == "ical") {
			$use_itemset = explode(",", $itemset["value"]);
		}
	}
}

//get all event groups
ko_get_eventgruppen($eventgroups);
$use_eg = array();
foreach($eventgroups as $eg) {
	if($use_itemset) {
		if(in_array($eg["id"], $use_itemset) && $group_view[$eg["id"]]) $use_eg[] = $eg["id"];
	} else {
		if($group_view[$eg["id"]]) $use_eg[] = $eg["id"];
	}
}
//apply filter
apply_daten_filter($z_where, $z_limit, 'today', "immer", $use_eg);
//get events
ko_get_events($events, $z_where);

//build ical file in a string
$ical  = "BEGIN:VCALENDAR\r\n";
$ical .= "VERSION:2.0\r\n";
$ical .= "CALSCALE:GREGORIAN\r\n";
$ical .= "METHOD:PUBLISH\r\n";
$ical .= 'PRODID:-//'.str_replace('/', '', $HTML_TITLE)."//www.churchtool.org//DE\r\n";
foreach($events as $event) {
	//url
	if($event['url']) $url = $event['url'];
	else if($eventgroups[$event['eventgruppen_id']]['url']) $url = $eventgroups[$event['eventgruppen_id']]['url'];
	else $url = '';
	//build ics string
	$ical .= "BEGIN:VEVENT\r\n";
	$ical .= 'DTSTAMP:'.strftime('%Y%m%dT%H%M%S', time())."\r\n";
	$base_url = $_SERVER['SERVER_NAME'] ? $_SERVER['SERVER_NAME'] : $BASE_URL;
	$ical .= 'UID:e'.$event['id'].'@'.$base_url."\r\n";
	if($event['startzeit'] == '00:00:00' && $event['endzeit'] == '00:00:00') {  //daily event
		$ical .= 'DTSTART:'.strftime('%Y%m%d', strtotime($event['startdatum']))."\r\n";
		$ical .= 'DTEND:'.strftime('%Y%m%d', strtotime(add2date($event['enddatum'], 'tag', 1, TRUE)))."\r\n";
	} else {
		$ical .= 'DTSTART:'.date_convert_timezone(($event['startdatum'].' '.$event['startzeit']), 'UTC')."\r\n";
		$ical .= 'DTEND:'.date_convert_timezone(($event['enddatum'].' '.$event['endzeit']), 'UTC')."\r\n";
	}
	$ical .= 'SUMMARY:'.utf8_encode($event['eventgruppen_name'].($event['kommentar'] ? (': '.$event['kommentar']) : '') )."\r\n";
	if($_SESSION['ses_username'] != 'ko_guest') $ical .= 'DESCRIPTION:'.utf8_encode($event['kommentar2'])."\r\n";
	$ical .= 'LOCATION:'.utf8_encode($event['room'])."\r\n";
	if($url) $ical .= 'URL:'.utf8_encode($url)."\r\n";
	$ical .= "END:VEVENT\r\n";
}
$ical .= "END:VCALENDAR\r\n";


//Output
if (isset($_SERVER["HTTP_USER_AGENT"]) && strpos($_SERVER["HTTP_USER_AGENT"], "MSIE")) {
	// IE cannot download from sessions without a cache
	header("Cache-Control: public");
	// q316431 - Don't set no-cache when over HTTPS
	if (	!isset($_SERVER["HTTPS"]) || $_SERVER["HTTPS"] != "on") {
		header("Pragma: no-cache");
	}
}
else {
	header("Cache-Control: no-cache, must-revalidate");
	header("Pragma: no-cache");
}
header('Content-Type: text/calendar', TRUE);
header('Content-Disposition: attachment; filename="kOOL.ics"');
header("Content-Length: ".strlen($ical));
print $ical;
?>
