<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

//Session-ID verlangen
if(!isset($_GET["sesid"])) exit;

//Session laden
if(FALSE === session_id($_GET["sesid"])) exit;
if(FALSE === session_start()) exit;

//Send headers to ensure latin1 charset
header('Content-Type: text/html; charset=ISO-8859-1');

error_reporting(0);
$ko_path = "../";
require_once($ko_path."inc/ko.inc");

//Smarty-Templates-Engine laden
require_once($BASE_PATH."inc/smarty.inc");

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);


if(isset($_GET) && isset($_GET["action"])) {
	$action = format_userinput($_GET["action"], "alphanum");
	switch($action) {
		case "opensm":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			//Bestehende SM dieses Benutzers holen
			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));
			if(in_array($id, $open)) continue;

			//Geschlossenes ffnen
			$new_open = implode(",", $open);
			$new_closed = "";
			foreach($closed as $c) {
				if($c == $id) {
					$new_open .= ($new_open == "") ? $c : ",$c";
				} else {
					$new_closed .= $c.",";
				}
			}
			//Werte neu speichern
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed", substr($new_closed, 0, -1));
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos, $new_open);

			//Neuen HTML-Code fr SM ausgeben
			eval("\$r=submenu_".$sm_module.'($id, $pos, "open", 2);');
			print $r;
		break;


		case "closesm":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			//Bestehende SM dieses Benutzers holen
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));
			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			if(in_array($id, $closed)) continue;

			//Offenes schliessen
			$new_closed = implode(",", $closed);
			$new_open = "";
			foreach($open as $c) {
				if($c == $id) {
					$new_closed .= ($new_closed == "") ? $c : ",$c";
				} else {
					$new_open .= $c.",";
				}
			}
			//Werte neu speichern
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed", $new_closed);
			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos, substr($new_open, 0, -1));

			//Neuen HTML-Code fr SM ausgeben
			eval("\$r=submenu_".$sm_module.'($id, $pos, "closed", 2);');
			print $r;
		break;



		case "movesmup":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));

			//Zustand finden
			if(in_array($id, $closed)) {  //Falls geschlossen
				$state = "_closed";
				$array = $closed;
			}
			if(in_array($id, $open)) {  //Falls offen
				$state = "";
				$array = $open;
			}

			//Index finden des zu verschiebenden Submenus
			for($i = 0; $i<sizeof($array); $i++) {
				if($array[$i] == $id) $index = $i;
			}
			//if($index == 0) continue;

			//Submenu tauschen (resp. nach oben schieben)
			$temp = $array[($index-1)];
			$array[($index-1)] = $array[$index];
			$array[$index] = $temp;

			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos.$state, implode(",", $array));
			$_SESSION["submenu_".$pos.$state] = implode(",", $array);

			//Neuen HTML-Code fr SM ausgeben
			print "main_".$pos."@@@";
			print ko_get_submenu_code($sm_module, $pos);
		break;


		case "movesmdown":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$id = format_userinput($_GET["id"], "js");
			$sm_module = format_userinput($_GET["mod"], "js");
			if(!in_array($sm_module, $MODULES)) return FALSE;

			$closed = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos."_closed"));
			$open = explode(",", ko_get_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos));

			//Zustand finden
			if(in_array($id, $closed)) {  //Falls geschlossen
				$state = "_closed";
				$array = $closed;
			}
			if(in_array($id, $open)) {  //Falls offen
				$state = "";
				$array = $open;
			}

			//Index finden des zu verschiebenden Submenus
			for($i = 0; $i<sizeof($array); $i++) {
				if($array[$i] == $id) $index = $i;
			}
			if($index == (sizeof($array)-1)) continue;

			//Submenu tauschen (resp. nach oben schieben)
			$temp = $array[($index+1)];
			$array[($index+1)] = $array[$index];
			$array[$index] = $temp;

			ko_save_userpref($_SESSION["ses_userid"], "submenu_".$sm_module."_".$pos.$state, implode(",", $array));
			$_SESSION["submenu_".$pos.$state] = implode(",", $array);

			//Neuen HTML-Code fr SM ausgeben
			print "main_".$pos."@@@";
			print ko_get_submenu_code($sm_module, $pos);
		break;


		case "savenote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

			if($_GET["notename"] == "" && $_GET["selnote"]) {  //Falls keine Name angegeben, dann die aktuelle Notiz berschreiben...
	      $save_key = format_userinput($_GET["selnote"], "alphanum++");
	    } else if($_GET["notename"]) {  //... sonst als neue Notiz speichern
	      $save_key = format_userinput($_GET["notename"], "alphanum++");
	    } else {
	      continue;
	    }
						    
	    ko_save_userpref($_SESSION["ses_userid"], $save_key, format_userinput($_GET["note"], "text"), "notizen");
	    $_SESSION["show_notiz"] = $save_key;

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "opennote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

      $save_key = format_userinput($_GET["selnote"], "alphanum++");
			if(!$save_key) continue;

			$_SESSION["show_notiz"] = $save_key;

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "deletenote":
			//Guest kann Layout nicht ndern
			if($_SESSION["ses_userid"] == ko_get_guest_id()) return FALSE;

			//bergebene Daten auslesen
			$pos = format_userinput($_GET["pos"], "alpha");
			if(!in_array($pos, array("left", "right"))) return FALSE;
			$sm_module = format_userinput($_GET["mod"], "js");

      $del_key = format_userinput($_GET["selnote"], "alphanum++");
			if(!$del_key) continue;

			ko_delete_userpref($_SESSION["ses_userid"], $del_key, "notizen");
	    $_SESSION["show_notiz"] = "";

			//Neuen HTML-Code fr SM ausgeben
			print submenu("gsm_notizen", $pos, "", 2, $sm_module);  //State is always open when saving
		break;


		case "exporttomylist":
			$ids = format_userinput(str_replace('@', ',', $_GET['ids']), 'intlist');
			$_SESSION['my_list'] = array();
			foreach(explode(',', $ids) as $id) {
				if($id) $_SESSION['my_list'][$id] = $id;
			}
			ko_save_userpref($_SESSION['ses_userid'], 'leute_my_list', serialize($_SESSION['my_list']));

			print 'mailmerge_infobox@@@';
			print getLL('leute_mailmerge_mylist_export_ok');
		break;
	}//switch(action);
}//if(GET[action])
?>
