<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/


//KG-Modul einfgen, damit es nicht manuell eingefgt werden muss
if(ko_module_installed("kg") && file_exists($ko_path."leute/inc/kg.inc"))
  include_once($ko_path."leute/inc/kg.inc");


//Define basic chart types for leute module (may be extended by plugins)
$LEUTE_CHART_TYPES = array("roles", "subgroups", "age_bar", "lastchange", "age_pie", "birthday_months", "sex", "famfunction", "city", "zip", "country", "rotateams");

$mailmerge_signature_ext = array('gif', 'jpg', 'jpeg', 'png', 'pdf');


function ko_formular_leute($mode, $id=0) {
	global $smarty, $ko_path, $db;
	global $LEUTE_LAYOUT, $LEUTE_EXCLUDE, $LEUTE_ENUMPLUS, $LEUTE_TEXTSELECT;
	global $kg_view, $kg_new, $group_new;
	global $g_view, $g_new, $g_edit;
	global $FAMILIE_EXCLUDE, $COLS_LEUTE_UND_FAMILIE;
	global $js_calendar;

	if($mode == "edit") {
		ko_get_person_by_id($id, $person);
		if(!$person["id"] || $person["deleted"] == "1") return FALSE;
	}

	//Datenbank-Spalten auslesen
	$leute_cols = db_get_columns("ko_leute");
	foreach($leute_cols as $c_i => $c) {
		if(!in_array($c["Field"], $LEUTE_EXCLUDE)) {
			$endpos = strpos($c["Type"], "(") ? strpos($c["Type"], "(") : strlen($c["Type"]);
			$endpos2 = strpos($c["Type"], ")") ? strpos($c["Type"], ")") : strlen($c["Type"]);
			$input_type[$c["Field"]] = substr($c["Type"], 0, $endpos);
			$input_size[$c["Field"]] = ($endpos && $endpos2) ? substr($c["Type"], ($endpos+1), ($endpos2-$endpos-1)) : 0;
		}
	}

	//get the cols, for which this user has edit-rights (saved in allowed_cols[edit])
	$allowed_cols = ko_get_leute_admin_spalten($_SESSION["ses_userid"], "all");


	//Familien-Daten
	if(!is_array($allowed_cols["view"]) || in_array("famid", $allowed_cols["view"])) {
		ko_get_familien($familien);

		//Familien-Select
		$fam_sel["values"][] = "0";
		$fam_sel["descs"][] = getLL("form_leute_none");
		foreach($familien as $f) {
			$fam_sel["values"][] = $f["famid"];
			$fam_sel["descs"][] = $f["id"];
		}

		//Familien-Funktion
		$ffs = db_get_enums_ll("ko_leute", "famfunction");
		foreach($ffs as $f => $ll) {
			$function_sel["values"][] = $f;
			$function_sel["descs"][] = $ll;
		}
		//Aktive Funktion selektieren
		$function_sel["sel"] = $person["famfunction"];

		//Familie Ja oder Nein
		if($person["famid"] != 0) {
			$smarty->assign("fam", TRUE);

			//Familien-ID
			$familie = ko_get_familie($person["famid"]);
			$smarty->assign("fam_id", $familie["id"]);

			//Aktive Familie selektieren
			$fam_sel["sel"] = $person["famid"];
		}//if(person[famid] != 0)

		else {
			$smarty->assign("fam", FALSE);
		}
		$smarty->assign("fam_sel", $fam_sel);
		$smarty->assign("famfunction", $function_sel);

		//Familien-Felder (fr edit und neu)
		$familie_col_name = ko_get_family_col_name();
		$familien_cols = db_get_columns("ko_familie");
		$fc = 0;
		foreach($familien_cols as $col_) {
			$col = $col_["Field"];
			$type = $col_["Type"];
			if(!in_array($col, array_merge($FAMILIE_EXCLUDE, $COLS_LEUTE_UND_FAMILIE))) {
				$cols_familie[$fc]["desc"] = $familie_col_name[$col] ? $familie_col_name[$col] : $col;
				$cols_familie[$fc]["name"] = "input_".$col;
				if($mode == "edit" && $person["famid"] != 0) {
					$cols_familie[$fc]["value"] = $familie[$col];
				} else {
					$cols_familie[$fc]["value"] = "";
				}
				if(substr($type, 0, 4) == "enum") {
					$cols_familie[$fc]["type"] = "select";
					$ffs = db_get_enums_ll("ko_familie", $col);
					foreach($ffs as $f => $ll) {
						$cols_familie[$fc]["values"][] = $f;
						$cols_familie[$fc]["descs"][] = $ll;
					}
				} else {
					$cols_familie[$fc]["type"] = "text";
				}
				$fc++;
			}
		}//foreach(familien_cols)
		$smarty->assign("cols_familie", $cols_familie);
		if(is_array($allowed_cols["edit"]) && !in_array("famid", $allowed_cols["edit"])) $smarty->assign("fam_params", ' disabled="disabled" ');
	}//if(in_array(famid, allowed_cols[view]))
	else {
		$smarty->assign("hide_fam", TRUE);
	}



	//Spalten-Namen
	$leute_col_name = ko_get_leute_col_name(FALSE, FALSE, "all");

	$row_counter = 0;
	foreach($LEUTE_LAYOUT as $ll) {
		$inputs = array();
		$add_inputs = NULL; $add_counter = 0;
		$col_counter = 0;

		foreach($ll as $l) {

			if($l == "---") {  //Trennlinie
				$inputs[0]["desc"] = "  ";  //wird gelscht
				$inputs[0]["type"] = "   ";
			}

			else if(substr($l, 0, 8) == "MODULE::") {
				$module = substr($l, 8);
				switch($module) {

					/* KG-Modul */
					case "kg":
						if(!ko_module_installed("kg") || !$kg_view) continue;
						//Kleingruppen-Select
						$inputs[$col_counter]["desc"] = getLL("kota_ko_leute_kg");
						$inputs[$col_counter]["type"] = "doubleselect";
						$inputs[$col_counter]["name"] = "input_kg";
						ko_get_kleingruppen($kgs);
						foreach($kgs as $kg) {
							$inputs[$col_counter]["values"][] = $kg["id"];
							$inputs[$col_counter]["descs"][] = ko_html($kg["name"]);
						}
						//Bestehende Werte einfllen
						foreach(explode(",", $person["kg"]) as $kg) {
							$inputs[$col_counter]["avalues"][] = $kg;
							$inputs[$col_counter]["adescs"][] = $kgs[$kg]["name"];
						}
						$inputs[$col_counter]["avalue"] = $person["kg"];
						if($kg_new) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}

						//Kleingruppen-Leiter-Select
						$col_counter++;
						$inputs[$col_counter]["desc"] = getLL("kota_ko_leute_kg_leiter");
						$inputs[$col_counter]["type"] = "doubleselect";
						$inputs[$col_counter]["name"] = "input_kg_leiter";
						$inputs[$col_counter]["values"] = $inputs[$col_counter-1]["values"];
						$inputs[$col_counter]["descs"] = $inputs[$col_counter-1]["descs"];
						foreach(explode(",", $person["kg_leiter"]) as $kg_leiter) {
							$inputs[$col_counter]["avalues"][] = $kg_leiter;
							$inputs[$col_counter]["adescs"][] = $kgs[$kg_leiter]["name"];
						}
						$inputs[$col_counter]["avalue"] = $person["kg_leiter"];
						if($kg_new) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}
					break;

					
					/* KG-Seit-Modul */
					case "kg_seit":
						if(!ko_module_installed("kg") || !$kg_view) continue;
						//Dabei in Kleingruppen seit
						$inputs[$col_counter]["desc"] = getLL("form_leute_kg_since");
						$inputs[$col_counter]["type"] = "varchar";
						$inputs[$col_counter]["name"] = "input_kg_seit";
						$inputs[$col_counter]["value"] = $person["kg_seit"];
						if($kg_new) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}

						//Dabei als Kleingruppen-Leiter seit
						$col_counter++;
						$inputs[$col_counter]["desc"] = getLL("form_leute_kg_leader_since");
						$inputs[$col_counter]["type"] = "varchar";
						$inputs[$col_counter]["name"] = "input_kgleiter_seit";
						$inputs[$col_counter]["value"] = $person["kgleiter_seit"];
						if($kg_new) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}
						
					break;


					/* Dienste */
					case "dienste":
						ko_get_admin("dp", $_SESSION["ses_userid"], $d_view, $d_new, $d_edit, $d_mod);
						if(!ko_module_installed("dp") || !$d_view) continue;
						//Dienst-Select
						$inputs[$col_counter]["desc"] = getLL("leute_team");
						$inputs[$col_counter]["type"] = "doubleselect";
						$inputs[$col_counter]["name"] = "input_dienst";
						//Select mit allen Diensten
						ko_get_dienste($dienste);
						foreach($dienste as $dienst) {
							if(!$d_edit[$dienst["id"]]) continue;
							$inputs[$col_counter]["values"][] = $dienst["id"];
							$inputs[$col_counter]["descs"][] = ko_html($dienst["name"]);
						}
						//Select mit zugewiesenen Dienste
						$adienste = explode(",", $person["dienst"]);
						foreach($adienste as $d) {
							if(!$d || !$d_view[$d]) continue;
							ko_get_dienste($dienst_, $d);
							$dienst = $dienst_[$d];
							$inputs[$col_counter]["avalues"][] = $dienst["id"];
							$inputs[$col_counter]["adescs"][] = ko_html($dienst["name"]);
						}
						$inputs[$col_counter]["avalue"] = implode(",", $inputs[$col_counter]["avalues"]);

						if($d_edit) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}


						$col_counter++;
						//Dienstleiter-Select
						$inputs[$col_counter]["desc"] = getLL("leute_team_leader");
						$inputs[$col_counter]["type"] = "doubleselect";
						$inputs[$col_counter]["name"] = "input_dienstleiter";
						//Select mit allen Diensten
						ko_get_dienste($dienste);
						foreach($dienste as $dienst) {
							if(!$d_mod[$dienst["id"]]) continue;
							$inputs[$col_counter]["values"][] = $dienst["id"];
							$inputs[$col_counter]["descs"][] = ko_html($dienst["name"]);
						}
						//Select mit zugewiesenen Dienste
						$adienste = explode(",", $person["dienstleiter"]);
						foreach($adienste as $d) {
							if(!$d || !$d_mod[$d]) continue;
							ko_get_dienste($dienst_, $d);
							$dienst = $dienst_[$d];
							$inputs[$col_counter]["avalues"][] = $dienst["id"];
							$inputs[$col_counter]["adescs"][] = ko_html($dienst["name"]);
						}
						$inputs[$col_counter]["avalue"] = implode(",", $inputs[$col_counter]["avalues"]);

						if($d_mod) {
							$inputs[$col_counter]["params"] = '';
						} else {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						}
					break;  //Dienste


					/* Groups-Modul */
					case "groups":
						if(!ko_module_installed("groups")) continue;
						//Gruppen-Select der aktiven Gruppen
						$inputs[$col_counter]["desc"] = getLL("groups");
						$inputs[$col_counter]["type"] = "groupselect";
						$inputs[$col_counter]["name"] = "input_groups";
						$inputs[$col_counter]["colspan"] = 'colspan="2"';
						$inputs[$col_counter]["onclick_2_add"] = 'do_update_df_form(\''.$id.'\',\''.session_id().'\');';
						$inputs[$col_counter]["onclick_del_add"] = 'do_update_df_form(\''.$id.'\',\''.session_id().'\');';
						//Nur gltige IDs auslesen, Rest wird durch js-groupmenu.inc erledigt
						//Hier die alten Gruppen immer ausblenden
						$orig_value = ko_get_setting("show_passed_groups");
						ko_set_setting("show_passed_groups", 0);
						ko_get_groups($groups, ko_get_groups_zwhere());
						ko_set_setting("show_passed_groups", $orig_value);
						$valid_ids = array();
						$allow_assign = FALSE;
						foreach($groups as $group) {
							if($g_view[$group["id"]]) {
								$valid_ids[] = $group["id"];
							}
							if($g_new[$group["id"]]) $allow_assign = TRUE;
						}
						$smarty->assign("allow_assign", $allow_assign);
						//Bestehende Werte einfllen
						$do_datafields = NULL;
						foreach(explode(",", $person["groups"]) as $group) {
							if($group) {
								$group_id = ko_groups_decode($group, "group_id");
								$group_desc = ko_groups_decode($group, "group_desc_full");
								if(in_array($group_id, $valid_ids)) {
									//Prepare for sorting
									$assigned_groups[$group] = $group_desc;
									$sort_assigned_groups[$group_desc] = $group;
									//prepare datafields
									if($group["datafields"]) $do_datafields[] = array_merge($groups[$group_id], array("desc_full" => $group_desc, "group_id" => $group_id));
								}
							}//if(group)
						}//foreach(person[groups])

						//Sort assigned groups alphabetically
						ksort($sort_assigned_groups);
						foreach($sort_assigned_groups as $group) {
							$inputs[$col_counter]["avalues"][] = $group;
							$inputs[$col_counter]["adescs"][] = $assigned_groups[$group];
						}

						$inputs[$col_counter]["avalue"] = implode(",", $inputs[$col_counter]["avalues"]);
						if(sizeof($valid_ids) == 0) {
							$inputs[$col_counter]["params"] = 'disabled="disabled"';
						} else {
							$inputs[$col_counter]["params"] = '';
						}



						//Group datafields for selected groups
						$html = ko_groups_render_group_datafields($do_datafields, $id);

						$add_inputs[$add_counter][0]["desc"] = getLL("leute_group_datafield");
						$add_inputs[$add_counter][0]["type"] = "html";
						$add_inputs[$add_counter][0]["colspan"] = 'colspan="2"';
						$add_inputs[$add_counter][0]["value"] = $html;
						$add_counter++;



						//Groups-History
						$col_counter = 0;
						$add_inputs[$add_counter][$col_counter]["desc"] = getLL("leute_group_bisher");
						$add_inputs[$add_counter][$col_counter]["type"] = "html";
						$add_inputs[$add_counter][$col_counter+1]["desc"] = "";
						$add_inputs[$add_counter][$col_counter+1]["type"] = "html";
						//get rights for all groups
						$orig_value = ko_get_setting("show_passed_groups");
						if($orig_value != 1) {
							ko_set_setting("show_passed_groups", 1);
							ko_get_admin("groups", $_SESSION["ses_userid"], $g_all_view, $g_all_new, $g_all_edit, $g_all_mod);
							ko_set_setting("show_passed_groups", $orig_value);
						} else {
							$g_all_view = $g_view;
						}
						foreach(explode(",", $person["groups"]) as $group) {
							if(!$group) continue;
							$g = ko_groups_decode($group, "group");
							$g_id = ko_groups_decode($group, "group_id");
							if($g["stop"] != "0000-00-00" && (int)str_replace("-", "", $g["stop"]) < (int)strftime("%Y%m%d", time()) && $g_all_view[$g_id]) {
								$history_groups[$g_id] = $group;
								$history_groups_sort[$g_id] = $g["start"];
							}
						}
						arsort($history_groups_sort);
						$num = 0; $history = array();
						foreach($history_groups_sort as $gid => $start) {
							$history[$num] .= '<div style="font-size:x-small;color:#444;" title="'.ko_groups_decode($history_groups[$gid], "group_description").'">';
							$history[$num] .= ko_groups_decode($history_groups[$gid], "group_desc_full");
							$history[$num] .= "</div>";
							$num++;
						}

						$col = 0;
						foreach($history as $h) {
							$add_inputs[$add_counter][$col]["value"] .= $h;
							$col = $col ? 0 : 1;
						}
					break;

					//Show a save button
					case "save":
						$inputs[$col_counter]["type"] = "_save";
					break;

				}//switch(module)
			}//if(MODULE)
			
			else {
				if(is_array($allowed_cols) && sizeof($allowed_cols) > 0) {
					if((is_array($allowed_cols["view"]) && !in_array($l, $allowed_cols["view"])) && (!is_array($allowed_cols["edit"]) || is_array($allowed_cols["edit"]) && !in_array($l, $allowed_cols["edit"]))) continue;
					if(is_array($allowed_cols["edit"]) && !in_array($l, $allowed_cols["edit"])) $inputs[$col_counter]["params"] = ' disabled="disabled" ';
				}

				//Input-Type und -Namen speichern
				$inputs[$col_counter]["desc"] = $leute_col_name[$l];
				if(in_array($l, $COLS_LEUTE_UND_FAMILIE)) $inputs[$col_counter]["fam_feld"] = TRUE;
				$inputs[$col_counter]["type"] = $input_type[$l];
				$inputs[$col_counter]["name"] = "input_".$l;
				
				//Bei Edit: Bisherigen Wert einfllen:
				if($mode == "edit") {
					if($input_type[$l] == "date") {
						$inputs[$col_counter]["value"] = ko_html(sql2datum($person[$l]));
					} else if($input_type[$l] == "enum") {  //Don't apply ko_html to enum values, as these must not get changed
						$inputs[$col_counter]["value"] = $person[$l];
					} else {
						$inputs[$col_counter]["value"] = ko_html($person[$l]);
					}
				//Bei Neu: Die _POST-Werte wieder einfllen
				} else if($mode == "neu") {
					if($_POST["action"] == "submit_neue_person") {
						$inputs[$col_counter]["value"] = ko_html($_POST["input_".$l]);
					}
				}

				//Spezial-Optionen zu einzelnen Typen verarbeiten
				switch($input_type[$l]) {

					case "varchar":  //Textfeld
					case "mediumint":
					case "smallint":
						//Textfeld, das aber als Select mit zustzlichem Textfeld angezeigt werden soll
						if(in_array($l, $LEUTE_TEXTSELECT)) {
							$inputs[$col_counter]["type"] = "enum";

							//Leere Option
							$inputs[$col_counter]["values"][] = "";
							$inputs[$col_counter]["descs"][] = "";

							$c = db_select_distinct("ko_leute", $l, "", "", TRUE);
							foreach($c as $cc) {
								$inputs[$col_counter]["values"][] = $cc;
								$inputs[$col_counter]["descs"][] = $cc;
							}
							$inputs[$col_counter]["value"] = $person[$l];

							//Allfllige doppelte Leereintrge rausholen
							$inputs[$col_counter]["values"] = array_unique($inputs[$col_counter]["values"]);
							$inputs[$col_counter]["descs"] = array_unique($inputs[$col_counter]["descs"]);

							//Zustzliches Textfeld erstellen
							$inputs[++$col_counter]["desc"] = getLL("form_textplus");
							$inputs[$col_counter]["type"] = "varchar";
							$inputs[$col_counter]["name"] = "input_".$l."_2";
							$inputs[$col_counter]["params"] .= $inputs[($col_counter-1)]["params"];  //Copy params from select (e.g. disabled)
							$inputs[$col_counter]["params"] .= 'maxlength="'.$input_size[$l].'"';
						}//if(in_array(l, LEUTE_TEXTSELECT))
						else {
							$inputs[$col_counter]["params"] .= 'maxlength="'.$input_size[$l].'"';
						}
					break;

					case "enum":  //Select
						$enum_values = explode(",", str_replace("'", "", $input_size[$l]));
						foreach($enum_values as $ev) {
							$inputs[$col_counter]["values"][] = $ev;
							$ll_value = getLL("ko_leute_".$l."_".$ev);
							$inputs[$col_counter]["descs"][] = $ll_value ? $ll_value : $ev;
						}
						if(in_array($l, $LEUTE_ENUMPLUS)) {
							$inputs[++$col_counter]["desc"] = getLL("form_textplus");
							$inputs[$col_counter]["type"] = "varchar";
							$inputs[$col_counter]["name"] = "input_".$l."_2";
						}
					break;

					case "date":
						$inputs[$col_counter]["type"] = "html";
						if(FALSE === strpos($inputs[$col_counter]["params"], 'disabled')) {
							$inputs[$col_counter]["value"] = $js_calendar->make_input_field(array(), array("name" => $inputs[$col_counter]["name"], "value" => $inputs[$col_counter]["value"]));
						}
					break;

					case "tinyint":  //Checkbox
						$inputs[$col_counter]["params"] .= $person[$l] ? 'checked="checked"' : '';
					break;

					//picture
					case "tinytext":
						$inputs[$col_counter]["type"] = 'file';
						$inputs[$col_counter]["name2"] = "input_".$l."_DELETE";
						$inputs[$col_counter]["value2"] = getLL("delete");
					break;

					case "blob":
					case "text":
					break;

				}
				$col_counter++;
			}//if..else(ll=="---")

		}//foreach(ll)

		$row[$row_counter++]["inputs"] = $inputs;
		if($add_inputs) {
			foreach($add_inputs as $add_input) {
				$row[$row_counter++]["inputs"] = $add_input;
			}
		}
	}//foreach(LEUTE_LAYOUT)


	//LL-Values
	$smarty->assign("label_family", getLL("form_leute_family"));
	$smarty->assign("label_familyrole", getLL("form_leute_familyrole"));
	$smarty->assign("label_family_new", getLL("form_leute_family_new"));
	$smarty->assign("label_ok", getLL("OK"));
	$smarty->assign("label_group", getLL("groups_group"));
	$smarty->assign("label_grouprole", getLL("groups_role"));
	$smarty->assign("label_group_assigned", getLL("groups_assigned"));
	$smarty->assign("label_as_new_person", getLL("form_leute_as_new_person"));

	//Legend for family fields
	$smarty->assign("tpl_legend", getLL("leute_legend_family_fields"));
	$smarty->assign("tpl_legend_icon", "icon_familie.png");

	$smarty->assign("tpl_titel", getLL("form_leute_title")); //Personendaten
	$smarty->assign("tpl_id", $id);
	$smarty->assign("tpl_rows", $row);
	$smarty->assign("tpl_action", $mode == "neu" ? "submit_neue_person" : "submit_edit_person");
	$smarty->assign("tpl_action_neu", ($mode == "edit" && $group_new) ? "submit_als_neue_person" : "");

	$smarty->display("ko_formular_leute.tpl");
}//ko_formular_leute()






/**
  * Stellt die Leute-Liste dar
	* mode definiert die Ausgabe: liste, my_list, adressliste
	* output: TRUE=Ausgabe erfolgt direkt, FALSE=HTML wird zurckgegeben (Ajax)
	*/
function ko_list_personen($mode="liste", $output=TRUE) {
	global $smarty, $ko_path;
	global $group_view, $group_new, $group_edit, $group_mod;
	global $item_view, $item_new, $item_edit, $item_mod;
	global $g_view;
	global $LEUTE_EXCLUDE, $LEUTE_ADRESSLISTE_LAYOUT;
	global $KOTA, $ko_menu_akt;
	global $all_groups;

	if(!$group_view && !$item_view) return;

	if(!$all_groups) ko_get_groups($all_groups);
	$all_datafields = db_select_data("ko_groups_datafields", "WHERE 1=1", "*");

	$leute_col_name = ko_get_leute_col_name($groups_hierarchie=FALSE, $add_group_datafields=TRUE);
	$show_group_datafields = ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields");

	if($mode == "my_list") {  //Daten aus _SESSION[my_list] holen
		//Eigenes z_where gemss den gespeicherten IDs aufbauen
		if(sizeof($_SESSION["my_list"]) > 0) {
			$z_where = " AND ( ";
			foreach($_SESSION["my_list"] as $m) {
				if($m) $z_where .= "`id` = '$m' OR ";
			}
			if($z_where != " AND ( ") {
				$z_where = substr($z_where, 0, -3) . " ) ";
				$z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
				$rows = sizeof($_SESSION["my_list"]);
				ko_get_leute($es, $z_where, $z_limit);
			}
		} else {
			$es = array();
			$rows = 0;
		}

	}
	else if($mode == 'birthdays') {
		//Get dealine settings for birthdays
		$deadline_plus = ko_get_setting('geburtstagsliste_deadline_plus');
		$deadline_minus = ko_get_setting('geburtstagsliste_deadline_minus');

		$cols = '*, ( YEAR( CURDATE() ) - YEAR(`geburtsdatum` ) ) AS `alter`, TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) AS deadline';
		$where = " AND deleted = '0' ".ko_get_leute_hidden_sql()." AND TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) <= $deadline_plus AND TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) >= -$deadline_minus ".ko_get_birthday_filter();

		$rows = db_get_count('ko_leute', 'id', $where);
		$z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
		$es = db_select_data('ko_leute', 'WHERE 1=1 '.$where, $cols, 'ORDER BY `deadline` ASC', $z_limit);

		//Add columns for birthday list
		if(!in_array('geburtsdatum', $_SESSION['show_leute_cols'])) $_SESSION['show_leute_cols'][] = 'geburtsdatum';
		if(!in_array('alter', $_SESSION['show_leute_cols'])) $_SESSION['show_leute_cols'][] = 'alter';
		if(!in_array('deadline', $_SESSION['show_leute_cols'])) $_SESSION['show_leute_cols'][] = 'deadline';
		$leute_col_name['alter'] = getLL('leute_birthday_list_header_age');
		$leute_col_name['deadline'] = getLL('leute_birthday_list_header_deadline');
	}
	else {  //Daten aus DB holen
		//Filter anwenden
		apply_leute_filter($_SESSION["filter"], $z_where, !$group_view);

		//Manual sorting for MODULE- and other special columns
		if(TRUE === ko_manual_sorting($_SESSION["sort_leute"])) {
			$rows = ko_get_leute($all, $z_where);
			$es = ko_leute_sort($all, $_SESSION["sort_leute"], $_SESSION["sort_leute_order"]);
		}
		//Sorting done directly in MySQL
		else {
			$z_limit = "LIMIT " . ($_SESSION["show_start"]-1) . ", " . $_SESSION["show_limit"];
			$rows = db_get_count("ko_leute", "id", $z_where);
			ko_get_leute($es, $z_where, $z_limit);
		}
	}

	//show list-title
	$leute_show_deleted = FALSE;
	if($group_mod && ko_get_userpref($_SESSION["ses_userid"], "leute_show_deleted") == 1) {
		$leute_show_deleted = TRUE;
		$smarty->assign("tpl_list_title", getLL("leute_list_header_deleted"));
	}
	else if(($group_new || $item_new) && $_SESSION["leute_version"]) {
		$smarty->assign("tpl_list_title", getLL("leute_list_header_version"));
		$smarty->assign("tpl_list_title_styles", "background-color: #f4914a;");
		$smarty->assign("tpl_list_subtitle", getLL("leute_list_subheader_version").sql2datum($_SESSION["leute_version"]));
	}


	//version history of every record
	if($group_new || $item_new) {
		$smarty->assign("tpl_show_version_col", TRUE);
	}

	//find number of columns for colspan for version td (as IE can not edit innerHTML of tr elements
	$cols = 5;  //checkboxes, edit, del, history button
	if(!is_array($all_groups)) ko_get_groups($all_groups);
	$show_group_datafields = ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields");
	foreach($_SESSION["show_leute_cols"] as $col) {
		if($show_group_datafields && substr($col, 0, 9) == "MODULEgrp" && $all_groups[substr($col, 9)]["datafields"]) {
			foreach(explode(",", $all_groups[substr($col, 9)]["datafields"]) as $fid) {
				$cols++;
			}
		}
		$cols++;
	}
	$smarty->assign("version_colspan", $cols);


	//Statistik ber Suchergebnisse und Anzeige
  $stats_end = ($_SESSION["show_limit"]+$_SESSION["show_start"]-1 > $rows) ? $rows : ($_SESSION["show_limit"]+$_SESSION["show_start"]-1);
	$smarty->assign('tpl_stats', $_SESSION["show_start"]." - ".$stats_end." ".getLL("list_oftotal")." ".$rows);


  //Links fr Prev und Next-Page vorbereiten
  if($_SESSION["show_start"] > 1) {
		$smarty->assign("tpl_prevlink_link", "javascript:sendReq('../leute/inc/ajax.php', 'action,set_start,sesid', 'setstart,".(($_SESSION["show_start"]-$_SESSION["show_limit"] < 1) ? 1 : ($_SESSION["show_start"]-$_SESSION["show_limit"])).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_prevlink_link', '');
  }
  if(($_SESSION["show_start"]+$_SESSION["show_limit"]-1) < $rows) {
		$smarty->assign("tpl_nextlink_link", "javascript:sendReq('../leute/inc/ajax.php', 'action,set_start,sesid', 'setstart,".($_SESSION["show_limit"]+$_SESSION["show_start"]).",".session_id()."', do_element);");
  } else {
    $smarty->assign('tpl_nextlink_link', '');
  }


	//page-select
	$pages = ceil($rows/$_SESSION["show_limit"]);
	if($pages > 1) {
		$values = $output = NULL; $selected = 1;
		for($i=0; $i<$pages; $i++) {
			$start = 1+$i*$_SESSION["show_limit"];
			$values[] = $start;
			$output[] = ($i+1);
		}
		$smarty->assign("show_page_select", TRUE);
		$smarty->assign("show_page_select_label", getLL("page"));
		$smarty->assign("show_page_values", $values);
		$smarty->assign("show_page_output", $output);
		$smarty->assign("show_page_selected", $_SESSION["show_start"]);
	} else {
		$smarty->assign("show_page_select", FALSE);
	}
	


	//Header
	$smarty->assign('tpl_show_4cols_leute', (in_array($mode, array('liste', 'my_list'))) );
	$smarty->assign('tpl_show_3cols', (in_array($mode, array('birthdays'))) );

	if(in_array($mode, array('liste', 'my_list', 'birthdays'))) {
		$smarty->assign("checkbox_code", "select_export_marked();");
		$smarty->assign("checkbox_all_code", "select_export_marked();");
		$h_counter = -1;
		foreach($_SESSION["show_leute_cols"] as $c) {
			if($c != "" && isset($leute_col_name[$c])) {
				$h_counter++;
				if(substr($c, 0, 6) == "MODULE") {
					$tpl_table_header[$h_counter]["sort"] = $mode != 'birthdays' ? $c : '';
					$tpl_table_header[$h_counter]["name"] = $leute_col_name[$c];
					if($show_group_datafields && $all_groups[substr($c, 9)]["datafields"]) {
						$fid_counter = 0;
						foreach(explode(",", $all_groups[substr($c, 9)]["datafields"]) as $fid) {
							if(!isset($all_datafields[$fid])) continue;
							$tpl_table_header[++$h_counter]["sort"] = $mode != 'birthdays' ? $c."datafield".++$fid_counter : '';
							$tpl_table_header[$h_counter]["class"] = "ko_list_datafields";
							$tpl_table_header[$h_counter]["name"] = $leute_col_name[$c.":".$fid];
						}
					}
				} else {
					if($c != "groups" && $mode != 'birthdays') {
						$sort_col = $c;
						if($c == 'geburtsdatum')
							$sort_col = ko_get_userpref($_SESSION['ses_userid'], 'leute_sort_birthdays') == 'year' ? $c : 'MODULE'.$c;
						$tpl_table_header[$h_counter]["sort"] = $sort_col;
					}
					$tpl_table_header[$h_counter]["name"] = $leute_col_name[$c];
				}
			}//if(c)
		}

		//Multisorting (show for list)
		$multisort["select_values"][] = "";
		$multisort["select_descs"][] = "";
		foreach($leute_col_name as $i => $col) {
			if(substr($i, 0, 6) == "MODULE") continue;  //Only add "normal" columns without groups
			$sort_col = $i;
			if($i == 'geburtsdatum')
				$sort_col = ko_get_userpref($_SESSION['ses_userid'], 'leute_sort_birthdays') == 'year' ? $i : 'MODULE'.$i;
			$multisort["select_values"][] = $sort_col;
			$multisort["select_descs"][] = $col;
		}
		$multisort["select_values"][] = "";
		$multisort["select_descs"][] = "---".getLL("groups")."---";
		foreach($tpl_table_header as $i => $col) {
			if(substr($col["sort"], 0, 6) != "MODULE") continue;  //Only add displayed groups
			$multisort["select_values"][] = $col["sort"];
			$multisort["select_descs"][] = $col["name"];
		}
		$multisort["show"] = TRUE;
		$multisort["showLink"] = getLL("list_multisort_showLink");
		$multisort["open"] = (sizeof($_SESSION["sort_leute"]) > 1);
		foreach($_SESSION["sort_leute"] as $i => $col) {
			$multisort["select_selected"][$i] = $col;
			$multisort["columns"][$i] = $i;
			$multisort["order"][$i] = strtoupper($_SESSION["sort_leute_order"][$i]);
		}

	}//if(mode == liste | my_list)
	else if($mode == "adressliste") {
		$tpl_table_header = array();
	}
	else return FALSE;

  $smarty->assign("tpl_table_header", $tpl_table_header);
  $smarty->assign("sort", array("show" => TRUE,
																"action" => "setsortleute",
																"akt" => $_SESSION["sort_leute"][0],
																"akt_order" => $_SESSION["sort_leute_order"][0])
	);
	$smarty->assign("module", "leute");
	$smarty->assign("sesid", session_id());
	if($mode != 'birthdays') $smarty->assign("multisort", $multisort);


	//Multiedit-Spalten definieren
	//get the cols, for which this user has edit-rights (saved in allowed_cols[edit])
	$allowed_cols = ko_get_leute_admin_spalten($_SESSION["ses_userid"], "all");
	if(!$leute_show_deleted && ($group_new || $item_new) && $mode != 'birthdays') {
		$smarty->assign("tpl_show_editrow", TRUE);
		$edit_columns = array();
		foreach($_SESSION["show_leute_cols"] as $col) {
			if($col != "" && isset($leute_col_name[$col])) {
				if(isset($KOTA["ko_leute"][$col])) {
					if(!is_array($allowed_cols["edit"]) || (is_array($allowed_cols["edit"]) && in_array($col, $allowed_cols["edit"])))
						$edit_columns[] = $col;
					else
						$edit_columns[] = "";
				} else $edit_columns[] = "";
				//add cols for group-datafields
				if($show_group_datafields && substr($col, 0, 9) == "MODULEgrp" && $all_groups[substr($col, 9)]["datafields"]) {
					foreach(explode(",", $all_groups[substr($col, 9)]["datafields"]) as $fid) {
						if($fid && isset($all_datafields[$fid])) {
							if($all_groups[substr($col, 9)]['type'] != 1) {
								$edit_columns[] = str_replace("grp", "gdf", $col).$fid;
							} else {
								$edit_columns[] = '';
							}
						}
					}
				}
			}
		}
		$smarty->assign("tpl_edit_columns", $edit_columns);
	} else {
		$smarty->assign("tpl_show_editrow", FALSE);
	}
	

	//add icons to move columns left an right
	if(ko_get_userpref($_SESSION["ses_userid"], "sort_cols_leute") == "0" && $mode != 'birthdays') {
		$smarty->assign("tpl_show_sort_cols", TRUE);
		$sort_cols = NULL;
		foreach($_SESSION["show_leute_cols"] as $col) {
			if($col != "" && isset($leute_col_name[$col])) {
				$sort_cols[] = $col;
				//add empty cols for group-datafields
				if($show_group_datafields && substr($col, 0, 6) == "MODULE" && $all_groups[substr($col, 9)]["datafields"]) {
					foreach(explode(",", $all_groups[substr($col, 9)]["datafields"]) as $fid) if($fid) $sort_cols[] = "";
				}
			}
		}
		$smarty->assign("tpl_sort_cols", $sort_cols);
	} else {
		//no sorting
		$smarty->assign("tpl_show_sort_cols", FALSE);
	}



	$login_edit_person = ko_get_setting("login_edit_person");
	$logged_in_leute_id = ko_get_logged_in_id();
	//Eigentliche Daten ausgeben
	$e_i = -1;
	foreach($es as $e) {
		//Nur erlaubte Personen berhaupt anzeigen
		if(!$item_view[$e["id"]]) continue;

		$e_i++;

		//Hidden row
		$tpl_list_data[$e_i]["rowclass"] = $e["hidden"] ? "ko_list_hidden" : "";

		//Checkbox
    $tpl_list_data[$e_i]["show_checkbox"] = TRUE;
    //$tpl_list_data[$e_i]["rowclick_code"] = 'jumpToUrl(\'/leute/index.php?action=single_view&amp;id='.$e["id"].'\');';

		//Familien-Checkbox
		if($e["famid"] > 0) {
    	$tpl_list_data[$e_i]["show_fam_checkbox"] = TRUE;
		}

		//Edit-Button
		if( !$leute_show_deleted && ($item_new[$e["id"]] || ($login_edit_person == 1 && $e["id"] == $logged_in_leute_id))) {
      $tpl_list_data[$e_i]["show_edit_button"] = TRUE;
      $tpl_list_data[$e_i]["alt_edit"] = getLL("leute_labels_edit_pers");
      $tpl_list_data[$e_i]["onclick_edit"] = "javascript:set_action('edit_person');set_hidden_value('id', '".$e["id"]."');this.submit";
    } else {
			if($leute_show_deleted) {
				$tpl_list_data[$e_i]["show_undelete_button"] = TRUE;
				$tpl_list_data[$e_i]["alt_edit"] = getLL('leute_labels_undel_pers');
				$tpl_list_data[$e_i]["onclick_edit"] = "javascript:set_action('undelete_person');set_hidden_value('id', '".$e["id"]."');this.submit";
			} else {
		    $tpl_list_data[$e_i]["show_edit_button"] = FALSE;
			}
    }

    //Delete-Button
		if($item_edit[$e["id"]]) {
	    $tpl_list_data[$e_i]["show_delete_button"] = TRUE;
 	  	$tpl_list_data[$e_i]["alt_delete"] = getLL("leute_labels_del_pers");
      $tpl_list_data[$e_i]["onclick_delete"] = "javascript:c = confirm('" . getLL("leute_confirm_del_pers") . "');if(!c) return false;set_action('delete_person');set_hidden_value('id', '".$e["id"]."');";
    } else {
      $tpl_list_data[$e_i]["show_delete_button"] = FALSE;
    }

		//version history
		if($item_new[$e["id"]]) {
      $tpl_list_data[$e_i]["alt_version"] = getLL("leute_labels_version_history");
      $tpl_list_data[$e_i]["onclick_version"] = "tr=document.getElementById('version_tr_".$e["id"]."'); if(tr.style.display == 'none') {sendReq('../leute/inc/ajax.php', 'action,id,sesid', 'history,".$e["id"].",".session_id()."', do_element); } change_vis_tr('version_tr_".$e["id"]."');return false;";
		}

	  //Index
    $tpl_list_data[$e_i]["id"] = $e["id"];
    $tpl_list_data[$e_i]["famid"] = $e["famid"];

		//Anzuzeigende Spalten einfllen
		$colcounter = -1;
		if(in_array($mode, array('liste', 'my_list', 'birthdays'))) {
			foreach($_SESSION["show_leute_cols"] as $c) {
				if($c != "" && isset($leute_col_name[$c])) {
					$colcounter++;

					//Add links to single groups in groups column
					if($c == "groups") {
						$value = NULL;
						if(!isset($g_view)) ko_get_admin("groups", $_SESSION["ses_userid"], $g_view, $g_new, $g_edit, $g_mod);
						foreach(explode(",", $e[$c]) as $g) {
							$gid = ko_groups_decode($g, "group_id");
							if($g && $g_view[$gid]) {
								$value[] = '<a href="#" onclick="'."sendReq('../leute/inc/ajax.php', 'action,id,state,sesid', 'itemlist,MODULEgrp".$gid.",switch,".session_id()."', do_element);return false;".'">'.ko_html(ko_groups_decode($g, "group_desc_full"))."</a>";
							}
						}
						$value = implode(", ", $value);
					}
					//Display hidden column
					elseif($c == "hidden") {
						//Only show link to hide or unhide if this column can be edited
						if(!is_array($allowed_cols["edit"]) || (is_array($allowed_cols["edit"]) && in_array($c, $allowed_cols["edit"]))) {
							if($e["hidden"]) {
								$value = '<input type="image" src="'.$ko_path.'images/icon_unhide.png" onclick="sendReq(\'../leute/inc/ajax.php\', \'action,mode,id,sesid\', \'hideperson,visible,'.$e["id"].','.session_id().'\', do_element);return false;" />';
							} else {
								$value = '<input type="image" src="'.$ko_path.'images/icon_hide.png" '.'onclick="sendReq(\'../leute/inc/ajax.php\', \'action,mode,id,sesid\', \'hideperson,hidden,'.$e["id"].','.session_id().'\', do_element);return false;"'.' />';
							}
						} else {
							$value = "&nbsp;";
						}
					}
					//all other columns are handled in map_leute_daten()
					else {
						$value = map_leute_daten($e[$c], $c, $e, $all_datafields);
						if(substr($c, 0, 9) != "MODULEgrp") $value = ko_html($value);
					}

					if(is_array($value)) {  //group with datafields, so more than one columns has to be added
						foreach($value as $v) {
							$tpl_list_cols[$colcounter] = $colcounter;
							$tpl_list_data[$e_i][$colcounter++] = $v;
						}
						$colcounter--;
					}
					//normal value (not from group-datafield)
					else {
						$tpl_list_cols[$colcounter] = $colcounter;
						$tpl_list_data[$e_i][$colcounter] = $value;
					}
				}
			}
		}
		else if($mode == "adressliste") {
			$tpl_list_data[$e_i]["vcard_id"] = $e["id"];
			$tpl_list_data[$e_i]["maplinks"] = ko_get_map_links($e);
			$rowcounter = 0;
			foreach($LEUTE_ADRESSLISTE_LAYOUT as $c) {
				$tpl_list_data[$e_i]["daten"][$rowcounter] = "";
				foreach($c as $cc) {
					if(substr($cc, 0, 1) == "@")  //Kommentar (beginnend mit @) direkt ausgeben
						$tpl_list_data[$e_i]["daten"][$rowcounter] .= "<i>".ko_html(substr($cc, 1))."</i> ";
					else if(is_string($cc))   //Eintrge als Personendaten formatiert ausgeben
						$tpl_list_data[$e_i]["daten"][$rowcounter] .= ko_html(map_leute_daten($e[$cc], $cc, $e)) . " ";
				}
				$rowcounter++;
			}
		}
		else return FALSE;

	}//foreach(es)

	$smarty->assign('tpl_list_cols', $tpl_list_cols);
  $smarty->assign('tpl_list_data', $tpl_list_data);
	if(in_array($mode, array('liste', 'my_list', 'birthdays'))) {

		//Footer:
		if($rows > 0 && (!$leute_show_deleted || $mode == "my_list") && $mode != 'birthdays') {
			if(ko_module_installed("dp") && !$group_edit && (!defined('DP_DISABLE_OLD') || !DP_DISABLE_OLD)) {
				ko_get_admin("dp", $_SESSION["ses_userid"], $d_view, $d_new, $d_edit, $d_mod);
				if($d_edit) {
					//Dienst-Zuweisung anzeigen
					$button_code = '<select name="sel_dienst" size="0">';
					ko_get_dienste($dienste);
					foreach($dienste as $l_i => $l) {
						if($d_edit[$l["id"]]) {
							ko_get_leute_by_dienst($d_l, $l["id"]);
							$button_code .= '<option value="'.$l["id"].'">';
							$button_code .= $l["name"];
							if(sizeof($d_l) > 0) $button_code .= " (".sizeof($d_l).")";
							$button_code .= '</option>';
						}
					}//foreach(logins)
					$button_code .= '</select>';
					$button_code .= '&nbsp;&nbsp;<input type="submit" onclick="set_action(\'assign_dienst\');" value="'.getLL("leute_list_footer_team_button1").'" />';
					$button_code .= '&nbsp;&nbsp;<input type="submit" onclick="set_action(\'assign_dienst_del\');" value="'.getLL("leute_list_footer_team_button2").'" />';
					$button_code .= '</td></tr>';

					$list_footer[] = array("label" => getLL("leute_list_footer_team_label"),
																 "button" => $button_code);
					$smarty->assign("show_list_footer", TRUE);
				}//if(a_edit)


				//Dienst-Verantwortlich-Zuweisung anzeigen
				if($d_mod) {
					$button_code = '<select name="sel_dienst_verantwortlich" size="0">';
					ko_get_dienste($dienste);
					foreach($dienste as $l_i => $l) {
						if($d_mod[$l["id"]]) {
							ko_get_leiter_by_dienst($l_l, $l["id"]);
							$button_code .= '<option value="'.$l["id"].'">';
							$button_code .= $l["name"];
							if(sizeof($l_l) > 0) $button_code .= " (".sizeof($l_l).")";
							$button_code .= '</option>';
						}
					}//foreach(logins)
					$button_code .= '</select>';
					$button_code .= '&nbsp;&nbsp;<input type="submit" onclick="set_action(\'assign_dienst_verantwortlich\');" value="'.getLL("leute_list_footer_team_button1").'" />';
					$button_code .= '&nbsp;&nbsp;<input type="submit" onclick="set_action(\'assign_dienst_verantwortlich_del\');" value="'.getLL("leute_list_footer_team_button2").'" />';

					$list_footer[] = array("label" => getLL("leute_list_footer_teamleader_label"),
																 "button" => $button_code);
					$smarty->assign("show_list_footer", TRUE);
				}//if(a_mod)
			}//if(ko_module_installed(dp))


			//Join in Family
			if($group_new && (!is_array($allowed_cols["edit"]) || in_array("famid", $allowed_cols["edit"]))) {
				$button_code = '<input type="submit" onclick="set_action(\'join_in_family\');" value="'.getLL("leute_list_footer_join_in_family_button").'" />';
				$list_footer[] = array("label" => getLL("leute_list_footer_join_in_family"),
															 "button" => $button_code);
				$smarty->assign("show_list_footer", TRUE);
			}

			$smarty->assign("list_footer", $list_footer);
		}//if(rows > 0)


		// Help for multisorting
		$smarty->assign("help", ko_get_help("leute", $_SESSION['show']));

		if($output) {
			if($mode == "my_list") $smarty->assign("tpl_list_title", getLL("leute_mylist_list_title"));
			else if($mode == 'birthdays') $smarty->assign('tpl_list_title', getLL('leute_birthday_list_title'));
		  $smarty->display('ko_list.tpl');
		} else  {
		  print $smarty->fetch('ko_list.tpl');
		}
	} else if($mode == "adressliste") {
		if($output) {
		  $smarty->display('ko_adressliste.tpl');
		} else {
		  print $smarty->fetch('ko_adressliste.tpl');
		}
	}
}//ko_list_personen()




function ko_list_mod_leute() {
	global $smarty, $ko_path;
	global $DATETIME;

	$counter=0;
	ko_get_mod_leute($leute);
	foreach($leute as $p) {
		$fields_counter=0;

		if($p["_leute_id"] == -1) {  //Neu
			$old_p = array();
			$mutationen[$counter]["name"] = getLL("leute_aa_new").": ".ko_html($p["vorname"])." ".ko_html($p["nachname"]);
		} else {  //bisherige Adresse gendert
			ko_get_person_by_id($p["_leute_id"], $old_p);
			$mutationen[$counter]["name"] = ko_html($old_p["vorname"])." ".ko_html($old_p["nachname"]);
		}
		$mutationen[$counter]["id"] = $p["_id"];

		$cols = db_get_columns("ko_leute_mod");
		$col_names = ko_get_leute_col_name();
		foreach($cols as $c) {
			if(substr($c["Field"], 0, 1) != "_") {
				if( ( ($p[$c["Field"]] != "" && $p[$c["Field"]] != "0000-00-00") || $old_p[$c["Field"]]) && $p[$c["Field"]] != $old_p[$c["Field"]]) {
					$mutationen[$counter]["fields"][$fields_counter]["name"] = $c["Field"];
					$mutationen[$counter]["fields"][$fields_counter]["desc"] = $col_names[$c["Field"]];
					if(substr($c['Type'], 0, 4) == 'enum') {
						$mutationen[$counter]['fields'][$fields_counter]['type'] = 'select';
						$mutationen[$counter]['fields'][$fields_counter]['values'] = db_get_enums('ko_leute_mod', $c['Field']);
						$mutationen[$counter]['fields'][$fields_counter]['descs'] = db_get_enums_ll('ko_leute_mod', $c['Field']);
						$mutationen[$counter]['fields'][$fields_counter]['oldvalue'] = getLL('ko_leute_mod_'.$c['Field'].'_'.$old_p[$c['Field']]);
						$mutationen[$counter]['fields'][$fields_counter]['newvalue'] = $p[$c['Field']];
					} else {
						$mutationen[$counter]['fields'][$fields_counter]['type'] = 'input';
						$mutationen[$counter]['fields'][$fields_counter]['oldvalue'] = ko_html($old_p[$c['Field']]);
						$mutationen[$counter]['fields'][$fields_counter]['newvalue'] = ko_html($p[$c['Field']]);
					}
					$fields_counter++;
				}//if(p != old_p)
			}//if(substr(c) != "_")
		}//foreach(cols as c)

		//Bemerkungen zu dieser Mutation anzeigen
		$mutationen[$counter]["bemerkung"] = ko_html($p["_bemerkung"]);

		//Show creation date
		if($p["_crdate"] != "0000-00-00 00:00:00") $mutationen[$counter]["crdate"] = strftime($DATETIME["dmY"]." %H:%M", strtotime($p["_crdate"]));

		$counter++;
	}//foreach(leute as p)

	if(sizeof($leute) == 0) $smarty->assign("tpl_aa_empty", TRUE);
	//LL-Values
	$smarty->assign("label_empty", getLL("aa_list_empty"));
	$smarty->assign("label_comments", getLL("aa_list_comments"));
	$smarty->assign("label_submit", getLL("aa_list_submit"));
	$smarty->assign("label_delete", getLL("aa_list_delete"));
	$smarty->assign("label_crdate", getLL("leute_labels_crdate"));

	$smarty->assign("tpl_list_title", getLL("leute_mod_title"));
	$smarty->assign("tpl_fm_title", getLL("leute_mod_title"));

	$smarty->assign("tpl_mutationen", $mutationen);
	$smarty->display("ko_adressaenderung.tpl");
}//ko_list_mod_leute()



function ko_list_groupsubscriptions() {
	global $smarty, $ko_path;
	global $DATETIME;

	$counter=0;
	ko_get_groupsubscriptions($leute, "", $_SESSION["ses_userid"]);
	foreach($leute as $p) {
		$fields_counter = 0;

		//Group- and Role-ID
		list($gid, $rid) = explode(":", $p["_group_id"]);
		$gid = format_userinput($gid, "uint");
		$group = db_select_data("ko_groups", "WHERE `id` = '$gid'", "*", "", "", TRUE);
		$rid = format_userinput($rid, "uint");
		$role = $rid ? db_select_data("ko_grouproles", "WHERE `id` = '$rid'", "*", "", "", TRUE) : array();

		//Try to find person in DB
		$found_dbp = ko_fuzzy_search(array("vorname" => $p["vorname"], "nachname" => $p["nachname"]), "ko_leute", 2, FALSE, 2);
		$db = NULL;
		foreach($found_dbp as $db_id) {
			ko_get_person_by_id($db_id, $dbp);
			$db[] = array("gid" => $gid, "_id" => $p["_id"], "lid" => $dbp["id"], "name" => $dbp["vorname"]." ".$dbp["nachname"], 
										"adressdaten" => $dbp["adresse"].", ".$dbp["plz"]." ".$dbp["ort"].
																		 ", ".$dbp["telp"].", ".$dbp["email"].", ".sql2datum($dbp["geburtsdatum"])
									 );
		}


		$gs[$counter]["_id"] = $p["_id"];
		$gs[$counter]["groupname"] = $group["name"].($rid ? ": ".$role["name"] : "");
		$gs[$counter]["ezmlm"] = $group["ezmlm_list"] != "" ? getLL("ezmlm_ml") : "";
		$gs[$counter]["name"] = ko_html($p["vorname"])." ".ko_html($p["nachname"]);
		$gs[$counter]["address"] = $p["adresse"];
		$gs[$counter]["plz"] = $p["plz"];
		$gs[$counter]["ort"] = $p["ort"];
		$gs[$counter]["telp"] = $p["telp"];
		$gs[$counter]["email"] = $p["email"];
		$gs[$counter]["geburtsdatum"] = sql2datum($p["geburtsdatum"]);
		$gs[$counter]["_bemerkung"] = ko_html($p["_bemerkung"]);
		//Show creation date
		if($p["_crdate"] != "0000-00-00 00:00:00") $gs[$counter]["_crdate"] = strftime($DATETIME["dmY"]." %H:%M", strtotime($p["_crdate"]));

		if(sizeof($found_dbp) > 0) {
			$gs[$counter]["db"] = $db;
		} else {
			$gs[$counter]["empty"] = TRUE;
		}
		//datafields
		$df_values = array();
		foreach(unserialize($p["_group_datafields"]) as $i =>$df) {
			$df_values[$gid][$i] = $df;
		}
		$gs[$counter]["datafields"] = ko_groups_render_group_datafields($gid, $p["_id"], $df_values, array("hide_title" => TRUE, "add_leute_id" => TRUE));

		//People selects
		$ps = array("gid" => $gid);
		foreach(array("a","b","c","d","e","f","g","h","i","j","k","l","m","n","o","p","q","r","s","t","u","v","w","x","y","z") as $letter) {
			$ps["descs"][] = strtoupper($letter);
			$ps["values"][] = "i".strtoupper($letter);
		}
		$ps["name"] = "ps_".$p["_id"];

		$gs[$counter]["ps"] = $ps;

		$counter++;
	}//foreach(leute as p)

	if(sizeof($leute) == 0) {
		$smarty->assign("tpl_list_empty", TRUE);
		$smarty->assign("label_no_entries", getLL("groups_mod_no_entries"));
	}

	//LL-Values
	$smarty->assign("label_no_person_in_db", getLL("groups_mod_no_person_in_db"));
	$smarty->assign("label_entered_data", getLL("groups_mod_entered_data"));
	$smarty->assign("label_ok", getLL("OK"));
	$smarty->assign("label_ok_and_mutation", getLL("groups_mod_ok_and_mutation"));
	$smarty->assign("label_add_person", getLL("groups_mod_add_person"));
	$smarty->assign("label_add_person_submit", getLL("groups_mod_add_person_submit"));
	$smarty->assign("label_delete_entry", getLL("groups_mod_delete_entry"));
	$smarty->assign("label_delete_entry_confirm", getLL("groups_mod_delete_entry_confirm"));
	$smarty->assign("label_new_groupsubscription", getLL("groups_mod_new_groupsubscription"));
	$smarty->assign("label_possible_db_hits", getLL("groups_mod_possible_db_hits"));
	$smarty->assign("label_ps", getLL("groups_mod_peopleselect"));
	$smarty->assign("label_crdate", getLL("leute_labels_crdate"));
	$smarty->assign('sesid', session_id());


	$smarty->assign("tpl_list_title", getLL("leute_groupsubscriptions_title"));
	$smarty->assign("tpl_fm_title", getLL("leute_groupsubscriptions_title"));

	$smarty->assign("tpl_gs", $gs);
	$smarty->display("ko_groupsubscription.tpl");
}//ko_list_groupsubscriptions()





function ko_leute_show_single($id) {
	global $smarty, $ko_path;

	ko_get_person_by_id($id, $person);
	//TODO: Get all other infos like family, groups, datafields, kg etc.
	$smarty->assign("person", $person);
	$smarty->display("ko_leute_single_view.tpl");
}//ko_leute_show_single()





function ko_update_kg_filter() {
	ko_get_kleingruppen($kgs);
	$new_code  = '<select name="var1" size="0">';
	$new_code .= '<option value=""></option>';
	foreach($kgs as $kg) {
		$new_code .= '<option value="'.$kg["id"].'">'.$kg["name"].'</option>';
	}
	$new_code .= '</select>';

	ko_get_filters($filters, "leute");
	foreach($filters as $ff) {
		if($ff["_name"] == "smallgroup") {
			db_update_data("ko_filter", "WHERE `id` = '".$ff["id"]."'", array("code1" => $new_code));
		} else if($ff["_name"] == "smallgroup leader") {
			db_update_data("ko_filter", "WHERE `id` = '".$ff["id"]."'", array("code1" => $new_code));
		}
	}
}//ko_update_kg_filter()




function ko_update_familie_filter() {
	ko_get_familien($fams);
	$new_code  = '<select name="var1" size="0">';
	$new_code .= '<option value="0"></option>';
	foreach($fams as $fam) {
		$new_code .= '<option value="'.$fam["famid"].'">'.$fam["id"].'</option>';
	}
	$new_code .= '</select>';

	db_update_data("ko_filter", "WHERE `typ`='leute' AND `name`='family'", array("code1" => $new_code));
}//ko_update_familie_filter()



function ko_leute_import($state, $mode) {
	global $ko_path, $smarty;
	global $all_groups;

	switch($state) {
		case 1:
			$code  = "<h1>".getLL("leute_import_state1")."</h1>";
			$code .= getLL("leute_import_state1_header")."<br />";
			$code .= '<div class="install_select_lang">';
			$code .= '<a href="index.php?action=import&amp;state=2&amp;mode=vcard">';
			$code .= '<img src="'.$ko_path.'images/vcard_big.gif" border="0" /><br /><br />'.getLL("leute_import_state1_vcard");
			$code .= '</a></div>';
			$code .= '<div class="install_select_lang">';
			$code .= '<a href="index.php?action=import&amp;state=2&amp;mode=csv">';
			$code .= '<img src="'.$ko_path.'images/csv.jpg" border="0" /><br /><br />'.getLL("leute_import_state1_csv");
			$code .= '</a></div>';

			print $code;
		break;  //1

		case 2:
			if($mode == "vcard") {
				$rowcounter = 0;
				$gc = 0;
				$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("leute_import_state1_vcard"),
						"type" => "file",
						"name" => "vcf",
						"params" => 'size="60"',
						);
				$smarty->assign("tpl_titel", getLL("leute_import_state2"));
				$smarty->assign("tpl_hide_cancel", TRUE);
				$smarty->assign("tpl_submit_value", getLL("next"));
				$smarty->assign("tpl_action", "import");
				$smarty->assign("tpl_groups", $frmgroup);
				$smarty->display('ko_formular.tpl');
			}  //vcard

			else if($mode == "csv") {
				$rowcounter = 0;
				$gc = 0;

				$values = $descs = array();
				$table_cols = db_get_columns("ko_leute");
				$col_names = ko_get_leute_col_name();
				$dont_allow = array("id", "famid", "deleted", "hidden", "picture", "groups", "dienst", "dienstleiter", "kinder", "kg", "kg_leiter", "famfunction", "lastchange", 'crdate', 'cruserid');
				foreach($table_cols as $c) {
					if(!in_array($c["Field"], $dont_allow)) {
						$values[] = $c["Field"];
						$descs[] = $col_names[$c["Field"]] ? $col_names[$c["Field"]] : $c["Field"];
					}
				}
				$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("leute_import_state1_csv_dbcols"),
						"type" => "doubleselect",
						"js_func_add" => "double_select_add",
						"name" => "sel_dbcols",
						"params" => 'size="7"',
						"show_moves" => TRUE,
						"values" => $values,
						"descs" => $descs,
						);
				$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("leute_import_state1_csv"),
						"type" => "file",
						"name" => "csv",
						"params" => 'size="60"',
						);
				$frmgroup[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("leute_import_state1_csv_separator"),
						"type" => "text",
						"name" => "txt_separator",
						"params" => 'size="6"',
						"value" => ",",
						);
				$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("leute_import_state1_csv_content_separator"),
						"type" => "text",
						"name" => "txt_content_separator",
						"params" => 'size="6"',
						"value" => '&quot;',
						);
				$frmgroup[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("leute_import_state1_csv_first_line"),
						"type" => "checkbox",
						"name" => "chk_first_line",
						"value" => "1",
						);
				$smarty->assign("tpl_titel", getLL("leute_import_state2"));
				$smarty->assign("tpl_hide_cancel", TRUE);
				$smarty->assign("tpl_submit_value", getLL("next"));
				$smarty->assign("tpl_action", "import");
				$smarty->assign("tpl_groups", $frmgroup);
				$smarty->display('ko_formular.tpl');
			}  //csv
		break;  //2

		case 3:
			//Kept for CSV-Settings like date_*, mgrp_*, bgrp_*
		break;  //3

		case 4:
			$num_entries = sizeof($_SESSION["import_data"]);

			//found entries
			$entries = "<table><tr>";
			foreach($_SESSION["import_data"][0] as $key => $value) {
				$entries .= '<th>'.getLL("kota_ko_leute_".$key).'</th>';
			}
			$entries .= "</tr>";
			for($i=0; $i<5; $i++) {
				if($_SESSION["import_data"][$i]) {
					$entries .= '<tr><td>'.implode("</td><td>", $_SESSION["import_data"][$i])."</td></tr>";
				}
			}
			$entries .= "</table>";

			//assign to group
			if(!is_array($all_groups)) ko_get_groups($all_groups);
			$values = $descs = array(0 => "");
			if(!$groups) $groups = ko_groups_get_recursive(ko_get_groups_zwhere());
			foreach($groups as $g) {
				//Full id including parent relationship
				$motherline = ko_groups_get_motherline($g["id"], $all_groups);
				$mids = array();
				foreach($motherline as $mg) {
					$mids[] = "g".$all_groups[$mg]["id"];
				}
				$values[] = (sizeof($mids) > 0 ? implode(":", $mids).":" : "")."g".$g["id"];

				//Name
				$desc = "";
				$depth = sizeof($motherline);
				for($i=0; $i<$depth; $i++) $desc .= "&nbsp;&nbsp;";
				$desc .= $g["name"];
				$descs[] = $desc;
			}

			$rowcounter = 0;
			$gc = 0;
			$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("leute_import_state4_header")." ".$num_entries."<br />",
					"type" => "label",
					"value" => $entries,
					);
			$frmgroup[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("leute_import_state4_group"),
					"type" => "select",
					"name" => "sel_group",
					"params" => 'size="0"',
					"values" => $values,
					"descs" => $descs,
					);

			$smarty->assign("tpl_titel", getLL("leute_import_state4"));
			$smarty->assign("tpl_hide_cancel", TRUE);
			$smarty->assign("tpl_submit_value", getLL("leute_import_do_import"));
			$smarty->assign("tpl_action", "do_import");
			$smarty->assign("tpl_groups", $frmgroup);
			$smarty->display('ko_formular.tpl');
		break;  //4
	}
}//ko_leute_import()






/**
 * Show settings for PDF export of address data
 */
function ko_export_leute_as_pdf_settings($layout_id) {
	global $smarty;

	$gc = $rowcounter = 0;

	//Get layout from db
	$_layout = db_select_data("ko_pdf_layout", "WHERE `id` = '$layout_id'", "*", "", "", TRUE);
	$layout = unserialize($_layout["data"]);

	//Prepare filter select
	$filter_values = $filter_descs = array();
	if(sizeof($_SESSION['my_list']) > 0) {
		$filter_values[] = '_mylist';
		$filter_descs[] = getLL('leute_export_pdf_filter_mylist');
	}
	if($layout["filter"]) {
		$filter_values[] = "_layout";
		$filter_descs[] = getLL("leute_export_pdf_filter_layout");
	}
	$filter_values[] = "_current";
	$filter_descs[] = getLL("leute_export_pdf_filter_current");
	$filterset = array_merge((array)ko_get_userpref('-1', '', 'filterset', 'ORDER BY `key` ASC'), (array)ko_get_userpref($_SESSION['ses_userid'], '', 'filterset', 'ORDER BY `key` ASC'));
	foreach($filterset as $f) {
		$filter_values[] = $f['user_id'] == '-1' ? '@G@'.$f['key'] : $f['key'];
		$filter_descs[] = $f['user_id'] == '-1' ? getLL('itemlist_global_short').' '.$f['key'] : $f['key'];
	}
	//Set current selection
	if($layout['filter']) {  //Filter as set for this pdf layout
		$filter_selected = '_layout';
	} else if($_SESSION['show_back'] == 'show_my_list' && sizeof($_SESSION['my_list']) > 0) {  //Use my list if entries
		$filter_selected = '_mylist';
	} else {  //Otherwise use currently applied filter
		$filter_selected = '_current';
	}

	//Prepare columns select
	if($layout["columns"]) {
		$columns_values[] = "_layout";
		$columns_descs[] = getLL("leute_export_pdf_columns_layout");
	}
	$columns_values[] = "_current";
	$columns_descs[] = getLL("leute_export_pdf_columns_current");
	$itemset = array_merge((array)ko_get_userpref('-1', '', 'leute_itemset', 'ORDER BY `key` ASC'), (array)ko_get_userpref($_SESSION['ses_userid'], '', 'leute_itemset', 'ORDER BY `key` ASC'));
	foreach($itemset as $f) {
		$columns_values[] = $f['user_id'] == '-1' ? '@G@'.$f['key'] : $f['key'];
		$columns_descs[] = $f['user_id'] == '-1' ? getLL('itemlist_global_short').' '.$f['key'] : $f['key'];
	}

	$group[$gc] = array("titel" => getLL("leute_export_pdf_title_data"), "state" => "open");
	$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("leute_export_pdf_filter"),
																												 "type" => "select",
																												 "name" => "pdf[filter]",
																												 "values" => $filter_values,
																												 "descs" => $filter_descs,
																												 "value" => $filter_selected,
																												 "params" => 'size="0"'
																												 );
	$group[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("leute_export_pdf_columns"),
																											 "type" => "select",
																											 "name" => "pdf[columns]",
																											 "values" => $columns_values,
																											 "descs" => $columns_descs,
																											 "value" => "_layout",
																											 "params" => 'size="0"'
																											 );
	if($layout["columns_datafields"]) {
		$df_check = TRUE;
	} else if($layout["columns"]) {
		$df_check = FALSE;
	} else {
		$df_check = ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields") ? TRUE : FALSE;
	}
	$children_check = $layout["columns_children"] ? TRUE : FALSE;

	$group[$gc]["row"][$rowcounter++]["inputs"][1] = array("desc" => getLL("leute_export_pdf_show_datafields"),
																												 "type" => "checkbox",
																												 "name" => "pdf[columns_datafields]",
																												 "value" => "1",
																												 "params" => $df_check ? 'checked="checked"' : "",
																												 );
	$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("leute_export_pdf_show_children"),
																												 "type" => "checkbox",
																												 "name" => "pdf[columns_children]",
																												 "value" => "1",
																												 "params" => $children_check ? 'checked="checked"' : "",
																												 );
	//Header and Footer
	$group[++$gc] = array("titel" => getLL("leute_export_pdf_title_headerfooter"), "state" => "open");
	$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("desc" => getLL("help"),
																												 "type" => "html",
																												 "value" => getLL("leute_export_pdf_help_headerfooter"),
																												 "colspan" => 'colspan="3"',
																												 );
	$group[$gc]["row"][$rowcounter++]["inputs"][0] = array("type" => "   ", "colspan" => 'colspan="3"');
	$group[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("leute_export_pdf_header_left"),
																												 "type" => "text",
																												 "name" => "pdf[header][left][text]",
																												 "value" => $layout["header"]["left"]["text"],
																												 "params" => 'size="50"',
																												 );
	$group[$gc]["row"][$rowcounter]["inputs"][1] = array("desc" => getLL("leute_export_pdf_header_center"),
																												 "type" => "text",
																												 "name" => "pdf[header][center][text]",
																												 "value" => $layout["header"]["center"]["text"],
																												 "params" => 'size="50"',
																												 );
	$group[$gc]["row"][$rowcounter++]["inputs"][2] = array("desc" => getLL("leute_export_pdf_header_right"),
																												 "type" => "text",
																												 "name" => "pdf[header][right][text]",
																												 "value" => $layout["header"]["right"]["text"],
																												 "params" => 'size="50"',
																												 );
	$group[$gc]["row"][$rowcounter]["inputs"][0] = array("desc" => getLL("leute_export_pdf_footer_left"),
																												 "type" => "text",
																												 "name" => "pdf[footer][left][text]",
																												 "value" => $layout["footer"]["left"]["text"],
																												 "params" => 'size="50"',
																												 );
	$group[$gc]["row"][$rowcounter]["inputs"][1] = array("desc" => getLL("leute_export_pdf_footer_center"),
																												 "type" => "text",
																												 "name" => "pdf[footer][center][text]",
																												 "value" => $layout["footer"]["center"]["text"],
																												 "params" => 'size="50"',
																												 );
	$group[$gc]["row"][$rowcounter++]["inputs"][2] = array("desc" => getLL("leute_export_pdf_footer_right"),
																												 "type" => "text",
																												 "name" => "pdf[footer][right][text]",
																												 "value" => $layout["footer"]["right"]["text"],
																												 "params" => 'size="50"',
																												 );

	$smarty->assign("tpl_titel", getLL("leute_export_pdf").": ".$_layout["name"]);
	$smarty->assign("tpl_submit_value", getLL("leute_export_pdf_submit"));
	$smarty->assign("tpl_action", "do_export_pdf");
	$smarty->assign("tpl_cancel", "show_all");
	$smarty->assign("tpl_groups", $group);
	$smarty->assign("tpl_hidden_inputs", array(0 => array("name" => "layout_id", "value" => $layout_id)));

	$smarty->display('ko_formular.tpl');
}//ko_export_leute_as_pdf_settings()




/**
 * Exports address data as pdf file
 */
function ko_export_leute_as_pdf($layout_id, $settings="", $force=FALSE) {
	global $ko_path;
	global $group_view;
	global $all_groups;
	global $LEUTE_EXPORT_CHILDREN_COLUMNS;

	$z_where = "";
	if(!$layout_id) return FALSE;

	if(!$all_groups) ko_get_groups($all_groups);
	$all_datafields = db_select_data("ko_groups_datafields", "WHERE 1=1", "*");


	//Get selected layout
	$_layout = db_select_data("ko_pdf_layout", "WHERE `id` = '$layout_id'", "*", "", "", TRUE);
	$layout = unserialize($_layout["data"]);
	/**
	 * Array as it is stored in ko_pdf_layout
	 **
	$layout = array("page" => array("orientation" => "L", "margin_left" => 10, "margin_top" => 10, "margin_right" => 10, "margin_bottom" => 10),
									"header" => array("left" => array("font" => "arialb", "fontsize" => "13"), "center" => array(), "right" => array()),
									"footer" => array("left" => array("font" => "arial", "fontsize" => "10"), "center" => array(), "right" => array()),
									"headerrow" => array("font" => "arialb", "fontsize" => "11", "fillcolor" => "255"),
									"columns" => array("vorname", "nachname", "plz", "ort"),
									"columns_datafields" => FALSE,
									"columns_children" => FALSE,
									"filter" => array(),
									"sort" => "nachname",
									"sort_order" => "ASC",
									"col_template" => array("_default" => array("font" => "arial", "fontsize" => "11")),
									);
	**/


	//GET-Data
	$post = $settings ? $settings : $_POST["pdf"];
	
	/* Columns to be used */
	$cols = array();
	//Get columns from layout
	if($post["columns"] == "_layout" && $layout["columns"]) {
		$do_cols = $layout["columns"];
	}
	//Get columns as array from post (used for T3-Extension kool_leute)
	else if(is_array($post["columns"]) && sizeof($post["columns"]) > 0) {
		$do_cols = $post["columns"];
	}
	//Get columns from userprefs
	else if($post["columns"] && $post["columns"] != "_current") {
		if(substr($post['columns'], 0, 3) == '@G@') $value = ko_get_userpref('-1', substr($post["columns"], 3), "leute_itemset");
		else $value = ko_get_userpref($_SESSION["ses_userid"], $post["columns"], "leute_itemset");
		$do_cols = explode(",", $value[0]["value"]);
	}
	//Otherwise use the currently displayed columns
	else {
		$do_cols = $_SESSION["show_leute_cols"];
	}
	$layout["columns_datafields"] = $post["columns_datafields"] ? TRUE : FALSE;
	$layout["columns_children"] = $post["columns_children"] ? TRUE : FALSE;


	//Add children columns if given
	if($layout["columns_children"] && is_array($LEUTE_EXPORT_CHILDREN_COLUMNS)) {
		foreach($LEUTE_EXPORT_CHILDREN_COLUMNS as $col) {
			$ll = getLL("leute_children_col".$col);
			$leute_col_name_add[$col] = $ll ? $ll : substr($col, 1);
			$do_cols[] = $col;
		}
	}

	//Prepare columns with group/groupdatafield info
	$leute_col_name = ko_get_leute_col_name($groups_hierarchie=FALSE, $add_group_datafields=TRUE, "view", $force);
	$leute_col_name = array_merge($leute_col_name, (array)$leute_col_name_add);

	foreach($do_cols as $c) {
		if(substr($c, 0, 9) == "MODULEgrp") {
			$cols[$c] = $leute_col_name[$c];
			if($layout["columns_datafields"]) {  //Add datafields
				foreach(explode(",", $all_groups[substr($c, 9)]["datafields"]) as $fid) {
					if(!isset($all_datafields[$fid])) continue;
					$cols[$c.":".$fid] = $leute_col_name[$c.":".$fid];
				}
			}
		} else {
			$cols[$c] = $leute_col_name[$c];
		}
	}
	$layout["columns"] = $cols;


	/* Sorting */
	if($layout["sort"]) {
		$layout["sort"] = array($layout["sort"]);
		$layout["sort_order"] = array($layout["sort_order"]);
	} else {
		$layout["sort"] = $_SESSION["sort_leute"];
		$layout["sort_order"] = $_SESSION["sort_leute_order"];
	}


	/* Get Filter */
	if($post["filter"] == "_layout") {
		$do_filter = $layout["filter"];
	}
	//Use my list
	else if($post['filter'] == '_mylist') {
		if(sizeof($_SESSION['my_list']) > 0) {
			$z_where = " AND `id` IN ('".implode("','", $_SESSION['my_list'])."') ";
		} else {
			$z_where = ' AND 1=2 ';
		}
	}
	//Get filter as array from post (used for T3-Extension kool_leute)
	else if(is_array($post["filter"]) && sizeof($post["filter"]) > 0) {
		$z_where = $post["filter"]["where"];
	}
	//Get filter from userpref
	else if($post["filter"] && $post["filter"] != "_current") {
		if(substr($post['filter'], 0, 3) == '@G@') {
			$value = ko_get_userpref('-1', "", "filterset");
			$post['filter'] = substr($post['filter'], 3);
		} else $value = ko_get_userpref($_SESSION["ses_userid"], "", "filterset");
		foreach($value as $v_i => $v) {
			if($v["key"] == $post["filter"]) $do_filter = unserialize($value[$v_i]["value"]);
		}
	}
	//Use current filter
	else {
		$do_filter = $_SESSION["filter"];
	}



	//Header and Footer
	$layout["header"]["left"]["text"] = $post["header"]["left"]["text"];
	$layout["header"]["center"]["text"] = $post["header"]["center"]["text"];
	$layout["header"]["right"]["text"] = $post["header"]["right"]["text"];
	$layout["footer"]["left"]["text"] = $post["footer"]["left"]["text"];
	$layout["footer"]["center"]["text"] = $post["footer"]["center"]["text"];
	$layout["footer"]["right"]["text"] = $post["footer"]["right"]["text"];


	//PDF starten
	define('FPDF_FONTPATH',$ko_path.'fpdf/schriften/');
	require_once($ko_path.'fpdf/pdf_leute.php');
	$pdf = new PDF_leute($layout["page"]["orientation"], 'mm', 'A4');
  $pdf->Open();
	$pdf->layout = $layout;
	$pdf->SetAutoPageBreak(true, $layout["page"]["margin_bottom"]);

	//Find fonts actually used in this document
	$used_fonts = array();
	foreach(array("header", "footer") as $i) {
		foreach(array("left", "center", "right") as $j) {
			$used_fonts[] = $layout[$i][$j]["font"];
		}
	}
	$used_fonts[] = $layout["headerrow"]["font"];
	$used_fonts[] = $layout["col_template"]["_default"]["font"];
	$used_fonts = array_unique($used_fonts);
	//Add fonts
	$fonts = ko_get_pdf_fonts();
	foreach($fonts as $font) {
		if(!in_array($font["id"], $used_fonts)) continue;
		$pdf->AddFont($font["id"], '', $font["file"]);
	}

	//$pdf->border(TRUE);
	$pdf->SetMargins($layout["page"]["margin_left"], $layout["page"]["margin_top"], $layout["page"]["margin_right"]);

	//Prepare replacement-array for header and footer
	$map["[[Day]]"] = strftime("%d", time());
	$map["[[Month]]"] = strftime("%m", time());
	$map["[[MonthName]]"] = strftime("%B", time());
	$map["[[Year]]"] = strftime("%Y", time());
	$map["[[Hour]]"] = strftime("%H", time());
	$map["[[Minute]]"] = strftime("%M", time());
	$map["[[kOOL-URL]]"] = $BASE_URL;
	$pdf->header_map = $map;

	//Set column widths
	/*
	$widths = array();
	$page_width = $pdf->w-$layout["page"]["margin_left"]-$layout["page"]["margin_right"];
	foreach($layout["columns"] as $col) {
		if($layout["col_template"][$col]["width"]) {
			$widths[] = $layout["col_template"][$col]["width"];
		} else if($layout["col_template"]["_default"]["width"]) {
			$widths[] = $layout["col_template"]["_default"]["width"];
		} else {
			$widths[] = $page_width/sizeof($layout["columns"]);
		}
	}
	$pdf->SetWidths($widths);
	*/

	//Get data from ko_leute
	foreach($layout["sort"] as $i => $col) {
		if(substr($col, 0, 6) != "MODULE") {
			$sort_add[] = $col." ".$layout["sort_order"][$i];
		}
	}
	if(!in_array("nachname", $layout["sort"])) $sort_add[] = "nachname ASC";
	if(!in_array("vorname", $layout["sort"])) $sort_add[] = "vorname ASC";
	$sql_sort = "ORDER BY ".implode(", ", $sort_add);
	//z_where can be set if called by T3 extension kool_leute through get.php
	if(!$z_where) apply_leute_filter($do_filter, $z_where, !$group_view);
	ko_get_leute($all, $z_where, "", "", $sql_sort);
	if(TRUE === ko_manual_sorting($layout["sort"])) {
		$all = ko_leute_sort($all, $layout["sort"], $layout["sort_order"], TRUE, $forceDatafields=TRUE);
	}

	for($i = 0; $i < 2; $i++) {

		//First loop: Gather string widths for whole table
		if($i == 0) {
			$find_widths = TRUE;

			//Add header titles
			$string_widths = array();
			$colcounter = 0;
			$pdf->SetFont($pdf->layout["headerrow"]["font"], "", $pdf->layout["headerrow"]["fontsize"]);
			foreach($pdf->layout["columns"] as $colName) {
				$string_widths[$colcounter][] = $pdf->getStringWidth($colName);
				$headerwidth[$colcounter] = $pdf->getStringWidth($colName);
				$colcounter++;
			}
		}

		//Second loop: Use string widths to calculate columns widths for table
		else {
			//Calculate column widths for all columns
			foreach($string_widths as $col => $values) {
				$num = $sum = $max = 0;
				foreach($values as $value) {
					if($value == 0) continue;
					$sum += $value;
					$num++;
					$max = max($max, $value);
				}
				$averages[$col] = $sum/$num;
				$maxs[$col] = $max;
			}

			//Find total width of full text
			$page_width = $pdf->w-$layout["page"]["margin_left"]-$layout["page"]["margin_right"];
			$maxwidth = $page_width/3;
			//Don't let a single column use more than a third of the page width
			foreach($averages as $col => $width) {
				if($width > $maxwidth) $averages[$col] = $maxwidth;
				$maxs[$col] = min($maxs[$col], $maxwidth);
			}
			//Keep a minimum column width of 10mm
			$minwidth = 10;
			foreach($averages as $col => $width) {
				if($width < $minwidth) $averages[$col] = $minwidth;
			}

			$total_width = 0;
			foreach($averages as $col => $width) $total_width += $width;

			//Use space to enlarge the columns where the header is wider than the column
			if($total_width < $page_width) {
				$total_need = 0; $need = array();
				//Find needs for all columns
				foreach($averages as $col => $width) {
					if($width < $headerwidth[$col]) {
						$need[$col] = $headerwidth[$col]-$width;
						$total_need += $need[$col];
					}
				}
				$need_factor = ($page_width-$total_width) / $total_need;
				foreach($averages as $col => $value) {
					if($need[$col]) {
						//Only grow the row to the width of the headertext
						$new_max = $value + $need_factor*$need[$col];
						$averages[$col] = min($headerwidth[$col], $new_max);
					}
				}
			}

			//Use space to enlarge the columns where the content is wider than the column width
			if($total_width < $page_width) {
				$total_need = 0; $need = array();
				//Find needs for all columns
				foreach($averages as $col => $width) {
					if($width < $maxs[$col]) {
						$need[$col] = $maxs[$col]-$width;
						$total_need += $need[$col];
					}
				}
				$need_factor = ($page_width-$total_width) / $total_need;
				foreach($averages as $col => $value) {
					if($need[$col]) {
						//Only grow the row to the width of the headertext
						$new_max = $value + $need_factor*$need[$col];
						$averages[$col] = min($maxs[$col], $new_max);
					}
				}
			}

			$total_width = 0;
			foreach($averages as $col => $width) $total_width += $width;

			//Get scaling factor
			$factor = $page_width / $total_width;

			//Calculate single widths for all columns
			$widths = array();
			foreach($averages as $value) {
				$widths[] = $factor*$value;
			}
			$pdf->SetWidths($widths);

			$pdf->AddPage();
			$find_widths = FALSE;
		}


		//Loop all addresses
		foreach($all as $id => $person) {
			$row = array();
			foreach($layout["columns"] as $col => $colName) {
				//Don't include group datafield columns as they are returned in map_leute_daten(group-column)
        if(substr($col, 0, 9) == "MODULEgrp" && strstr($col, ":")) continue;

				//TODO: Set layouts for different columns (needs change in settings and in fpdf/mc_table.php)
				$value = map_leute_daten($person[$col], $col, $person, $all_datafields, $force);
				if(is_array($value)) {
					if($layout["columns_datafields"]) {
						foreach($value as $v) $row[] = ko_unhtml(strip_tags($v));
					} else {
						$row[] = ko_unhtml(strip_tags($value[0]));
					}
				} else {
					$row[] = ko_unhtml(strip_tags($value));
				}
			}//foreach(columns as col)

			//Layout for normal content
			$pdf->SetFont($layout["col_template"]["_default"]["font"], "", $layout["col_template"]["_default"]["fontsize"]);


			if($find_widths) {
				//Store width for width calculation
				foreach($row as $key => $value) $string_widths[$key][] = $pdf->getStringWidth($value);
			} else {
				//Save this row in pdf
				$pdf->SetZeilenhoehe($layout["col_template"]["_default"]["fontsize"]/2);
				$pdf->Row($row);
			}
		}//foreach(all as id => person)
	}

	$filename = $ko_path."download/pdf/".getLL("leute_filename_pdf").strftime("%d%m%Y_%H%M%S", time()).".pdf";
	$pdf->Output($filename);

	return $filename;
}//ko_export_leute_as_pdf()




/**
 * Shows address charts
 */
function ko_leute_chart($_type="") {
	global $LEUTE_CHART_TYPES;
	
	//Get SQL for current filter
	apply_leute_filter($_SESSION["filter"], $where_base, !$group_view);

	$do_types = $_type ? array($_type) : $_SESSION["show_leute_chart"];

	//Call all chart functions
	$html = array();
	foreach($do_types as $type) {
		if(!function_exists("ko_leute_chart_".$type) || !in_array($type, $LEUTE_CHART_TYPES)) continue;
		$html[$type] = call_user_func("ko_leute_chart_".$type, $where_base);
	}

	if($_type) {
		$out = '<label>'.getLL("leute_chart_title_".$type).'</label>'.$html[$type];
	} else {
		//Generate HTML output
		$out = '<div class="list_title">'.getLL("leute_chart_title").'</div><br clear="all" />';
		foreach($html as $type => $code) {
			$out .= '<div class="leute_chart" name="leute_chart_'.$type.'" id="leute_chart_'.$type.'"><label>'.getLL("leute_chart_title_".$type).'</label>'.$code.'</div>';
		}
		$out .= '<br clear="all" />';
	}

	return $out;
}//ko_leute_chart()





/**
 * Display the number of persons in all childgroups of a given group
 */
function ko_leute_chart_subgroups($where_base) {
	global $all_groups, $ko_path;

	//Get access rights and all groups
	ko_get_admin("groups", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
	if(!is_array($all_groups)) ko_get_groups($all_groups);

	//Prepare group select
	$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
	$gsel = '<select name="sel_leute_chart_subgroups_gid" size="0" onchange="sendReq(\''.$ko_path.'leute/inc/ajax.php\', \'action,gid,sesid\', \'leutechartsubgroups,\'+this.options[this.selectedIndex].value+\','.session_id().'\', do_element);">';
	$gsel .= '<option value=""></option>';
	foreach($groups as $grp) {
		if(!$group_view[$grp["id"]]) continue;
		$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
		//Display hierarchy
		$pre = "";
		$depth = sizeof($mother_line);
		for($i=0; $i<$depth; $i++) $pre .= "&nbsp;&nbsp;";
		//Build select
		$sel = $grp["id"] == $_SESSION["leute_chart_subgroups_gid"] ? 'selected = "selected"' : '';
		$gsel .= '<option value="'.$grp["id"].'" '.$sel.'>'.$pre.ko_html($grp["name"]).'</option>';
	}
	$gsel .= '</select>';


	//Draw pie chart if a group id is given
	if($_SESSION["leute_chart_subgroups_gid"]) {
		$gid = $_SESSION["leute_chart_subgroups_gid"];
		//Get all children groups
		$groups = db_select_data("ko_groups", "WHERE `pid` = '$gid' ".ko_get_groups_zwhere(), "*", "ORDER BY `name` ASC");

		$value = $label = array();
		foreach($groups as $id => $group) {
			$value[] = db_get_count("ko_leute", "id", $where_base." AND `groups` REGEXP 'g$id'");
			$label[] = strlen($group["name"]) > 15 ? ko_truncate($group["name"], 15, 4) : $group["name"];
		}

		//Create img link for preview chart
		$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
		$r .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
		$r .= '" />';

		//Create img link for popup to show bar chart a bit bigger
		$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
		$p .= '&size=1000x450&yValueMode=3&textXOrientation=vertical';

		$graph = '<a href="'.$p.'" target="_blank">'.$r.'</a>';
	}//if(_SESSION[leute_chart_roles_gid])

	return getLL("leute_chart_subgroups_select_group")."<br />".$gsel."<br />".$graph;
}//ko_leute_chart_subgroups()




/**
 * Display roles for the selected group and all its subgroups
 */
function ko_leute_chart_roles($where_base) {
	global $all_groups, $ko_path;

	//Get access rights and all groups
	ko_get_admin("groups", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
	if(!is_array($all_groups)) ko_get_groups($all_groups);

	//Prepare group select
	$groups = ko_groups_get_recursive(ko_get_groups_zwhere());
	$gsel = '<select name="sel_leute_chart_roles_gid" size="0" onchange="sendReq(\''.$ko_path.'leute/inc/ajax.php\', \'action,gid,sesid\', \'leutechartroles,\'+this.options[this.selectedIndex].value+\','.session_id().'\', do_element);">';
	$gsel .= '<option value=""></option>';
	foreach($groups as $grp) {
		if(!$group_view[$grp["id"]]) continue;
		$mother_line = ko_groups_get_motherline($grp["id"], $all_groups);
		//Display hierarchy
		$pre = "";
		$depth = sizeof($mother_line);
		for($i=0; $i<$depth; $i++) $pre .= "&nbsp;&nbsp;";
		//Build select
		$sel = $grp["id"] == $_SESSION["leute_chart_roles_gid"] ? 'selected = "selected"' : '';
		$gsel .= '<option value="'.$grp["id"].'" '.$sel.'>'.$pre.ko_html($grp["name"]).'</option>';
	}
	$gsel .= '</select>';


	//Draw pie chart if a group id is given
	if($_SESSION["leute_chart_roles_gid"]) {
		$_value = $_label = array();
		$gid = $_SESSION["leute_chart_roles_gid"];
		$group = $all_groups[$gid];

		//Go through all roles but only display those with at least one entry
		//This way also roles of subgroups will get displayed, even if a dummy group was selected
		ko_get_grouproles($roles);
		foreach($roles as $role) {
			$num = db_get_count("ko_leute", "id", $where_base." AND `groups` REGEXP 'g".$gid."[g:0-9]*r".$role["id"]."'");
			if($num) {
				$_value[] = $num;
				$_label[] = $role["name"];
			}
		}
		//Add all persons assigned without a role
		$num = db_get_count("ko_leute", "id", $where_base." AND `groups` REGEXP 'g".$gid."[g:0-9]*' AND `groups` NOT REGEXP 'g".$gid."[g:0-9]*r[0-9]{6}'");
		if($num) {
			$_value[] = $num;
			$_label[] = getLL("leute_chart_none");
		}

		//Sort descending by num
		arsort($_value);
		$value = $label = array();
		foreach($_value as $vi => $v) {
			$value[] = $v;
			$label[] = $_label[$vi];
		}

		$graph = '<img src="'.$ko_path.'inc/graph_piechart.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label)).'" />';
	}//if(_SESSION[leute_chart_roles_gid])

	return getLL("leute_chart_roles_select_group")."<br />".$gsel."<br />".$graph;
}//ko_leute_chart_roles()



/**
 * Chart function for addresses
 * Pie chart showing age distribution
 */
function ko_leute_chart_age_pie($where_base) {
	global $ko_path;

	$value = $label = array();
	/*
	//No birthday given
	$label[] = getLL("leute_chart_none");
	$where = $where_base." AND `geburtsdatum` = '0000-00-00'";
	$value[] = db_get_count("ko_leute", "id", $where);
	*/

	//Get number of people for these age spans
	$ages = array(array(0,10), array(11,20), array(21,30), array(31,40), array(41,50), array(51,60), array(61,70), array(71,120));
	foreach($ages as $span) {
		$where = $where_base."AND `geburtsdatum` != '0000-00-00' AND YEAR(CURDATE()) - YEAR(`geburtsdatum`) >= ".$span[0]." AND YEAR(CURDATE()) - YEAR(`geburtsdatum`) <= ".$span[1];
		$value[] = db_get_count("ko_leute", "id", $where);
		$label[] = $span[0]."-".$span[1];
	}
	return '<img src="'.$ko_path.'inc/graph_piechart.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label)).'" />';
}//ko_leute_chart_age_pie()



/**
 * Chart function for addresses
 * Pie chart showing age distribution
 */
function ko_leute_chart_age_bar($where_base) {
	global $ko_path, $db;

	$value = $label = array();
	/*
	//No birthday given
	$label[] = getLL("leute_chart_none");
	$where = $where_base." AND `geburtsdatum` = '0000-00-00'";
	$value[] = db_get_count("ko_leute", "id", $where);
	*/

	$query = "SELECT YEAR(CURDATE())-YEAR(`geburtsdatum`) AS `age`, COUNT(`id`) AS `num` FROM `ko_leute` WHERE `geburtsdatum` != '0000-00-00' $where_base GROUP BY `age` ORDER BY `age` ASC";
	$result = $db->query($query);
	$data = array(); $min = 100; $max = 0;
	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
		$data[$row["age"]] = $row["num"];
		$min = min($min, $row["age"]);
		$max = max($max, $row["age"]);
	}
	for($i = $min; $i<= $max; $i++) {
		$value[] = $data[$i];
		$label[] = $i;
	}
	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=0&xStep=10';
	$r .= '&title='.urlencode(getLL("leute_chart_title_age_bar"));
	$r .= '&title_x='.urlencode(getLL("leute_chart_title_age_bar_x"));
	$r .= '&title_y='.urlencode(getLL("leute_chart_title_age_bar_y"));
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size=1000x450&yValueMode=3&xStep=5';
	$p .= '&title='.urlencode(getLL("leute_chart_title_age_bar"));
	$p .= '&title_x='.urlencode(getLL("leute_chart_title_age_bar_x"));
	$p .= '&title_y='.urlencode(getLL("leute_chart_title_age_bar_y"));

	$out = '<a href="'.$p.'" target="_blank">'.$r.'</a>';

	return $out;
}//ko_leute_chart_age_bar()



/**
 * Shows a bar chart for all rota teams with the number of members and leaders
 */
function ko_leute_chart_rotateams($where_base) {
	global $ko_path;

	$value = $label = array();

	ko_get_dienste($teams);
	foreach($teams as $id => $team) {
		ko_get_leute_by_dienst($m, $id);
		ko_get_leiter_by_dienst($l, $id);
		$value[] = sizeof($m)+sizeof($l);
		$label[] = ko_truncate($team["name"], 15, 4);
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=3&textXOrientation=vertical';
	$r .= '" />';

	//Create img link for popup to show bar chart a bit bigger
	$p  = $ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$p .= '&size=1000x450&yValueMode=3&textXOrientation=vertical';

	$out = '<a href="'.$p.'" target="_blank">'.$r.'</a>';

	return $out;
}//ko_leute_chart_rotateams()





/**
 * Chart function for addresses
 * Pie chart showing birthday months
 */
function ko_leute_chart_birthday_months($where_base) {
	global $ko_path;

	/* Birthday months */
	$value = $label = array();
	for($m=1; $m<=12; $m++) {
		$where = $where_base."AND `geburtsdatum` != '0000-00-00' AND MONTH(`geburtsdatum`) = '$m'";
		$value[] = db_get_count("ko_leute", "id", $where);
		$label[] = strftime("%B", mktime(1,1,1, $m, 1, 2000));
	}
	return '<img src="'.$ko_path.'inc/graph_piechart.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label)).'" />';
}//ko_leute_chart_birthday_months()






function ko_leute_chart_generic_pie_enum($table, $where_base, $col, $ll_prefix="", $return_data=FALSE) {
	global $ko_path;

	$enums = db_get_enums($table, $col);
	$value = $label = array();
	foreach($enums as $v) {
		$value[] = db_get_count($table, "id", $where_base." AND `$col` = '$v'");
		if($v) {
			$ll = getLL($ll_prefix.$v);
			$label[] = $ll ? $ll : $v;
		} else {
			$label[] = getLL("leute_chart_none");
		}
	}

	if($return_data) {
		return array("value" => $value, "label" => $label);
	} else {
		return '<img src="'.$ko_path.'inc/graph_piechart.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label)).'" />';
	}
}//ko_leute_chart_generic_pie_enum()


function ko_leute_chart_sex($where_base) {
	return ko_leute_chart_generic_pie_enum("ko_leute", $where_base, "geschlecht", "ko_leute_geschlecht_");
}


function ko_leute_chart_famfunction($where_base) {
	$where_base .= " AND `famid` != '' ";
	return ko_leute_chart_generic_pie_enum("ko_leute", $where_base, "famfunction", "ko_leute_famfunction_");
}




/**
 * Generic stats function for pie chart showing the first $max entries for the given $col
 */
function ko_leute_chart_generic_pie($table, $where_base, $col, $max=12) {
	global $ko_path, $db;

	$value = $label = array();
	$query = "SELECT `$col`, COUNT(`id`) AS num FROM `$table` WHERE `$col` != '' $where_base GROUP BY `$col` ORDER BY `num` DESC";
	$result = $db->query($query);
	$num = 0; $div = 0;
	while($row = $result->fetchRow(DB_FETCHMODE_ASSOC)) {
		$num++;
		if($num > $max) {
			$div += $row["num"];
			continue;
		}
		$value[] = $row["num"];
		$label[] = $row[$col];
	}
	if($div) {
		$value[] = $div;
		$label[] = getLL("leute_chart_misc");
	}

	return '<img src="'.$ko_path.'inc/graph_piechart.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label)).'" />';
}//ko_leute_chart_generic_pie()


function ko_leute_chart_city($where_base) {
	return ko_leute_chart_generic_pie("ko_leute", $where_base, "ort", 12);
}


function ko_leute_chart_zip($where_base) {
	return ko_leute_chart_generic_pie("ko_leute", $where_base, "plz", 12);
}


function ko_leute_chart_country($where_base) {
	return ko_leute_chart_generic_pie("ko_leute", $where_base, "land", 12);
}



function ko_leute_chart_lastchange($where_base) {
	global $ko_path, $DATETIME;

	$span = 30;
	$value = $label = array();
	$time = strtotime("-$span days");
	for($i=$span; $i>=0; $i--) {
		$value[] = db_get_count("ko_leute", "id", $where_base." AND `lastchange` REGEXP '".strftime("%Y-%m-%d", $time)."'");
		$label[] = strftime($DATETIME["dmy"], $time);
		$time = strtotime("+1 day", $time);
	}

	//Create img link for preview chart
	$r  = '<img border="0" src="'.$ko_path.'inc/graph_bar.php?data='.implode("*", $value).'&label='.urlencode(implode("*", $label));
	$r .= '&size=400x250&yValueMode=0&textXOrientation=vertical&xStep=2';
	$r .= '&title='.urlencode(getLL("leute_chart_title_lastchange"));
	$r .= '&title_x='.urlencode(getLL("leute_chart_title_lastchange_x"));
	$r .= '&title_y='.urlencode(getLL("leute_chart_title_lastchange_y"));
	$r .= '" />';

	return $r;
}

?>
