<?php
/***************************************************************
*  Copyright notice
*
*  (c) 2003-2010 Renzo Lauper (renzo@churchtool.org)
*  All rights reserved
*
*  This script is part of the kOOL project. The kOOL project is
*  free software; you can redistribute it and/or modify
*  it under the terms of the GNU General Public License as published by
*  the Free Software Foundation; either version 2 of the License, or
*  (at your option) any later version.
*
*  The GNU General Public License can be found at
*  http://www.gnu.org/copyleft/gpl.html.
*  A copy is found in the textfile GPL.txt and important notices to the license
*  from the author is found in LICENSE.txt distributed with these scripts.
*
*  kOOL is distributed in the hope that it will be useful,
*  but WITHOUT ANY WARRANTY; without even the implied warranty of
*  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
*  GNU General Public License for more details.
*
*  This copyright notice MUST APPEAR in all copies of the script!
***************************************************************/

ob_start();  //Ausgabe-Pufferung einschalten

$ko_path = "../";
$ko_menu_akt = "leute";

include_once($ko_path . "inc/ko.inc");
include_once("inc/leute.inc");

if(ko_module_installed("sms")) include_once($ko_path . "inc/Clickatell.php");

if(!ko_module_installed("leute")) {
	header("Location: ".$BASE_URL."index.php");  //Absolute URL
}

ob_end_flush();


$error = $info = 0;

//***Rechte auslesen:
list($item_view, $item_new, $item_edit, $item_gs) = ko_get_admin("leute", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
if(ko_module_installed("kg")) ko_get_admin("kg", $_SESSION["ses_userid"], $kg_view, $kg_new, $kg_edit, $kg_mod);
if(ko_module_installed("groups")) {
	ko_get_admin("groups", $_SESSION["ses_userid"], $g_view, $g_new, $g_edit, $g_mod);
	ko_get_groups($all_groups);
}
if(ko_module_installed("dp")) {
	ko_get_admin("dp", $_SESSION["ses_userid"], $d_view, $d_new, $d_edit, $d_mod);
}



//Smarty-Templates-Engine laden
require_once("$ko_path/inc/smarty.inc");


//kOOL Table Array
include_once($ko_path . "inc/kota.inc");


//*** Plugins einlesen:
$hooks = hook_include_main("leute,kg");
if(sizeof($hooks) > 0) foreach($hooks as $hook) include_once($hook);


//***Action auslesen:
if($_POST["action"]) {
	$do_action = $_POST["action"];
	$action_mode = "POST";
} else if($_GET["action"]) {
	$do_action = $_GET["action"];
	$action_mode = "GET";
} else {
	$do_action = $action_mode = "";
}

if(FALSE === format_userinput($do_action, "alphanum+", TRUE, 50)) trigger_error("invalid action: ".$do_action, E_USER_ERROR);

switch($do_action) {

	//Anzeige
	case "show_all":
		$_SESSION["show"] = "show_all";
		$_SESSION["show_start"] = 1;
		$onload_code = "form_set_focus('fastfilter2');".$onload_code;
	break;


	case "show_adressliste":
		$_SESSION["show"] = "show_adressliste";
		$_SESSION["show_start"] = 1;
		$onload_code = "form_set_focus('fastfilter2');".$onload_code;
	break;


	case "show_geburtstagsliste":
		$_SESSION["show"] = "geburtstagsliste";
	break;


	case "single_view":
		$single_id = format_userinput($_GET["id"], "uint");
		if($group_view || $item_view[$single_id]) {
			$_SESSION["show"] = "single_view";
		}
	break;



	case "show_aa":
		$_SESSION["show"] = "mutationsliste";
	break;

	case "show_groupsubscriptions":
		$_SESSION["show"] = "groupsubscriptions";
	break;





	//My-List
	case "add_to_my_list":
		foreach($_POST["chk"] as $c_i => $c) {
			if($c) {
				if(FALSE === ($value = format_userinput($c_i, "uint", TRUE, 10))) {
					trigger_error("Not allowed my_list selection: $c_i", E_USER_ERROR);
				}
				$_SESSION["my_list"][$value] = $value;
			}
		}
    ko_save_userpref($_SESSION["ses_userid"], "leute_my_list", serialize($_SESSION["my_list"]));
	break;

	case "del_from_my_list":
		foreach($_POST["chk"] as $c_i => $c) {
			if($c) unset($_SESSION["my_list"][$c_i]);
		}
    ko_save_userpref($_SESSION["ses_userid"], "leute_my_list", serialize($_SESSION["my_list"]));
	break;

	case "clear_my_list":
		$_SESSION["my_list"] = array();
    ko_save_userpref($_SESSION["ses_userid"], "leute_my_list", serialize($_SESSION["my_list"]));
	break;

	case "show_my_list":
		$_SESSION["show"] = "show_my_list";
		$_SESSION["show_start"] = 1;
	break;




	//Neu
	case "neue_person":
		$_SESSION["show_back"] = $_SESSION["show"];
		$_SESSION["show"] = "neue_person";
		$onload_code = "form_set_first_input();".$onload_code;
	break;

	case "submit_neue_person":
	case "submit_edit_person":
	case "submit_als_neue_person":
		//Beim Editieren auf korrekte Leute-ID prfen
		if($do_action == "submit_edit_person") {
			if(!$_POST["leute_id"] || !format_userinput($_POST["leute_id"], "uint", TRUE, 10)) continue;
			$leute_id = format_userinput($_POST["leute_id"], "uint");
			ko_get_person_by_id($leute_id, $person);
			$action = "submit_edit_person";
		}
		//New person or "save as new person" for an existing one
		else if($do_action == "submit_als_neue_person" || $do_action == "submit_neue_person") {
			//Create a new entry and store new id
			db_insert_data("ko_leute", array("id" => "NULL", "crdate" => date("Y-m-d H:i:s"), "cruserid" => $_SESSION["ses_userid"]));
			//Simulate editing with new id
			$action = "submit_edit_person";
			$leute_id = Mysql_Insert_ID($db->connection);
		  //Everything as when editing, but a new LDAP entry has to be created
			$ldap_new_entry = TRUE;
		}//if(do_action == submit_als_neue_person)
		else {
			continue;
		}

		if($group_new || $item_new || (ko_get_setting("login_edit_person") == 1 && $leute_id == ko_get_logged_in_id())) {} else continue;

		//Funktion (kundenspezifisch) einlesen, die Variablen speziell behandeln lsst
		if(file_exists($ko_path."leute/inc/my_fcn_leute.inc")) {
			include_once($ko_path."leute/inc/my_fcn_leute.inc");
		}
		$log_message = "";


		//LDAP
		$do_ldap = ko_do_ldap();
		unset($ldap_entry);


		//Datenbank-Spalten auslesen
	  $leute_cols = db_get_columns("ko_leute");
		$col_namen = ko_get_leute_col_name();

		//get the cols, for which this user has edit-rights (saved in allowed_cols[edit])
		$allowed_cols = ko_get_leute_admin_spalten($_SESSION["ses_userid"], "all");
		//add cols of MODULES, if allowed
		//Handle view and edit separately because if only one of them is set for a login,
		//the test is_array() has to be called separately, so allowed_cols doesn't get turned into an array.
		if(is_array($allowed_cols["view"]) && sizeof($allowed_cols["view"]) > 0) {
			if($g_view) $allowed_cols["view"][] = "groups";
			if($kg_view) $allowed_cols["view"][] = "kg";
			if($kg_view) $allowed_cols["view"][] = "kg_leiter";
			if($d_view) $allowed_cols["view"][] = "dienst";
			if($d_mod) $allowed_cols["view"][] = "dienstleiter";
		}
		if(is_array($allowed_cols["edit"]) && sizeof($allowed_cols["edit"]) > 0) {
			if($g_new) $allowed_cols["edit"][] = "groups";
			if($kg_new) $allowed_cols["edit"][] = "kg";
			if($kg_new) $allowed_cols["edit"][] = "kg_leiter";
			if($d_new) $allowed_cols["edit"][] = "dienst";
			if($d_mod) $allowed_cols["edit"][] = "dienstleiter";
		}


		/* Familien-Daten speichern */
		if(!is_array($allowed_cols["edit"]) || in_array("famid", $allowed_cols["edit"])) {
			$do_update_familie = FALSE;  //Familiendaten - falls ntig - erst nach Speichern der Person updaten
			$new_familie = FALSE;
			$old_famid  = $person["famid"];

			//Neue Familie
			if($_POST["hid_new_family"] == 1) {
				$save_famid = db_insert_data("ko_familie", array("nachname" => ""));
				$new_familie = TRUE;
			} else {
				$save_famid = format_userinput($_POST["sel_familie"], "uint");
			}

			//Familie gendert
			if($save_famid != $old_famid) {
				$log_message .= getLL("leute_log_family").": $old_famid --> $save_famid, ";

				//Alte Familie lschen, falls keine Mitglieder mehr
				if($old_famid != 0) {
					$num = ko_get_personen_by_familie($old_famid, $asdf);
					if($num <= 1) ko_del_familie($old_famid);
				}
			}
			//Gleiche Familie oder eine neue, dann Familiendaten speichern
			if($save_famid == $old_famid || $new_familie) {
				$familien_cols = db_get_columns("ko_familie");
				foreach($familien_cols as $col_) {
					$col = $col_["Field"];
					if($col && in_array($col, $LEUTE_TEXTSELECT) && $_POST["input_".$col."_2"]) {
						$fam_data[$col] = format_userinput($_POST["input_".$col."_2"], "text");
					} else if($col && isset($_POST["input_".$col])) {
						$fam_data[$col] = format_userinput($_POST["input_".$col], "text");
					}
				}
				$do_update_familie = TRUE;
			}//if..else(save_famid != old_famid)
		}//if(in_array(famid, allowed_cols[edit]))



	  foreach($leute_cols as $c_i => $c) {
	    if(in_array($c["Field"], $LEUTE_EXCLUDE)) continue;
			//don't save not allowed columns (edit)
			if(is_array($allowed_cols["edit"]) && !in_array($c["Field"], $allowed_cols["edit"])) continue;

			$dont_log = FALSE;

			//Groups-Modul
			if($c["Field"] == "groups") {
				//Ntige rechte Checken
				$go_on = (ko_module_installed("groups") && $g_new);
				if(!$go_on) continue;

				ko_groups_get_savestring($_POST["input_groups"], array("id" => $leute_id), $log, $person["groups"]);
				//Store current datafields for versioning (stored with ko_save_leute_changes())
				$datafields = ko_get_datafields($leute_id);
				//Store datafields in DB
				ko_groups_save_datafields($_POST["group_datafields"], array("id" => $leute_id, "groups" => $_POST["input_groups"], "old_groups" => $person["groups"]), $log2);

				//Log-Message:
				$dont_log = TRUE;
				if(trim($log) != "") $log_message .= getLL("leute_log_groups").": $log";
				if(trim($log2) != "") $log_message .= getLL("leute_log_datafields").": $log2";
			}//groups-Modul

			//KG-Modul
			if($c["Field"] == "kg" || $c["Field"] == "kg_leiter") {
				$go_on = (ko_module_installed("kg") && $kg_new);
				if(!$go_on) continue;
			}

			//Dienste-Modul
			if($c["Field"] == "dienst" || $c["Field"] == "dienstleiter") {
				$rights_d = $c["Field"] == "dienst" ? $d_edit : $d_mod;
				$go_on = (ko_module_installed("dp") && $rights_d);
				if(!$go_on) continue;

				//Behandlung der Dienste
				//Einzeln hinzufgen oder lschen, damit Rechte eingehalten werden. (Bestehende, nicht anzeigbare wrden sonst gelscht, da nicht in Formular)
				$bisher   = explode(",", $person[$c["Field"]]);
				$submited = explode(",", $_POST["input_".$c["Field"]]);
				$log = "";
				//Neu eingetragene:
				foreach($submited as $s) {
					if(!in_array($s, $bisher) && $rights_d[$s]) {
						$bisher[] = $s;
						$log .= "+".ko_dienstliste($s).", ";
					}
				}
				//Gelschte:
				foreach($bisher as $b_i => $b) {
					if($rights_d[$b] && !in_array($b, $submited)) {
						unset($bisher[$b_i]);
						$log .= "-".ko_dienstliste($b).", ";
					}
				}
				$_POST["input_".$c["Field"]] = implode(",", $bisher);

				//Log-Meldung:
				$dont_log = TRUE;
				if(trim($log) != "") $log_message .= $c["Field"].": $log";
			}//Dienst-Modul


			$endpos = strpos($c["Type"], "(") ? strpos($c["Type"], "(") : strlen($c["Type"]);
			$endpos2 = strpos($c["Type"], ")") ? strpos($c["Type"], ")") : strlen($c["Type"]);
			$input_type = substr($c["Type"], 0, $endpos);
			$input_size = ($endpos && $endpos2) ? substr($c["Type"], ($endpos+1), ($endpos2-$endpos-1)) : 0;

			switch($input_type) {

				case "varchar": //Textfeld
				case "tinyint":
				case "smallint":
				case "mediumint":
				case "blob":
				case "enum":
				case "text":
					if(in_array($c["Field"], $LEUTE_TEXTSELECT) && $_POST["input_".$c["Field"]."_2"]) {
						$data[$c["Field"]] = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
					}
					else if(in_array($c["Field"], $LEUTE_ENUMPLUS) && $_POST["input_".$c["Field"]."_2"]) {
						//Enum-Definition neu erstellen
						$options = db_get_enums("ko_leute", $c["Field"]);
						$options[] = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
						sort($options);
						reset($options);
						$enum_code = "";
						foreach($options as $o) {
							$enum_code .= "'$o', ";
						}
						$enum_code = substr($enum_code, 0, -2);
						db_alter_table("ko_leute", "CHANGE `".$c["Field"]."` `".$c["Field"]."` ENUM( $enum_code ) DEFAULT NULL ");

						if(function_exists("my_enumplus")) {
							my_enumplus($c["Field"], format_userinput($_POST["input_".$c["Field"]], "text"), format_userinput($_POST["input_".$c["Field"]."_2"], "text"));
						}

						$data[$c["Field"]] = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
					} else {
						$data[$c["Field"]] = format_userinput($_POST["input_".$c["Field"]], "text");
					}
				break;

				case "date":
					$data[$c["Field"]] = sql_datum($_POST["input_".$c["Field"]]);
				break;

				//picture
				case "tinytext":
					if($_FILES["input_".$c["Field"]]["tmp_name"]) {
						$upload_name = $_FILES["input_".$c["Field"]]["name"];
						$tmp = $_FILES["input_".$c["Field"]]["tmp_name"];
						$ext_ = explode(".", $upload_name);
						$ext = $ext_[sizeof($ext_)-1];

						$path = $BASE_PATH."my_images/";
						$filename = "person_".$leute_id.".".$ext;
						$dest = $path.$filename;

						$ret = move_uploaded_file($tmp, $dest);
						if($ret) {
							$data[$c["Field"]] = "/my_images/".$filename;
							chmod($dest, 0644);
						} else {
							$data[$c["Field"]] = "";
						}
					}
					//delete picture
					else if($_POST["input_".$c["Field"]."_DELETE"] == 1) {
						$data[$c["Field"]] = "";
						if($person[$c["Field"]] && file_exists($BASE_PATH.$person[$c["Field"]])) unlink($BASE_PATH.$person[$c["Field"]]);
					}
					$test["columns"][] = $col;
				break;

			}//switch(input_type)


			//Kunden-spezifische Behandlung der Leute-Felder
			if(function_exists("my_fcn_leute")) {
				my_fcn_leute($c["Field"], format_userinput($_POST["input_".$c["Field"]], "text"), format_userinput($_POST["input_".$c["Field"]."_2"], "text"));
			}


			//Log-Message
			if(!$dont_log) {
				if($action == "submit_neue_person") {  //Alle gemachten Angaben loggen
					if($_POST["input_".$c["Field"]]) {
						$label = $col_namen[$c["Field"]];
						$value = format_userinput($_POST["input_".$c["Field"]], "text");
					} else if($_POST["input_".$c["Field"]."_2"]) {
						$label = $col_namen[$c["Field"]];
						$value = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
					}
					if($value) $log_message .= "$label: '$value', ";

				} else {  //Bei Editieren nur die loggen, die gendert wurden
					$new  = format_userinput($_POST["input_".$c["Field"]], "text");
					$new2 = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
					$old  = $c["Type"] == "date" ? map_leute_daten($person[$c["Field"]], $c["Field"], $person) : $person[$c["Field"]];
					if( ($old || $new) && $new != $old) {
						$log_message .= $col_namen[$c["Field"]].": '$old' --> '$new', ";
					} else if($new2 && $old != $new2) {
						$log_message .= $col_namen[$c["Field"]].": '$new2', ";
					}
				}
			}//if(!dont_log)


			//LDAP-Data
			if($do_ldap) {
				$label = $value = "";
				if($_POST["input_".$c["Field"]]) {
					$label = $c["Field"];
					$value = format_userinput($_POST["input_".$c["Field"]], "text");
				} else if($_POST["input_".$c["Field"]."_2"]) {
					$label = $c["Field"];
					$value = format_userinput($_POST["input_".$c["Field"]."_2"], "text");
				} else if($person[$c["Field"]] && map_leute_daten($person[$c["Field"]], $c["Field"], $person) != $_POST["input_".$c["Field"]]) {
					$ldap_entry[$LDAP_ATTRIB[$c["Field"]]] = "";
				}
				if($do_ldap && in_array($label, array_keys($LDAP_ATTRIB))) {
					if($ldap_entry[$LDAP_ATTRIB[$label]] != "") {
						$ldap_entry[$LDAP_ATTRIB[$label]] .= ($label == "ort" ? " " : "$").$value;
					} else {
						$ldap_entry[$LDAP_ATTRIB[$label]] = $value;
					}
				}
			}

	  }//foreach(leute_cols as c_i => c)


		//Check for leute_admin_groups to be added
		if((!defined(LEUTE_ADMIN_GROUPS_NEW_ONLY) || LEUTE_ADMIN_GROUPS_NEW_ONLY == FALSE)
				|| in_array($do_action, array("submit_neue_person", "submit_als_neue_person")))
			{
			$lag = ko_get_leute_admin_groups($_SESSION["ses_userid"]);
			if($lag) {
				foreach(explode(",", $lag) as $gid) {
					if(!$gid) continue;
					if(FALSE === strstr($data["groups"], $gid)) {
						$data["groups"] .= $data["groups"] != "" ? ",".$gid : $gid;
					}
				}
			}
		}



		//In DB speichern
		$data["lastchange"] = date("Y-m-d H:i:s");  //LastChange hinzufgen
	  //Familien-ID hinzufgen
		if(!is_array($allowed_cols["edit"]) || in_array("famid", $allowed_cols["edit"])) {
			$data["famid"] = $save_famid;
		}
		if($action == "submit_edit_person") {
			db_update_data("ko_leute", "WHERE `id` = '$leute_id'", $data);
		} else {
			//Not needed? as submit_neue_person is handled as submit_edit_person with id of new empty entry...?
			$leute_id = db_insert_data("ko_leute", $data);
		}


		//Familien-Daten
		//Erst nachher updaten, damit Personendaten nicht Familiendaten berschreiben
		if(!is_array($allowed_cols["edit"]) || in_array("famid", $allowed_cols["edit"])) {
			if($do_update_familie) ko_update_familie($save_famid, $fam_data, $leute_id);
			else {
				ko_update_leute_in_familie($save_famid);
				ko_update_leute_in_familie($old_famid);
			}
			ko_update_familie_filter();
		}


		//In LDAP speichern
		if($do_ldap) {
			//Create cn
			$ldap_entry["cn"] = $ldap_entry["givenName"]." ".$ldap_entry["sn"];
			if($ldap_entry["sn"] == "") $ldap_entry["sn"] = " ";

			$ldap = ko_ldap_connect();
			if($action == "submit_edit_person" && !$ldap_new_entry) {  //Als neue Person speichern, ist zwar edit, muss aber neu angelegt werden.
				$ldap_entry["uid"] = $person["id"];
				ko_ldap_add_person($ldap_entry, TRUE);
			} else {
				$ldap_entry["uid"] = $leute_id;
				ko_ldap_add_person($ldap_entry);
			}
			ko_ldap_close();
		}//if(do_ldap)


		//ezmlm: change email in mailinglist address if email has changed
		if($action != 'submit_neue_person' && defined("EXPORT2EZMLM") && EXPORT2EZMLM) {
			$old_email = $person['email']; $new_email = $_POST['input_email'];
			if($old_email != $new_email && check_email($new_email)) {  //Check for changed valid email
				foreach(explode(",", $data["groups"]) as $group) {  //Check this user's groups for one with an ML assigned
					$gid = ko_groups_decode($group, "group_id");
					if($all_groups[$gid]["ezmlm_list"]) {
						//Un- and resubscribe
						ko_ezmlm_unsubscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $old_email);
						ko_ezmlm_subscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $new_email);
					}
				}
			}
		}


		//Log-Meldung
		if($do_action == "submit_neue_person") {
			ko_log("new_person", $leute_id . ": " . substr($log_message,0,-2));
			$info = 1;
		} else {
			if($log_message != "") {
				$name = $person["vorname"]." ".$person["nachname"];
				if(!$name) $name = $person["firm"];
				ko_log("edit_person", $leute_id . " ($name): " . substr($log_message,0,-2));
				//Save changes for versioning
				ko_save_leute_changes($leute_id, $person, $datafields);
			}
			$info = 2;
		}

		//Set show case
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
	break;



	//Bearbeiten
	case "edit_person":
		$leute_id = format_userinput($_POST["id"], "uint");
		if($group_new || $item_new[$leute_id] || (ko_get_setting("login_edit_person") == 1 && $leute_id == ko_get_logged_in_id())) {} else continue;

		$_SESSION["show_back"] = $_SESSION["show"];
		$_SESSION["show"] = "edit_person";
	break;



	//Save multpile people in family
	case "join_in_family":
		if(!is_array($allowed_cols["edit"]) || in_array("famid", $allowed_cols["edit"])) {
			//add all selected people to family
			$do_ids = array();
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ($edit_id = format_userinput($c_i, "uint", TRUE))) {
						trigger_error("Not allowed join_in_familiy_id: ".$c_i, E_USER_ERROR);
					}
					if($item_view[$edit_id]) $do_ids[] = $edit_id;
				}
			}
			$got_data = FALSE;
			$fam_leute = NULL;
			foreach($do_ids as $id) {
				if(!$id) continue;
				//don't override family-ids
				ko_get_person_by_id($id, $p);
				if($p["famid"] != 0) continue;
				if(!$got_data && $p["nachname"]) {
					$got_data = TRUE;
					//Save fam-data
					$familien_cols = db_get_columns("ko_familie");
					foreach($familien_cols as $col_) {
						$col = $col_["Field"];
						if($col) $fam_data[$col] = $p[$col];
					}
				}//if(!got_data)
				$fam_leute[] = $id;
			}

			//New fam-id and members
			if($got_data) {
				$save_famid = db_insert_data("ko_familie", array("nachname" => ""));
				foreach($fam_leute as $id) {
					db_update_data("ko_leute", "WHERE `id` = '$id'", array("famid" => $save_famid));
				}
				//save in fam and update members
				ko_update_familie($save_famid, $fam_data);

				//update filter
				ko_update_familie_filter();
			}//if(got_data)

		}//if(allowed)

	break;




	case "multiedit":
		/* Leute-Multiedit */
		if($_SESSION["show"] == "show_all" || $_SESSION["show"] == "show_my_list") {
			if( !($group_new || $item_new) ) continue;

			//Zu bearbeitende Spalten
			$columns = explode(",", format_userinput($_POST["id"], "alphanumlist"));
			foreach($columns as $column) {
				$do_columns[] = $column;
			}
			if(sizeof($do_columns) < 1) $error = 4;

			//Zu bearbeitende Eintrge
			$do_ids = array();
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ($edit_id = format_userinput($c_i, "uint", TRUE))) {
						trigger_error("Not allowed multiedit_id: ".$c_i, E_USER_ERROR);
					}
					if($item_new[$edit_id]) $do_ids[] = $edit_id;
				}
			}
			if(sizeof($do_ids) < 1) $error = 5;

			//Daten fr Formular-Aufruf vorbereiten
			if(!$error) {
				if(substr($_SESSION["sort_leute"][0], 0, 6) == "MODULE") {
					$order = "ORDER BY nachname ASC";
				} else {
					$order = "ORDER BY ".$_SESSION["sort_leute"][0]." ".$_SESSION["sort_leute_order"][0];
				}
				$_SESSION["show_back"] = $_SESSION["show"];
				$_SESSION["show"] = "multiedit";
			}


		/* KG-Multiedit */
		} else if($_SESSION["show"] == "list_kg") {
			if(!$kg_new) continue;

			//Zu bearbeitende Spalten
			$columns = explode(",", format_userinput($_POST["id"], "alphanumlist"));
			foreach($columns as $column) {
				$do_columns[] = $column;
			}
			if(sizeof($do_columns) < 1) $error = 4;

			//Zu bearbeitende Eintrge
			$do_ids = array();
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ($edit_id = format_userinput($c_i, "uint", TRUE))) {
						trigger_error("Not allowed multiedit_id: ".$c_i, E_USER_ERROR);
					}
					$do_ids[] = $edit_id;
				}
			}
			if(sizeof($do_ids) < 1) $error = 5;

			//Daten fr Formular-Aufruf vorbereiten
			$order = 'ORDER BY name ASC';  //Default
			if(!$error) {
				if(is_string($_SESSION['sort_kg'])) $order = "ORDER BY ".$_SESSION["sort_kg"]." ".$_SESSION["sort_kg_order"];
				$_SESSION["show_back"] = $_SESSION["show"];
				$_SESSION["show"] = "multiedit_kg";
			}
		}

		$onload_code = "form_set_first_input();".$onload_code;
	break;



	case "submit_multiedit":
		if($_SESSION["show"] == "multiedit") {
			kota_submit_multiedit($error, $item_new, "", FALSE, "lastchange");
		} else if($_SESSION["show"] == "multiedit_kg") {
			if(!$kg_new) continue;
			kota_submit_multiedit($error);
		}
		if(!$error) $info = 11;
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
	break;




	//Lschen
	case "delete_person":
		$del_id = format_userinput($_POST["id"], "uint", TRUE);
		if(!$del_id) continue;
		if( !($group_edit || $item_edit[$del_id]) ) continue;

		ko_get_person_by_id($del_id, $del_person);
		if($del_person["deleted"] == 1) {  //really delete already deleted entry
			db_delete_data("ko_leute", "WHERE `id` = '$del_id'");

			//delete group datafields
			db_delete_data("ko_groups_datafields_data", "WHERE `person_id` = '$del_id'");
		}
		else {  //mark as deleted
			db_update_data("ko_leute", "WHERE `id` = '$del_id'", array("deleted" => "1", "famid" => "0"));

			//unset assigned login
			$login = db_select_data("ko_admin", "WHERE `leute_id` = '$del_id'", "id,leute_id", "", "", TRUE);
			if(is_array($login) && $login["leute_id"] == $del_id) {
				db_update_data("ko_admin", "WHERE `id` = '".$login["id"]."'", array("leute_id" => "0"));
			}

			//unsubscribe from ezml
			if(defined("EXPORT2EZMLM") && EXPORT2EZMLM) {
				foreach(explode(",", $del_person["groups"]) as $grp) {
					$gid = ko_groups_decode($grp, "group_id");
					if($all_groups[$gid]["ezmlm_list"]) ko_ezmlm_unsubscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $del_person["email"]);
				}
			}

			//set group datafields to deleted
			db_update_data("ko_groups_datafields_data", "WHERE `person_id` = '$del_id'", array("deleted" => "1"));

			//add version entry
			ko_save_leute_changes($del_id, $del_person);
		}//if(deleted == 0)


		//LDAP
		if(ko_do_ldap()) {
			$ldap = ko_ldap_connect();
			ko_ldap_del_person($del_id);
			ko_ldap_close();
		}

		//Familie lschen, falls dies die letzte Person war
		if($del_person["famid"] > 0) {
			$num = ko_get_personen_by_familie($del_person["famid"], $asdf);
			if($num <= 0) ko_del_familie($del_person["famid"]);
		}

		ko_log_diff("delete_person", $del_person);
		$info = 3;
	break;


	case "undelete_person":
		$del_id = format_userinput($_POST["id"], "uint", TRUE);
		if(!$del_id) continue;
		if(!$group_mod) continue;

		ko_get_person_by_id($del_id, $del_person);
		if($del_person["deleted"] == 1) {
			db_update_data("ko_leute", "WHERE `id` = '$del_id'", array("deleted" => "0"));
			ko_save_leute_changes($del_id, $del_person);

			//set group datafields to undeleted
			db_update_data("ko_groups_datafields_data", "WHERE `person_id` = '$del_id'", array("deleted" => "0"));

			//re-subscribe to ezmlm
			if(defined("EXPORT2EZMLM") && EXPORT2EZMLM) {
				foreach(explode(",", $del_person["groups"]) as $grp) {
					$gid = ko_groups_decode($grp, "group_id");
					if($all_groups[$gid]["ezmlm_list"]) ko_ezmlm_subscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $del_person["email"]);
				}
			}

			//add person to LDAP
			if(ko_do_ldap()) {
				$ldap_data = NULL;
				$ldap_data["cn"] = $del_person["vorname"]." ".$del_person["nachname"];
				$ldap_data["uid"] = $del_id;
				foreach($LDAP_ATTRIB as $key => $value) {
					if($ldap_data[$value] != "") {
						$ldap_data[$value] .= ($key == "ort" ? " " : "$").$del_person[$key];
					} else {
						$ldap_data[$value] = $del_person[$key];
					}
				}
				if($ldap_data["sn"] == "") $ldap_data["sn"] = " ";

				$ldap = ko_ldap_connect();
				ko_ldap_add_person($ldap_data);
				ko_ldap_close();
			}//if(ko_do_ldap()
		}//if(del_person[deleted] == 1)
	break;




	//Mutationen
	case "submit_mutation":
		if(!$group_mod) continue;
		if(!$_POST["aa_id"]) continue;

		//Initialisierung
		$do_ldap = ko_do_ldap();
		unset($ldap_entry);
		
		$mod_aa_id = format_userinput($_POST["aa_id"], "uint");

		//Mod- und alte Daten auslesen
		ko_get_mod_leute($mod_p, $mod_aa_id);

		if($mod_p[$mod_aa_id]["_leute_id"] == -1) { //Neu:
			$new_entry = TRUE;
			$old_p = array();
		} else {
			$new_entry = FALSE;
			ko_get_person_by_id($mod_p[$mod_aa_id]["_leute_id"], $old_p);
		}

		$found = FALSE;
		foreach($_POST["chk_".$mod_aa_id] as $field => $field_state) {
			$data[$field] = format_userinput($_POST["txt_".$mod_aa_id][$field], "text");
			$found = TRUE;
			//Familien-Daten:
			if(in_array($field, $COLS_LEUTE_UND_FAMILIE) && $old_p["famid"] != 0) {
				$fam_data[$field] = format_userinput($_POST["txt_".$mod_aa_id][$field], "text");
			}
			//LDAP-Daten
			if($do_ldap) {
				$label = $field;
				if(in_array($label, array_keys($LDAP_ATTRIB))) {  //LDAP-Feld
					$value = format_userinput($_POST["txt_".$mod_aa_id][$field], "text");
					if($ldap_entry[$LDAP_ATTRIB[$label]] != "") {  //Feld schon belegt, dann anhngen
						$ldap_entry[$LDAP_ATTRIB[$label]] .= ($label == "ort" ? " " : "$").$value;
					} else {  //einziger oder erster Eintrag fr dieses LDAP-Feld
						$ldap_entry[$LDAP_ATTRIB[$label]] = $value;
					}
				}
			}//if(do_ldap)
			//ezmlm: change email in mailinglist address if email has changed
			if($field == "email" && !$new_entry && defined("EXPORT2EZMLM") && EXPORT2EZMLM) {
				if($old_p["email"] != $data["email"] && check_email($data[$field])) {  //Check for changed valid email
					foreach(explode(",", $old_p["groups"]) as $group) {  //Check this user's groups for one with an ML assigned
						$gid = ko_groups_decode($group, "group_id");
						if($all_groups[$gid]["ezmlm_list"]) {
							//Un- and resubscribe
							ko_ezmlm_unsubscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $old_p["email"]);
							ko_ezmlm_subscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $data["email"]);
						}
					}
				}
			}
		}//foreach(chk_id as field)
		if(!$found) continue;  //Keine markierte CheckBox gefunden

		//Add lastchange
		$data["lastchange"] = date("Y-m-d H:i:s");

		if($new_entry) { //Neu:
			$data["crdate"] = date("Y-m-d H:i:s");
			$data["cruserid"] = $_SESSION["ses_userid"];
			$q_id = db_insert_data("ko_leute", $data);
		} else {
			//Save changes for versioning
			ko_save_leute_changes($mod_p[$mod_aa_id]["_leute_id"]);
			//Update record with new data
			db_update_data("ko_leute", "WHERE `id`='".$mod_p[$mod_aa_id]["_leute_id"]."'", $data);
		}

		//Familien-Daten aktualisieren
		if($old_p["famid"] != 0) {
			ko_update_familie($old_p["famid"], $fam_data);
			ko_update_familie_filter();
		}


		//In LDAP speichern
		if($do_ldap) {
			//Create cn
			$ldap_entry["cn"] = $ldap_entry["givenName"]." ".$ldap_entry["sn"];
			if($ldap_entry["sn"] == "") $ldap_entry["sn"] = " ";

			$ldap = ko_ldap_connect();
			if($new_entry) {  //Neuer Eintrag
				$ldap_entry["uid"] = $q_id;
				ko_ldap_add_person($ldap_entry);
			} else {  //Edit
				$ldap_entry["uid"] = $mod_p[$mod_aa_id]["_leute_id"];
				ko_ldap_add_person($ldap_entry, TRUE);
			}
			ko_ldap_close();
		}//if(do_ldap)


		//Mod-Eintrag lschen
		db_delete_data("ko_leute_mod", "WHERE `_id`='$mod_aa_id'");

		ko_log_diff("aa_insert", $data, $old_p);
	break;


	case "submit_del_mutation":
		if(!$group_mod) continue;
		if(!$_POST["aa_id"]) continue;

		db_delete_data("ko_leute_mod", "WHERE `_id`='".format_userinput($_POST["aa_id"], "uint")."'");

		//Log-Eintrag
		ko_log("aa_del", format_userinput($_POST["aa_id"], "uint"));
	break;




	//Group subscriptions
	case "submit_gs":  //Use found person from db
	case "submit_gs_aa":  //Use found person from db and add change
	case "submit_gs_new_person":  //New person to be added to db
	case "submit_gs_ps":  //Person from peopleselect
	case "submit_gs_ps_aa":  //Person from peopleselect and add change
		if(!$group_mod && !($item_gs && $g_new)) continue;
		if(!$_POST["_id"]) continue;

		//Initialisierung
		$do_ldap = ko_do_ldap();
		unset($ldap_entry);
		
		$_id = format_userinput($_POST["_id"], "uint");

		//get subscription-data
		ko_get_groupsubscriptions($_p, $_id); $_p = $_p[$_id];
		list($gid, $rid) = explode(":", $_p["_group_id"]);
		$gid = format_userinput($gid, "uint");
		//get full id for this group - including current motherline
		ko_get_groups($all_groups);
		$motherline = ko_groups_get_motherline($gid, $all_groups);
		$a_save_group_id = array();
		foreach($motherline as $m) $a_save_group_id[] = "g".$m;
		$a_save_group_id[] = "g".$gid;
		$save_group_id = implode(":", $a_save_group_id);
		if($rid) $save_group_id = $save_group_id.":".$rid;


		//get person-data
		if($do_action == "submit_gs_new_person") {
			//insert data as new person
			$new_person = $_p;
			//Unset fields not to be stored in ko_leute
			foreach($new_person as $k => $v) {
				if(substr($k, 0, 1) == "_") unset($new_person[$k]);
			}
			$new_person["crdate"] = date("Y-m-d H:i:s");
			$new_person["cruserid"] = $_SESSION["ses_userid"];
			$lid = db_insert_data("ko_leute", $new_person);
			$lids = array($lid);
		} else if($do_action == "submit_gs_ps" || $do_action == "submit_gs_ps_aa") {
			$lids = format_userinput($_POST["ps_".$_id], "intlist");
			if(!$lids) $error = 19;
			else $lids = explode(",", $lids);
		} else {
			$lid = format_userinput($_POST["lid"], "uint");
			if(!$lid) $error = 19;
			else $lids = array($lid);
		}
		if($error) continue;

		foreach($lids as $lid) {
			ko_get_person_by_id($lid, $p);

			//update group-data of person
			$groups = explode(",", $p["groups"]);
			if(!in_array($save_group_id, $groups)) {
				//Save changes for versioning (but not for new person)
				if($do_action != "submit_gs_new_person") {
					ko_save_leute_changes($lid);
				}

				$data = array("groups" => implode(",", array_merge($groups, array($save_group_id))));
				db_update_data("ko_leute", "WHERE `id`='$lid'", $data);

				//Add ezmlm subscription if set for this group
				if(defined("EXPORT2EZMLM") && EXPORT2EZMLM && $all_groups[$gid]["ezmlm_list"] != "") {
					ko_get_person_by_id($lid, $np);
					ko_ezmlm_subscribe($all_groups[$gid]["ezmlm_list"], $all_groups[$gid]["ezmlm_moderator"], $np["email"]);
				}
			}

			//insert group datafields data
			foreach(explode(",", $all_groups[$gid]["datafields"]) as $fid) {
				$value = $_POST["group_datafields"][$_id][$gid][$fid];
				db_delete_data("ko_groups_datafields_data", "WHERE `datafield_id` = '$fid' AND `person_id` = '$lid' AND `group_id` = '$gid'");
				db_insert_data("ko_groups_datafields_data", array("group_id" => $gid, "person_id" => $lid, "datafield_id" => $fid, "value" => $value));
			}

			//Handle address changes
			if($do_action == "submit_gs_aa" || $do_action == "submit_gs_ps_aa") {
				$aa = $_p;
				unset($aa["_id"]); unset($aa["_group_id"]); unset($aa["_group_datafields"]);
				$aa["_leute_id"] = $lid;
				db_insert_data("ko_leute_mod", $aa);
			}
		}//foreach(lids as lid)

		//Delete group subscription
		db_delete_data("ko_leute_mod", "WHERE `_id`='$_id'");

		if($do_action == "submit_gs_aa" || $do_action == "submit_gs_ps_aa") {
			//Display list of changes with back link to group subscriptions
			$_SESSION["show_back"] = "groupsubscriptions";
			$_SESSION["show"] = "mutationsliste";
		} else if($do_action == "submit_gs_new_person") {
			//Add LDAP entry
			if($do_ldap) {
				foreach($LDAP_ATTRIB as $key => $ldap) {
					if($ldap_entry[$ldap] != "") {
						$ldap_entry[$ldap] .= ($key == "ort" ? " " : "$").$new_person[$key];
					} else {
						$ldap_entry[$ldap] = $new_person[$key];
					}
				}
				//Add cn
				$ldap_entry["cn"] = $ldap_entry["givenName"]." ".$ldap_entry["sn"];
				if($ldap_entry["sn"] == "") $ldap_entry["sn"] = " ";
				$ldap_entry["uid"] = $lid;
				//Store in LDAP
				$ldap = ko_ldap_connect();
				ko_ldap_add_person($ldap_entry);
				ko_ldap_close();
			}
			//Display edit form for the new person
			$_POST["id"] = $lid;
			$_SESSION["show"] = "edit_person";
		}

		ko_log("groupsubscription", $p["vorname"]." " .$p["nachname"].": ".$all_groups[$gid]["name"]);
	break;



	case "submit_gs_delete":
		if(!$group_mod) continue;
		if(!$_POST["_id"]) continue;

		$_id = format_userinput($_POST["_id"], "uint");
		ko_get_groupsubscriptions($_p, $_id); $_p = $_p[$_id];
		//Mod-Eintrag lschen
		db_delete_data("ko_leute_mod", "WHERE `_id`='$_id'");

		ko_log("del_groupsubscription", $_p["vorname"]." " .$_p["nachname"].": ".$_p["_group_id"]);
	break;




	//Aktionen
	case "leute_action":
		set_time_limit(0);
		$fam = array();
		$person = array();

    $leute_col_name = ko_get_leute_col_name();

		//Spalten:
		switch($_POST["sel_cols"]) {
			case "alle":
				$xls_cols = array();
				foreach($leute_col_name as $c_i => $c) {
					$xls_cols[] = $c_i;
				}
			break;

			case "angezeigte":
				if($_SESSION["show"] == "show_adressliste")
					$xls_cols = $_SESSION["show_adressliste_cols"];
				else 
					$xls_cols = $_SESSION["show_leute_cols"];
			break;

			case "children":
				if($_SESSION["show"] == "show_adressliste")
					$xls_cols = $_SESSION["show_adressliste_cols"];
				else 
					$xls_cols = $_SESSION["show_leute_cols"];

				if(is_array($LEUTE_EXPORT_CHILDREN_COLUMNS)) {
					foreach($LEUTE_EXPORT_CHILDREN_COLUMNS as $col) {
						$ll = getLL("leute_children_col".$col);
						if(!$ll) {
							if(in_array(substr($col, 0, 8), array("_father_", "_mother_"))) {
								$ll = getLL("kota_ko_leute_".substr($col, 8))." ".getLL("leute_children_col".substr($col, 0, 7));
							} else {
								$ll = getLL("kota_ko_leute".$col);
							}
						}
						$leute_col_name_add[$col] = $ll ? $ll : substr($col, 1);
						$xls_cols[] = $col;
					}
				}
				$leute_col_name = array_merge($leute_col_name, (array)$leute_col_name_add);
			break;  //children

			default:
				if(substr($_POST["sel_cols"], 0, 4) == "set_") {
					$setname = substr($_POST["sel_cols"], 4);
					if(substr($setname, 0, 3) == '@G@') $set = ko_get_userpref('-1', substr($setname, 3), "leute_itemset");
					else $set = ko_get_userpref($_SESSION["ses_userid"], $setname, "leute_itemset");
					$xls_cols = explode(",", $set[0]["value"]);
				}
		}//switch(sel_cols)

		if($xls_cols == "") $error = 6;

		//Birthday list
		if($_SESSION['show'] == 'geburtstagsliste') {
			if(!in_array('geburtsdatum', $xls_cols)) $xls_cols[] = 'geburtsdatum';
			if(!in_array('alter', $xls_cols)) $xls_cols[] = 'alter';
			if(!in_array('deadline', $xls_cols)) $xls_cols[] = 'deadline';
			$leute_col_name['deadline'] = getLL('leute_birthday_list_header_deadline');
			$leute_col_name['alter'] = getLL('leute_birthday_list_header_age');
			$leute_col_name_add['deadline'] = getLL('leute_birthday_list_header_deadline');
			$leute_col_name_add['alter'] = getLL('leute_birthday_list_header_age');
		}


		//Zeilen:
		$pidlist = $famlist = array();
		if(substr($_POST["sel_auswahl"], 0, 4) == "alle" && $_SESSION["show"] == "show_all") {
			$mode = substr($_POST["sel_auswahl"], 4);

			apply_leute_filter($_SESSION["filter"], $z_where, !$group_view);
			ko_get_leute($es, $z_where);
			if(TRUE === ko_manual_sorting($_SESSION["sort_leute"])) {
				$es = ko_leute_sort($es, $_SESSION["sort_leute"], $_SESSION["sort_leute_order"], TRUE);
			}
		}
		//Birthday list
		else if(($_POST['sel_auswahl'] == 'markierte' || substr($_POST['sel_auswahl'], 0, 4) == 'alle') && $_SESSION['show'] == 'geburtstagsliste') {
			$mode = 'p';
			$deadline_plus = ko_get_setting('geburtstagsliste_deadline_plus');
			$deadline_minus = ko_get_setting('geburtstagsliste_deadline_minus');

			$cols = '*, ( YEAR( CURDATE() ) - YEAR(`geburtsdatum` ) ) AS `alter`, TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) AS deadline';
			$where = " AND deleted = '0' ".ko_get_leute_hidden_sql()." AND TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) <= $deadline_plus AND TO_DAYS(geburtsdatum + INTERVAL (YEAR( CURDATE() ) - YEAR(geburtsdatum)) YEAR) - TO_DAYS(CURDATE()) >= -$deadline_minus ".ko_get_birthday_filter();
			if($_POST['sel_auswahl'] == 'markierte' && isset($_POST['chk'])) {
				$pids = array();
				foreach($_POST['chk'] as $c_i => $c) {
					if($c) $pids[] = format_userinput($c_i, 'uint');
				}
				$where .= ' AND `id` IN (\''.implode("','", $pids)."') ";
			}

			$es = db_select_data('ko_leute', 'WHERE 1=1 '.$where, $cols, 'ORDER BY `deadline` ASC');
		}
		//Use mylist
		else if(substr($_POST["sel_auswahl"], 0, 4) == "alle") {
			$mode = substr($_POST["sel_auswahl"], 4);
			$pidlist = $_SESSION["my_list"];
		}
		else if($_POST["sel_auswahl"] == "markierte") {
			$mode = "f";
			$clear_famid_for_pidlist = TRUE;
			if(isset($_POST["chk"])) {
				foreach($_POST["chk"] as $c_i => $c) {
					if($c) $pidlist[] = format_userinput($c_i, "uint");
				}
			}

			if(isset($_POST["famchk"])) {
				foreach($_POST["famchk"] as $c_i => $c) {
					if($c) $famlist[] = format_userinput($c_i, "uint");
				}
				array_unique($famlist);
			}
		}//markierte
		else if($_POST["sel_auswahl"] == "markiertef") {
			$mode = "f";
			if(isset($_POST["chk"])) {
				foreach($_POST["chk"] as $c_i => $c) {
					if($c) $pidlist[] = format_userinput($c_i, "uint");
				}
			}
		}//markiertef
		else if($_POST["sel_auswahl"] == "markierteFam2") {
			$mode = "Fam2";
			if(isset($_POST["chk"])) {
				foreach($_POST["chk"] as $c_i => $c) {
					if($c) $pidlist[] = format_userinput($c_i, "uint");
				}
			}
		}//markierteFam2


		//Clear famid if selected persons should get exported as persons
		if($clear_famid_for_pidlist) $clear_pidlist = $pidlist;
		//get family member for all selected families
		if(sizeof($famlist) > 0) {
			foreach($famlist as $famid) {
				$members = db_select_data('ko_leute', ("WHERE `famid` = '$famid' AND `famfunction` IN ('husband', 'wife') AND `deleted` = '0'".ko_get_leute_hidden_sql()), 'id');
				foreach($members as $member) {
					if($member['id']) $pidlist[] = $member['id'];
				}
			}
		}
		if(sizeof($pidlist) > 0) {
			//Get people as defined in pidlist
			foreach($pidlist as $pid) {
				if(!$pid) continue;
				$in .= "'".$pid."',";
			}
			$in = substr($in, 0, -1);
			$z_where = "AND `id` IN ($in) AND `deleted` = '0'".ko_get_leute_hidden_sql();
			ko_get_leute($es, $z_where);
			if(TRUE === ko_manual_sorting($_SESSION["sort_leute"])) {
				$es = ko_leute_sort($es, $_SESSION["sort_leute"], $_SESSION["sort_leute_order"], TRUE);
			}
		}

		//Clear famid if selected persons should get exported as persons
		if($clear_famid_for_pidlist) {
			foreach($clear_pidlist as $pid) {
				$es[$pid]["_famid"] = $es[$pid]["famid"];
				$es[$pid]["famid"] = "";
			}
		}


		if(sizeof($es) == 0) $error = 5;
		if($error) continue;
	

		ko_get_familien($families);
		$all_datafields = db_select_data("ko_groups_datafields", "WHERE 1=1", "*");

		//Preprocess data if alleFam2
		//Unset famid for people where only one member of their family has been found
		//And unset all members of a family except for husband or wife or the first child
		$fam = array();
		if($mode == "Fam2") {
			foreach($es as $pid => $p) {
				if(!$p["famid"]) continue;
				$fam[$p["famid"]][] = $pid;  //Save all pids for each family
			}
			//Find
			foreach($fam as $famid => $pids) {
				//Find families with only one member in filtered people
				if(sizeof($pids) == 1) {
					foreach($pids as $pid) $es[$pid]["famid"] = "";  //And unset this famid, so it will be exported as person
				}
				//Export as family if more than one member has been found
				else if(sizeof($pids) > 1) {
					$famroles = array(); $keep = "";
					foreach($pids as $pid) {
						$famroles[] = $es[$pid]["famfunction"];
					}
					if(in_array("husband", $famroles)) $keep = "husband";
					else if(in_array("wife", $famroles)) $keep = "wife";
					else $keep = "";
					$done = FALSE;
					foreach($pids as $pid) {
						if( ($keep == "" && $done)
								|| ($keep != "" && $es[$pid]["famfunction"] != $keep)
							) {
							unset($es[$pid]);
							$done = TRUE;
						}
					}
				}
			}//foreach(fam as famid => pids)
		}//if(alleFam2)

		$row = 0;
		$data = array();
		foreach($es as $pid => $p) {
			if(!$pid || !$item_view[$pid]) continue;

			//Check for single person or family to be exported
			if( ($mode == "f" && $p["famid"])
					||
					($mode == "Def" && $p["famid"]
					 && ($families[$p["famid"]]["famgembrief"] == "ja" || !isset($families[$p["famid"]]["famgembrief"]))
					)
					||
					($mode == "Fam2" && $p["famid"])
				) {

				if($done_fam[$p["famid"]]) {
					unset($es[$pid]);
					continue;
				}

				if(in_array("anrede", $xls_cols)) {
					$p["anrede"] = $families[$p["famid"]]["famanrede"] ? $families[$p["famid"]]["famanrede"] : getLL("ko_leute_anrede_family");
				}//anrede
				if(in_array("vorname", $xls_cols)) {
					//If no special family values are given, set first name to empty ("Fam", "", "Lastname")
					if(!$families[$p["famid"]]["famanrede"] && !$families[$p["famid"]]["famfirstname"] && !$families[$p["famid"]]["famlastname"] && !FORCE_FAM_FIRSTNAME) {
						$p["vorname"] = "";
					} else {
						if($families[$p["famid"]]["famfirstname"]) {
							$p["vorname"] = $families[$p["famid"]]["famfirstname"];
						} else {
							//use first names of parents for firstname-col
							$parents = db_select_data("ko_leute", "WHERE `famid` = '".$p["famid"]."' AND `famfunction` IN ('husband', 'wife')", "famfunction,vorname", "ORDER BY famfunction ASC");
							$parent_values = array();
							foreach($parents as $parent) $parent_values[] = $parent["vorname"];
							$p["vorname"] = implode((" ".getLL("family_link")." "), $parent_values);
						}
					}
				}//vorname
				if(in_array("nachname", $xls_cols)) {
					$p["nachname"] = $families[$p["famid"]]["famlastname"] ? $families[$p["famid"]]["famlastname"] : $families[$p["famid"]]["nachname"];
				}//nachname
				if(in_array('email', $xls_cols)) {
					if($families[$p['famid']]['famemail']) {  //Get family email address if set
						$parent = db_select_data('ko_leute', ("WHERE `famid` = '".$p['famid']."' AND `famfunction` = '".$families[$p['famid']]['famemail']."' AND `deleted` = '0'".ko_get_leute_hidden_sql()), 'id,email', '', 'LIMIT 0,1', TRUE);
						if($parent['email']) $p['email'] = $parent['email'];
					} else if($p['famfunction'] == 'child') {  //if no family email is set but the person is a child, use the email address of one of the parents
						$parents = db_select_data('ko_leute', ("WHERE `famid` = '".$p['famid']."' AND `famfunction` IN ('husband', 'wife') AND `deleted` = '0'".ko_get_leute_hidden_sql()), 'id,famfunction,email', 'ORDER BY famfunction ASC');
						$done_parent = FALSE;
						foreach($parents as $parent) {
							if($parent['email'] && !$done_parent) {
								$p['email'] = $parent['email'];
								$done_parent = TRUE;
							}
						}
					}
				}//email

				$done_fam[$p["famid"]] = TRUE;
			}
			$es[$pid] = $p;

			
			//Restore famid if selected persons should get exported as persons (needed in map_leute_daten())
			if($clear_famid_for_pidlist) {
				$p["famid"] = $p["_famid"];
				unset($p["_famid"]);
			}

			$col = 0;
			foreach($xls_cols as $c) {
				if(!$leute_col_name[$c]) continue;
				$value = map_leute_daten($p[$c], $c, $p, $all_datafields);
				if(is_array($value)) {  //group with datafields, so more than one column has to be added
					foreach($value as $v) $data[$row][$col++] = strip_tags($v);
				} else {
					$data[$row][$col++] = strip_tags($value);
				}
			}//foreach(xls_cols as col)
			$row++;
		}//foreach(es as pid => p)

		if(sizeof($data) == 0) $error = 5;


		if(!$error) {
			switch($_POST["id"]) {
				case "excel":
					$show_group_datafields = ko_get_userpref($_SESSION["ses_userid"], "show_group_datafields");
					$leute_col_name = ko_get_leute_col_name(FALSE, $show_group_datafields);
					$leute_col_name = array_merge($leute_col_name, (array)$leute_col_name_add);
					$header = array();
					foreach($xls_cols as $c) {
						if(!$leute_col_name[$c]) continue;
						$header[] = $leute_col_name[$c];
						//add group-datafields if needed
						if($show_group_datafields && substr($c, 0, 6) == "MODULE" && $all_groups[substr($c, 9)]["datafields"]) {
							foreach(explode(",", $all_groups[substr($c, 9)]["datafields"]) as $fid) {
								if(!isset($all_datafields[$fid])) continue;
								$header[] = $leute_col_name[$c.":".$fid];
							}
						}
					}//foreach(cols as c)

					$filename = $ko_path."download/excel/".getLL("export_filename").strftime("%d%m%Y_%H%M%S", time()).".xls";
					ko_export_to_excel($header, $data, $filename, "kOOL");

					//Fileshare-Datei speichern, falls gewnscht
					if(ko_module_installed("fileshare", $_SESSION["ses_userid"]) && ko_get_userpref($_SESSION["ses_userid"], "save_files_as_share") == 1) {
						ko_fileshare_save_file_as_share($_SESSION["ses_userid"], $filename);
					}

					$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=".substr($filename, 3)."', 400, 300);";
				break;


				case "sms":
					$smarty->assign("sms_balance", ko_html(get_cache_sms_balance()));

					$smarty->assign("ko_path", $ko_path);

					//Leute-cols fr Excel-Datei auslesen
					$cols = array("anrede", "vorname", "nachname", "adresse", "adresse_zusatz", "plz", "ort", "telp", "telg", "natel");
		      $header = array();
		      foreach($cols as $c) {
		        $header[] = $leute_col_name[$c];
		      }

					//Empfnger auslesen
					$rec_invalid = $rec_invalid_ids = $recipients_names = "";
					$row = 0;
					$xls_data = $array_empfaenger = array();
					foreach($es as $l_id => $l) {
						if(check_natel($l["natel"])) {
							$array_empfaenger[] = $l["natel"];
							$recipients_names .= $l["vorname"]." ".$l["nachname"].", ";
						} else {
							$rec_invalid .= $l["vorname"]." ".$l["nachname"].($l["ort"] ? (" ".getLL('from')." ".$l["ort"]) : "").", ";
							$rec_invalid_ids .= $l["id"].",";

							$col = 0;
							foreach($cols as $c) {
			          $xls_data[$row][$col++] = sql2datum($l[$c]);
			        }
			        $row++;
						}

					}//foreach(leute as l_id)
					$smarty->assign("tpl_show_recipients", 1);
					$smarty->assign("tpl_show_sendbutton", 1);
					$smarty->assign("tpl_show_header", 1);
					$smarty->assign("tpl_recipients_names", ko_html(substr($recipients_names, 0, -2)));

					//XLS-Datei aller Leute ohne GSM-Nummer erstellen
					if($rec_invalid != "") {
						$rec_invalid = substr($rec_invalid, 0, -2);
						$rec_invalid_ids = substr($rec_invalid_ids, 0, -1);
						$smarty->assign("tpl_recipients_invalid", ko_html($rec_invalid));
						$smarty->assign("tpl_recipients_invalid_ids", $rec_invalid_ids);

						$filename = $ko_path."download/excel/".getLL("export_filename").strftime("%d%m%Y_%H%M%S", time()).".xls";
						ko_export_to_excel($header, $xls_data, $filename, "kOOL");
						$smarty->assign("xls_filename", $filename);
					}

					//Empfnger zuweisen
					$array_empfaenger = array_unique($array_empfaenger);
					foreach($array_empfaenger as $e) {
						$tpl_recipients .= $e . ",";
					}
					$tpl_recipients = substr($tpl_recipients, 0, -1);
					$smarty->assign("tpl_recipients", ko_html($tpl_recipients));

					$_SESSION["show_back"] = $_SESSION["show"];
					$_SESSION["show"] = "sms_versand";
				break;


				case "etiketten":
					//Vorlage-Namen auslesen (fr Dropdown-Listen)
				  //$vorlagen["values"][] = "";
				  //$vorlagen["output"][] = "";
				  ko_get_etiketten_vorlagen($vorlagen_);
				  foreach($vorlagen_ as $v) {
				    $vorlagen["values"][] = $v["vorlage"];
				    $vorlagen["output"][] = $v["value"];
				  }//foreach(vorlagen as v)
					$smarty->assign("vorlagen", $vorlagen);

					//Store data in session to be used on submission of label export settings
					$_SESSION["etiketten_data"] = $es;
					$_SESSION["etiketten_cols"] = $xls_cols;

					$col = array();
					$col_counter = 0;
					foreach($xls_cols as $c_i => $c) {
						if(!$leute_col_name[$c]) {
							unset($_SESSION["etiketten_cols"][$c_i]);
							continue;
						}
						$col[$col_counter]["name"] = ko_html($leute_col_name[$c]);
						if($col_counter < (sizeof($xls_cols)-1)) $col[$col_counter]["show_select"] = true;
						else $col[$col_counter]["show_select"] = false;
						$col[$col_counter++]["id"] = $c;
					}
					$smarty->assign("tpl_cols", $col);

					//LL-Values
					$smarty->assign("label_title", getLL("leute_labels_title"));
					$smarty->assign("label_preset", getLL("leute_labels_preset"));
					$smarty->assign("label_start", getLL("leute_labels_start"));
					$smarty->assign("label_border", getLL("leute_labels_border"));
					$smarty->assign("label_yes", getLL("yes"));
					$smarty->assign("label_no", getLL("no"));
					$smarty->assign("label_fill_page", getLL("leute_labels_fill_page"));
					$smarty->assign("label_limiter", getLL("leute_labels_limiter"));
					$smarty->assign("label_limiter_newline", getLL("leute_labels_limiter_newline"));
					$smarty->assign("label_limiter_doublenewline", getLL("leute_labels_limiter_doublenewline"));
					$smarty->assign("label_limiter_space", getLL("leute_labels_limiter_space"));
					$smarty->assign("label_limiter_nothing", getLL("leute_labels_limiter_nothing"));
					$smarty->assign("label_submit", getLL("leute_labels_submit"));


					$_SESSION["show_back"] = $_SESSION["show"];
					$_SESSION["show"] = "etiketten_optionen";
				break;


				case 'mailmerge':
					//Get layouts
					$layouts = ko_latex_get_layouts('letter');
					$smarty->assign('layouts', $layouts);

					//Show previously uploaded signature file
					foreach($mailmerge_signature_ext as $ext) {
						if(file_exists($ko_path.'latex/images/signature_'.$_SESSION['ses_userid'].'.'.$ext)) {
							$smarty->assign('show_sig_file', $ko_path.'latex/images/signature_'.$_SESSION['ses_userid'].'.'.$ext);
						}
					}

					//Check for complete addresses
					$mandatory_fields = array('adresse', 'plz', 'ort');
					$invalid_addresses = $invalid_addresses_ids = array();
					foreach($es as $id => $p) {
						foreach($mandatory_fields as $field) {
							if(trim($p[$field]) == '' && !in_array($p['id'], $invalid_addresses_ids)) {
								$invalid_addresses[] = (($p['vorname'] || $p['nachname']) ? ($p['vorname'].' '.$p['nachname']) : $p['firm']).($p['ort'] ? ' '.getLL('from').' '.$p['ort'] : '');
								$invalid_addresses_ids[] = $p['id'];
								// Don't remove them from export list (e.g. useful if letters are distributed by hand)
								//unset($es[$id]);
							}
						}
					}
					if(sizeof($invalid_addresses) > 0) {
						$smarty->assign('show_invalid', TRUE);
						$smarty->assign('invalid_addresses', implode(', ', $invalid_addresses));
						$smarty->assign('invalid_addresses_ids', implode('@', $invalid_addresses_ids));
					}

					//Prepare legend for all selected columns and their markers
					$show_group_datafields = ko_get_userpref($_SESSION['ses_userid'], 'show_group_datafields');
					$leute_col_name = ko_get_leute_col_name(FALSE, $show_group_datafields);
					$leute_col_name = array_merge($leute_col_name, (array)$leute_col_name_add);
					foreach($xls_cols as $c) {
						if(!$leute_col_name[$c]) continue;
						$header[] = $leute_col_name[$c];
						//add group-datafields if needed
						if($show_group_datafields && substr($c, 0, 6) == 'MODULE' && $all_groups[substr($c, 9)]['datafields']) {
							foreach(explode(',', $all_groups[substr($c, 9)]['datafields']) as $fid) {
								if(!isset($all_datafields[$fid])) continue;
								$header[] = $leute_col_name[$c.':'.$fid];
							}
						}
					}//foreach(cols as c)
					$colLegend = array();
					for($i=0; $i<sizeof($header); $i++) {
						$colLegend[$i] = $header[$i];
					}
					$smarty->assign('colLegend', $colLegend);

					//Get letters
					$rows = db_select_data('ko_mailmerge', 'WHERE `user_id` = \''.$_SESSION['ses_userid'].'\'', '*', 'ORDER BY `crdate` DESC');
					if(sizeof($rows) > 0) {
						$smarty->assign('show_reuse', TRUE);
						$letters = $letters_ids = array();
						$letters[] = ''; $letters_ids[] = '';
						foreach($rows as $letter) {
							$letters_ids[] = $letter['id'];
							$letters[] = strftime($DATETIME['dmy'], strtotime($letter['crdate'])).' '.ko_html(substr($letter['subject'], 0, 40)).' ('.$letter['num_recipients'].')';
						}
						$smarty->assign('letters', $letters);
						$smarty->assign('letters_ids', $letters_ids);
					} else {
						$smarty->assign('show_reuse', FALSE);
					}

					//Check for valid sender address of logged in user
					$p = ko_get_logged_in_person();
					if($p['id'] && $p['adresse'] && $p['plz'] && $p['ort']) {
						$smarty->assign('show_sender', TRUE);
						$address_user = $p['vorname'].' '.$p['nachname'].', '.$p['adresse'].', '.$p['plz'].' '.$p['ort'];
						$smarty->assign('sender_address_user', $address_user);
						$address_church = ko_get_setting('info_name').', '.ko_get_setting('info_address').', '.ko_get_setting('info_zip').' '.ko_get_setting('info_city');
						$smarty->assign('sender_address_church', $address_church);
					} else {
						$smarty->assign('show_sender', FALSE);
					}
					$smarty->assign('signature', $p['vorname'].' '.$p['nachname']);

					//Store data in session to be used on submission of label export settings
					$_SESSION['mailmerge_data'] = $es;
					$_SESSION['mailmerge_cols'] = $xls_cols;
					$_SESSION['mailmerge_famids'] = $done_fam;

					$_SESSION["show_back"] = $_SESSION["show"];
					$_SESSION["show"] = "mailmerge";
				break;


				case "email":
					//Titeldaten fr XLS-Datei
					$cols = array("anrede", "vorname", "nachname", "adresse", "adresse_zusatz", "plz", "ort", "telp", "telg");
		      $header = array();
		      foreach($cols as $c) {
		        $header[] = $leute_col_name[$c];
		      }

					$txt_empfaenger = "";
					$xls_data = $array_empfaenger = array();
					$ohne_email = "";
					$row = 0;
					foreach($es as $l => $p) {  //Loop ber alle Leute
						if(ko_get_leute_email($p, $email)) {
							$array_empfaenger[] = $email;
						} else {
							$ohne_email .= $p["vorname"]." ".$p["nachname"].($p["ort"] ? (" ".getLL('from')." ".$p["ort"]) : "").", ";

							$col = 0;
							foreach($cols as $c) {
			          $xls_data[$row][$col++] = sql2datum($p[$c]);
			        }
			        $row++;
						}
					}//foreach(es)

					$array_empfaenger = array_unique($array_empfaenger);
					$txt_empfaenger = implode(",", $array_empfaenger);

					$ohne_email = substr($ohne_email, 0, -2);
					//XLS-Datei aller Leute ohne Email erstellen
					if($ohne_email != "") {
						$dateiname = $ko_path."download/excel/".getLL("export_filename").strftime("%d%m%Y_%H%M%S", time()).".xls";
						ko_export_to_excel($header, $xls_data, $dateiname, "kOOL");
						$smarty->assign("xls_filename", $dateiname);
					}

					$smarty->assign("tpl_show_header", TRUE);
					$smarty->assign("tpl_show_rec_link", TRUE);

					$smarty->assign("txt_empfaenger", ko_html($txt_empfaenger));
					$smarty->assign("tpl_ohne_email", ($ohne_email == "" ? getLL('form_leute_none') : $ohne_email));
					$p = ko_get_logged_in_person();
					$smarty->assign("tpl_show_bcc_an_mich", ($p["email"] ? TRUE : FALSE));
					$smarty->assign("tpl_show_send", TRUE);
					$smarty->assign("tpl_show_to_bcc", TRUE);
					$smarty->assign("tpl_info_email", ko_get_setting("info_email"));

					$_SESSION["show_back"] = $_SESSION["show"];
					$_SESSION["show"] = "email_versand";
				break;
			}
		}//if(!error)

	break; //leute_action



	case "leute_chart":
		$_SESSION["show"] = "chart";
	break;



	case "export_pdf":
		$layout_id = format_userinput($_GET["layout_id"], "uint");
		if(!$layout_id) continue;

		$_SESSION["show_back"] = $_SESSION["show"];
		$_SESSION["show"] = "export_pdf";
	break;



	case "do_export_pdf":
		$layout_id = format_userinput($_POST["layout_id"], "uint");
		if(!$layout_id) continue;

		$filename = ko_export_leute_as_pdf($layout_id);
		
		$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=".substr($filename, 3)."', 400, 300);";
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
	break;





	case "submit_sms":
		//Empfaenger
		$empfaenger_ = explode(",", format_userinput($_POST["txt_recipients"], "intlist"));
		$empfaenger__ = explode(",", format_userinput($_POST["txt_recipients_add"], "intlist"));
		$empfaenger = array_unique(array_merge($empfaenger_, $empfaenger__));

		//Text
		$text = $_POST["txt_smstext"];

		//Absender
		if(!ko_get_logged_in_id()) {  //If no person is assigned just use the login name
			$from = $_SESSION["ses_username"];
		} else {  //Else use the mobile number or the name if no mobile is given
			$p = ko_get_logged_in_person();
			if($p["natel"]) {
				$from = $p["natel"];
				check_natel($from);
			} else {
				$from = $p["vorname"].$p["nachname"];
			}
		}

		//Client-Message-ID
		$climsgid = time()."_".$p["id"];

		//Message-Type
		$msg_type = "SMS_TEXT";

		//SMS senden
		$ret = send_sms($empfaenger, $text, $from, $climsgid, $msg_type, $success, $done, $problems, $charges);

		if($ret) {
			$info = 99;
			$info_txt = getLL("info_leute_99a") . "$success/$done" .  getLL("info_leute_99b");
			if($problems) $info_txt .= getLL("info_leute_99c") .substr($problems, 0, -2);
			$info_txt .= getLL("info_leute_99d") . " $charges";
		}//if(sms->auth())
		else {
			$error = 12;
		}
		
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
	break;



	case "export_sms_to_mylist":
	case "exportadd_sms_to_mylist":
		if($_POST["hid_recipients_invalid_ids"]) {
			if($do_action == "export_sms_to_mylist") $_SESSION["my_list"] = array();
			foreach(explode(",", format_userinput($_POST["hid_recipients_invalid_ids"], "intlist")) as $c) {
				if($c) $_SESSION["my_list"][$c] = $c;
			}
			ko_save_userpref($_SESSION["ses_userid"], "leute_my_list", serialize($_SESSION["my_list"]));
		}

		$smarty->assign("sms_balance", format_userinput($_POST["hid_sms_balance"], "float"));
		$smarty->assign("tpl_recipients", format_userinput($_POST["txt_recipients"], "intlist"));
		$smarty->assign("tpl_recipients_add", format_userinput($_POST["txt_recipients_add"], "intlist"));
		$smarty->assign("txt_smstext", ko_html($_POST["txt_smstext"]));
		$smarty->assign("txt_letters", format_userinput($_POST["txt_letters"], "uint"));
		$smarty->assign("tpl_recipients_invalid_ids", format_userinput($_POST["hid_recipients_invalid_ids"], "intlist"));
		$smarty->assign("tpl_recipients_invalid", ko_html($_POST["hid_recipients_invalid"]));
		$smarty->assign("tpl_recipients_names", ko_html($_POST["hid_recipients_names"]));
		$smarty->assign("xls_filename", ko_html($_POST["hid_xls_filename"]));

		$smarty->assign("tpl_show_recipients", 1);
		$smarty->assign("tpl_show_sendbutton", 1);
		$smarty->assign("tpl_show_header", 1);
	break;



	case "submit_etiketten":
		if(!$_POST["sel_vorlage"]) continue;

		$labels_data = array(); $row = 0;

		$data = $_SESSION["etiketten_data"];
		$cols = $_SESSION["etiketten_cols"];

		//Parse data
		$all_datafields = db_select_data("ko_groups_datafields", "WHERE 1=1", "*");
		foreach($data as $p_id => $p) {
			$temp = "";
			foreach($cols as $col) {
				if(substr($col, 0, 6) == "MODULE") {
					$value = map_leute_daten($p[$col], $col, $p, $all_datafields);
					if(is_array($value)) {
            $values = NULL;
            foreach($value as $v) if($v) $values[] = ko_unhtml($v);
            $temp .= implode(", ", $values);
          } else {
            $temp .= ko_unhtml($value);
          }
				} else {
					$value = map_leute_daten($p[$col], $col, $p, $all_datafields);
					$temp .= $value;
				}
				//Add newline or whitespace after value, if value is not empty
				if(trim($value) == "") continue;
				switch($_POST{"sel_col_".$col}) {
					case "Zeilenumbruch":
						$temp .= "\n";
					break;
					case "Doppelter Zeilenumbruch":
						$temp .= "\n\n";
					break;
					case "Leerschlag":
						$temp .= " ";
					break;
					case "Nichts":
						$temp .= "";
					break;
				}//switch(sel_col_)
			}//foreach(cols)
			$labels_data[$row++] = $temp;
		}//foreach(data)

		//Etiketten erstellen
		$filename = ko_export_etiketten($_POST["sel_vorlage"], $_POST["txt_start"], $_POST["rd_rahmen"], $labels_data, ($_POST["chk_fill_page"]?$_POST["txt_fill_page"]:0));

		//Fileshare-Datei speichern, falls gewnscht
		if(ko_module_installed("fileshare", $_SESSION["ses_userid"]) && ko_get_userpref($_SESSION["ses_userid"], "save_files_as_share") == 1) {
			ko_fileshare_save_file_as_share($_SESSION["ses_userid"], "../".$filename);  //Fhrendes "../" vorstellen
		}

		$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=$filename', 400, 300);";
		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
	break;



	case 'submit_mailmerge':
		$preset = $_POST['sel_preset'] ? format_userinput($_POST['sel_preset'], 'dir') : 'default';

		$mmdata = array(); $counter = 0;
		$data = $_SESSION['mailmerge_data'];
		$cols = $_SESSION['mailmerge_cols'];
		$fam_ids = $_SESSION['mailmerge_famids'];

		//Get latex preset
		$latex = file_get_contents($ko_path.'latex/layouts/mailmerge.tex');
		list($pre, $rest) = explode('\begin{letter}', $latex);
		list($letter, $post) = explode('\end{letter}', $rest);
		$letter = '\begin{letter}'.$letter.'\end{letter}';
		$latex = '';

		//Signature file
		$sig_file = '';
		if($_FILES['file_sig_file']['tmp_name']) {
			$upload_name = $_FILES['file_sig_file']['name'];
			$tmp = $_FILES['file_sig_file']['tmp_name'];
			$ext_ = explode('.', $upload_name);
			$ext = strtolower($ext_[sizeof($ext_)-1]);

			if(in_array($ext, $mailmerge_signature_ext)) {
				$path = $BASE_PATH.'latex/images/';
				$filename = 'signature_'.$_SESSION['ses_userid'].'.'.$ext;
				$dest = $path.$filename;

				$ret = move_uploaded_file($tmp, $dest);
				if($ret) {
					$sig_file = '../images/'.$filename;
					chmod($dest, 0644);
				}
			}
		}
		//Get already stored file
		else if($_POST['chk_sig_file']) {
			foreach($mailmerge_signature_ext as $ext) {
				if(is_file($BASE_PATH.'latex/images/signature_'.$_SESSION['ses_userid'].'.'.$ext)) {
					$sig_file = '../images/signature_'.$_SESSION['ses_userid'].'.'.$ext;
				}
			}
		}

		//Parse data
		$sender = ko_get_logged_in_person();
		$all_datafields = db_select_data('ko_groups_datafields', 'WHERE 1=1', '*');
		foreach($data as $p_id => $p) {
			//Used to store values for marks ###COL_X### to be replaced in text and subject below
			$mapCols = array(); $colcounter = 0;
			foreach($cols as $col) {
				if(substr($col, 0, 6) == 'MODULE') {
					$value = map_leute_daten($p[$col], $col, $p, $all_datafields);
					if(is_array($value)) {
            $values = NULL;
            foreach($value as $v) {
							$values[] = ko_unhtml($v);
							$mapCols['###COL_'.($colcounter++).'###'] = ko_unhtml($v);
						}
            $mmdata[$counter][$col] = implode(', ', $values);
          } else {
            $mmdata[$counter][$col] = ko_unhtml($value);
						$mapCols['###COL_'.($colcounter++).'###'] = ko_unhtml($value);
          }
				} else {
					$value = map_leute_daten($p[$col], $col, $p, $all_datafields);
					$mmdata[$counter][$col] = $value;
					$mapCols['###COL_'.($colcounter++).'###'] = $value;
				}
			}//foreach(cols)

			$map = array();

			//Salutation (opening)
			$opening = '';
			if($_POST['rd_salutation'] == 'formal') {
				if($p['famid'] != 0 && in_array($p['famid'], $fam_ids)) {  //Family
					$opening = getLL('leute_mailmerge_opening_formal_fam').' '.$p['anrede'].' '.$p['nachname'];
				} else {  //Single person
					if(!$p['anrede'] && $p['geschlecht']) $p['anrede'] = getLL('leute_salutation_'.$p['geschlecht']);
					$opening = getLL('leute_mailmerge_opening_formal_'.$p['geschlecht']).' '.$p['anrede'].' '.$p['nachname'];
				}
			} else {
				if($p['famid'] != 0 && in_array($p['famid'], $fam_ids)) {  //Family
					$opening = getLL('leute_mailmerge_opening_informal_fam').' '.$p['anrede'].' '.$p['nachname'];
				} else {  //Single person
					$opening = getLL('leute_mailmerge_opening_informal_'.$p['geschlecht']).' '.$p['vorname'];
				}
			}
			//TODO: Add hook to allow the opening to be changed by a plugin
			$map['###OPENING###'] = $opening;

			//Default fields which are alwys set for TeX templates for the recipient's address
			foreach(array('firm', 'anrede', 'vorname', 'nachname', 'adresse', 'adresse_zusatz', 'plz', 'ort', 'land') as $field) {
				if($p[$field]) {
					$map['###'.strtoupper($field).'###'] = $p[$field];
				} else {
					$map['###'.strtoupper($field).'###'] = '';
				}
			}

			//Prepare sender information (from address)
			$from_fields = array('vorname', 'nachname', 'adresse', 'plz', 'ort', 'telp', 'email', 'web');
			if($_POST['rd_sender'] == 'user' && $sender['id']) {
				foreach($from_fields as $field) {
					$map['###FROM_'.strtoupper($field).'###'] = $sender[$field];
				}
			} else {
				//Set global address as sender
				$map['###FROM_VORNAME###'] = ko_get_setting('info_name');
				$map['###FROM_NACHNAME###'] = '';
				$map['###FROM_ADRESSE###'] = ko_get_setting('info_address');
				$map['###FROM_PLZ###'] = ko_get_setting('info_zip');
				$map['###FROM_ORT###'] = ko_get_setting('info_city');
				$map['###FROM_TELP###'] = ko_get_setting('info_phone');
				$map['###FROM_EMAIL###'] = ko_get_setting('info_email');
				$map['###FROM_WEB###'] = ko_get_setting('info_url');
			}

			$map['###LAYOUT###'] = 'letter_'.$_POST['sel_layout'];
			$map['###SUBJECT###'] = ko_latex_escape_chars(strtr($_POST['txt_subject'], $mapCols));
			//Replace markers in text
			$text = strtr($_POST['txt_text'], $mapCols);
			//Escape LaTeX specific chars
			$text = ko_latex_escape_chars($text);
			//Replace formating code
			$mapFormat = array('[B]' => '\textbf{', '[/B]' => '}', '[b]' => '\textbf{', '[/b]' => '}',
												 '[I]' => '\textit{', '[/I]' => '}', '[i]' => '\textit{', '[/i]' => '}',
												 '[C]' => '\begin{center}', '[/C]' => '\end{center}', '[c]' => '\begin{center}', '[/c]' => '\end{center}');
			$text = strtr($text, $mapFormat);
			//Create lists (itemize) and paragraphs (\par)
			$txt = '';
			foreach(explode("\n", $text) as $line) {
				$line = trim($line);
				if($line == '') {
					//Add a \par for new lines and remove the last "\\" (if not within a list)
					if(!$itemize) {
						while(substr($txt, -1) == '\\') $txt = substr($txt, 0, -1);
						$txt .= "\n".'\par'."\n";
					}
				} else {
					if(substr($line, 0, 1) == '-') {  //List
						//item number > 1
						if($itemize) $txt .= '\item '.substr($line, 1)."\n";
						//First item
						else {
							$itemize = TRUE;
							$txt .= '\begin{itemize}'."\n";
							$txt .= '\item '.substr($line, 1)."\n";
						}
					} else if($itemize) {  //no more item but still inside a list, so finish the list
						$itemize = FALSE;
						$txt .= '\end{itemize}'."\n".$line."\n";
					} else {  //regular line. Add linebreak
						$txt .= $line.'\\\\';
					}
				}
			}
			//Remove any newlines at the end of the text
			while(substr($txt, -2) == '\\\\') $txt = substr($txt, 0, -2);

			$text = $txt;

			$map['###TEXT###'] = $text;
			$map['###CLOSING###'] = $_POST['txt_closing'];
			$map['###SIGNATURE###'] = ($sig_file ? '\includegraphics[height=4em]{'.$sig_file.'}\\\\' : '').$_POST['txt_signature'];

			$latex .= strtr($letter, $map)."\n\n";

			$counter++;
		}//foreach(data)

		$latex = strtr($pre, $map).$latex.strtr($post, $map);


		//Store letter in db
		$mmdb = array();
		$mmdb['user_id'] = $_SESSION['ses_userid'];
		$mmdb['crdate'] = strftime('%Y-%m-%d %H:%M:%S', time());
		$mmdb['num_recipients'] = $counter;
		$mmdb['preset'] = $_POST['sel_layout'];
		$mmdb['salutation'] = $_POST['rd_salutation'];
		$mmdb['subject'] = $_POST['txt_subject'];
		$mmdb['text'] = $_POST['txt_text'];
		$mmdb['closing'] = $_POST['txt_closing'];
		$mmdb['signature'] = $_POST['txt_signature'];
		$mmdb['sig_file'] = $_POST['chk_sig_file'] ? 1 : 0;
		db_insert_data('ko_mailmerge', $mmdb);


		//Set new show
		$_SESSION['show'] = $_SESSION['show_back'] ? $_SESSION['show_back'] : 'show_all';

		//Write Latex and create PDF
		$file = md5(uniqid(mt_rand(), true));
		if(!$fh = fopen($BASE_PATH.'latex/compile/'.$file.'.tex', 'w')) {
			$error = 20;
			break;
		}
		if(!fwrite($fh, $latex)) {
			$error = 20;
			break;
		}
		system('cd '.$BASE_PATH.'latex/compile/ && pdflatex -interaction nonstopmode '.$file.'.tex 2&>/dev/null', $ret);
		foreach(array('.aux', '.log', '.tex') as $type) {
			$f = $BASE_PATH.'latex/compile/'.$file.$type;
			if(is_file($f)) unlink($f);
		}
		if(is_file($ko_path.'latex/compile/'.$file.'.pdf')) {
			$filename = $ko_path.'download/pdf/'.getLL('leute_mailmerge_filename').strftime('%d%m%Y_%H%M%S', time()).'.pdf';
			copy($ko_path.'latex/compile/'.$file.'.pdf', $filename);
			unlink($ko_path.'latex/compile/'.$file.'.pdf');
			$onload_code = "popup('".$ko_path."download.php?action=file&amp;file=".substr($filename, 3)."', 400, 300);";
		} else {
			$error = 21;
			break;
		}
	break;



	case "submit_email":
		$m = ko_get_logged_in_person();
		if($m["email"] == "") $email = ko_get_setting("info_email");
		else $email = $m["email"];

		if($_POST["rd_bcc_an_mich"] == "ja") $_POST["txt_bcc"] .= ($_POST["txt_bcc"] == "") ? $email : ", $email";

		$headers = array("From" => $email);
		if($_POST["txt_cc"] != "") $headers["CC"] = nl2br(str_replace(";", ",", $_POST["txt_cc"]));
		if($_POST["txt_bcc"] != "") $headers["BCC"] = nl2br(str_replace(";", ",", $_POST["txt_bcc"]));

		$text = ko_emailtext($_POST["txt_emailtext"]);

		ko_send_email(str_replace(";", ",", $_POST["txt_empfaenger"]), $_POST["txt_betreff"], $text, $headers);

		$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "show_all";
		$info = 4;
		ko_log("leute_email", '"' . format_userinput($_POST["txt_betreff"], "text") . '": '.str_replace(",", ", ", format_userinput($_POST["txt_empfaenger"], "text")).", cc: ".str_replace(",", ", ", format_userinput($_POST["txt_cc"], "text")).", bcc: ".str_replace(",", ", ", format_userinput($_POST["txt_bcc"], "text")).", Text: ".format_userinput($_POST["txt_emailtext"], "text"));
	break;





	case "assign_login":
		if(!ko_module_installed("admin")) continue;
		ko_get_admin("admin", $_SESSION["ses_userid"], $a_view, $a_new, $a_edit, $a_mod);
		if(!$a_mod) continue;

		if(sizeof($_POST["chk"]) > 1) {
			$error = 7;
		}
		if(sizeof($_POST["chk"]) == 0) {
			$error = 8;
		}

		if(!$error) {
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) $leute_id = $c_i;
			}
			
			db_update_data("ko_admin", "WHERE `id`='".format_userinput($_POST["sel_login"], "uint")."'", array("leute_id" => $leute_id));
			$info=5;

			ko_get_login(format_userinput($_POST["sel_login"], "uint"), $login);
			ko_get_person_by_id($leute_id, $person);
			ko_log("assign_login", $login["login"]." (".format_userinput($_POST["sel_login"], "uint")."): ".$person["vorname"]." ".$person["nachname"]." ($leute_id)");
		}//if(!error)
	break;


	case "assign_dienst":
		if(!ko_module_installed("dp")) continue;
		if(!$d_edit) continue;

		if(sizeof($_POST["chk"]) == 0) {
			$error = 9;
		}

		if(!$error) {
			include_once($ko_path."dp/inc/dp.inc");
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ko_dp_assign_person_to_dienst($c_i, format_userinput($_POST["sel_dienst"], "uint"), "dienst") ) {
						$error = 10;
					} else {
						$info = 6;
					}
				}//if(c)
			}//foreach(chk)
		}//if(!error)
	break;


	case "assign_dienst_del":
		if(!ko_module_installed("dp")) continue;
		if(!$d_edit) continue;

		if(sizeof($_POST["chk"]) == 0) {
			$error = 9;
		}

		if(!$error) {
			include_once($ko_path."dp/inc/dp.inc");
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ko_dp_remove_person_from_dienst($c_i, format_userinput($_POST["sel_dienst"], "uint"), "dienst") ) {
						$error = 11;
					} else {
						$info = 8;
					}
				}//if(c)
			}//foreach(chk)
		}//if(!error)
	break;


	case "assign_dienst_verantwortlich":
		if(!ko_module_installed("dp")) continue;
		if(!$d_mod) continue;

		if(sizeof($_POST["chk"]) == 0) {
			$error = 9;
		}

		if(!$error) {
			include_once($ko_path."dp/inc/dp.inc");
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ko_dp_assign_person_to_dienst($c_i, format_userinput($_POST["sel_dienst_verantwortlich"], "uint"), "dienstleiter") ) {
						$error = 10;
					} else {
						$info = 7;
					}
				}//if(c)
			}//foreach(chk)
		}//if(!error)
	break;


	case "assign_dienst_verantwortlich_del":
		if(!ko_module_installed("dp")) continue;
		if(!$d_mod) continue;

		if(sizeof($_POST["chk"]) == 0) {
			$error = 9;
		}

		if(!$error) {
			include_once($ko_path."dp/inc/dp.inc");
			foreach($_POST["chk"] as $c_i => $c) {
				if($c) {
					if(FALSE === ko_dp_remove_person_from_dienst($c_i, format_userinput($_POST["sel_dienst_verantwortlich"], "uint"), "dienstleiter") ) {
						$error = 11;
					} else {
						$info = 9;
					}
				}//if(c)
			}//foreach(chk)
		}//if(!error)
	break;




	//Kleingruppen
	case "neue_kg":
		$_SESSION["show_back"] = $_SESSION["show"];
		$_SESSION["show"] = "neue_kg";
	break;



	case "list_kg":
		if(ko_module_installed("kg") && $kg_view) {
			$_SESSION["show"] = "list_kg";
			$_SESSION["show_kg_start"] = 1;
		} else {
			$_SESSION["show"] = "show_all";
		}
	break;


	case "chart_kg":
		if(ko_module_installed("kg") && $kg_view) {
			$_SESSION["show"] = "chart_kg";
		} else {
			$_SESSION["show"] = "show_all";
		}
	break;


	case "edit_kg":
		$_SESSION["show_back"] = $_SESSION["show"];
		$_SESSION["show"] = "edit_kg";
		$edit_id = format_userinput($_POST["id"], "uint");
	break;


	case "set_kg_filter":
		if(FALSE === ($id = format_userinput($_GET["id"], "uint", TRUE, 4))) {
			trigger_error("Not allowed set_kg_filter-id: ".$_POST["id"], E_USER_ERROR);
		}
		if(!$kg_view || !($group_view || $item_view) || !$id) continue;
		
		$_SESSION["filter"] = array();

		$filter_akt = 0;
		ko_get_filters($filters, "leute");
    foreach($filters as $ff) {
      if(!$filter_akt && $ff["_name"] == "smallgroup") {
        $filter_akt = $ff["id"];
        $f = $ff;
      }
    }
		if(!$filter_akt) continue;

		$vars = array(1 => $id);
		$_SESSION["filter"][] = array($filter_akt, $vars, 0);

		$_SESSION["show"] = "show_all";
		$_SESSION["show_start"] = 1;
	break;


	case "delete_kg":
		if(FALSE === ($id = format_userinput($_POST["id"], "uint", TRUE, 4))) {
			trigger_error("Not allowed kg-id: ".$_POST["id"], E_USER_ERROR);
		}
		if(!$kg_edit) continue;

		$old_kg = db_select_data("ko_kleingruppen", "WHERE `id` = '$id'");
		db_delete_data("ko_kleingruppen", "WHERE `id` = '$id.'");

		//update people data
		ko_kg_update_people();
		ko_update_kg_filter();

		$info = 14;
		ko_log_diff("del_kg", $old_kg[$id]);
	break;



	case "submit_neue_kg":
		if(!$kg_edit) continue;

		kota_submit_multiedit($error, "", "new_kg");
		if(!$error) {
			ko_update_kg_filter();
			$info = 12;
			$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "list_kg";
		}
	break;



	case "submit_edit_kg":
		if(!$kg_new) continue;

		kota_submit_multiedit($error, "", "edit_kg");
		if(!$error) {
			ko_update_kg_filter();
			$info = 11;
			$_SESSION["show"] = $_SESSION["show_back"] ? $_SESSION["show_back"] : "list_kg";
		}
	break;




	case 'submit_filter_kg':
		$kg_filters = array('name', 'geschlecht', 'wochentag', 'treffen', 'type', 'region');
		foreach($_POST['kg_filter'] as $field => $value) {
			if(!in_array($field, $kg_filters)) continue;
			if($value == '') unset($_SESSION['kg_filter'][$field]);
			else $_SESSION['kg_filter'][$field] = $value;
		}
		$_SESSION['show'] = 'list_kg';
		$_SESSION['show_kg_start'] = 1;
	break;



	case 'submit_filter_kg_clear':
		unset($_SESSION['kg_filter']);
		$_SESSION['show'] = 'list_kg';
		$_SESSION['show_kg_start'] = 1;
	break;





	//Gruppen-Filter
	case "set_group_filter":
		if(FALSE === ($id = format_userinput($_GET["id"], "uint", TRUE, 6))) {
			trigger_error("Not allowed set_group_filter-id: ".$_POST["id"], E_USER_ERROR);
		}
		if(isset($_GET['rid'])) {
			$rid = format_userinput($_GET['rid'], 'uint', TRUE, 6);
		}
		if(!$g_view || !($group_view || $item_view) || !$id) continue;
		
		$_SESSION["filter"] = array();

		$filter_akt = 0;
		ko_get_filters($filters, "leute");
		foreach($filters as $ff) {
			if($ff['_name'] == 'group') {
				$filter_akt = $ff["id"];
				$f = $ff;
			}
		}
		if(!$filter_akt) continue;

		$vars = array(1 => 'g'.$id);
		if($rid) $vars[2] = ':r'.$rid;
		$_SESSION["filter"][] = array($filter_akt, $vars, 0);

		$_SESSION["show"] = "show_all";
		$_SESSION["show_start"] = 1;
	break;




	case 'set_pfilter':
		$fn = format_userinput($_GET['fn'], 'text');
		$ln = format_userinput($_GET['ln'], 'text');
		$firm = format_userinput($_GET['firm'], 'text');
		if(!$g_view || !($group_view || $item_view)) continue;
		if(!($fn && $ln) && !$firm) continue;

		$f1 = db_select_data('ko_filter', "WHERE `name` = 'last name'", '*', '', '', TRUE);
		$f2 = db_select_data('ko_filter', "WHERE `name` = 'first name'", '*', '', '', TRUE);
		$f3 = db_select_data('ko_filter', "WHERE `name` = 'firm'", '*', '', '', TRUE);
		if(!$f1['id'] || !$f2['id']) continue;

		$_SESSION['filter'] = array();
		if($ln) $_SESSION['filter'][] = array($f1['id'], array(1 => $ln), 0);
		if($fn) $_SESSION['filter'][] = array($f2['id'], array(1 => $fn), 0);
		if($firm) $_SESSION['filter'][] = array($f3['id'], array(1 => $firm), 0);

		$_SESSION['show'] = 'show_all';
		$_SESSION['show_start'] = 1;
	break;





	//Import
	case "import":
		if(!$group_mod) continue;

		if($_GET["state"]) $_SESSION["import_state"] = format_userinput($_GET["state"], "uint");
		if($_GET["mode"]) $_SESSION["import_mode"] = format_userinput($_GET["mode"], "alpha");

		if($_POST["submit"]) {
			if($_SESSION["import_state"] == 2) {
				if($_SESSION["import_mode"] == "vcard") {
					//file
					$file = $_FILES["vcf"];
					if(substr($file["type"], 0, 4) == "text") {  //text/x-vcard, text/directory
						$content = file($file["tmp_name"]);
						$_SESSION["import_data"] = ko_parse_vcf($content);
						$_SESSION["import_state"] = 4;
					} else {
						$error = 15;
					}
				}//vcard

				else if($_SESSION["import_mode"] == "csv") {
					//db columns
					if($_POST["sel_dbcols"]) {
						$_SESSION["import_csv"]["dbcols"] = explode(",", format_userinput($_POST["sel_dbcols"], "alphanumlist"));
					} else {
						$error = 17;
					}
					//file
					$file = $_FILES["csv"];
					$content = file($file["tmp_name"]);
					//separator
					$sep = $_POST["txt_separator"];
					if(strlen($sep) == 1) {
						$_SESSION["import_csv"]["separator"] = $sep;
					} else {
						$error = 16;
					}
					//content separator
					$sep = $_POST["txt_content_separator"];
					$_SESSION["import_csv"]["content_separator"] = $sep;
					//first line
					if($_POST["chk_first_line"]) {
						$_SESSION["import_csv"]["first_line"] = 1;
					} else {
						$_SESSION["import_csv"]["first_line"] = 0;
					}

					if(!$error) {
						if(ko_parse_csv($content, $_SESSION["import_csv"], TRUE, $check_errors)) {
							$_SESSION["import_data"] = ko_parse_csv($content, $_SESSION["import_csv"]);
							$_SESSION["import_state"] = 4;
						} else {
							$error = 18;
						}
					}

				}//csv
			}//if(state == 2)
		}//if(submit)

		$_SESSION["show"] = "import";
	break;  //import


	case "do_import":
		if(!$group_mod) continue;

		if($_POST["sel_group"]) {
			$add_group = format_userinput($_POST["sel_group"], "alphanum", FALSE, 0, array(), ":");
		} else {
			$add_group = FALSE;
		}

		$do_ldap = ko_do_ldap();
		if($do_ldap) $ldap = ko_ldap_connect();
		foreach($_SESSION["import_data"] as $data) {
			if(sizeof($data) > 0) {
				if($add_group) {
					$data["groups"] = $data["groups"] ? $data["groups"].",".$add_group : $add_group;
				}
				$data["crdate"] = date("Y-m-d H:i:s");
				$data["cruserid"] = $_SESSION["ses_userid"];
				$new_id = db_insert_data("ko_leute", $data);

				//LDAP-Data
				if($do_ldap) {
					foreach($LDAP_ATTRIB as $col => $attribkey) {
						if($data[$col] != "")
							$ldap_entry[$attribkey] = $data[$col];
					}
					$ldap_entry["cn"] = $ldap_entry["givenName"]." ".$ldap_entry["sn"];
					if($ldap_entry["cn"] == "") $ldap_entry["cn"] = "-";
					if($ldap_entry["sn"] == "") $ldap_entry["sn"] = "-";
					$ldap_entry["uid"] = $new_id;
					ko_ldap_add_person($ldap_entry);
				}//if(/do_ldap)
			}//if(sizeof(data) > 0)
		}//foreach(import_data as data)
		if($do_ldap) ko_ldap_close();


		//HOOK: Plugins erlauben, hier einzugreifen, bevor die Session-Daten gelscht werden
		hook_action_handler_inline($do_action);

		$info = 15;
		$_SESSION["show"] = "show_all";
		unset($_SESSION["import_mode"]);
		unset($_SESSION["import_state"]);
		unset($_SESSION["import_data"]);
		unset($_SESSION["import_csv"]);
	break;  //do_import




	case "submit_leute_version":
		if(!$group_mod) continue;

		if($_POST["date_version"] == "") {
			unset($_SESSION["leute_version"]);
		} else {
			$version = format_userinput($_POST["date_version"], "date");
			//empty date
			if(strtotime($version) == 0) continue;
			//don't allow future dates
			if(strtotime($version) > time()) continue;

			$_SESSION["leute_version"] = sql_datum($version);
		}

		$_SESSION["show"] = "show_all";
	break;  //submit_leute_version



	case "clear_leute_version":
		if(!$group_mod) continue;

		unset($_SESSION["leute_version"]);
		$_SESSION["show"] = "show_all";
	break;  //clear_leute_version



	//Rollback to old version
	case "rollback":
		$vid = format_userinput($_GET["v"], "uint");
		if(!$vid) break;

		//Retrieve data from old version
		$version = db_select_data("ko_leute_changes", "WHERE `id` = '$vid'", "*", "", "", TRUE);
		if(!isset($version["id"])) break;
		$data = unserialize($version["changes"]);
		$df = unserialize($version["df"]);
		$leute_id = $version["leute_id"];

		//Save version history
		ko_save_leute_changes($leute_id);

		//Update record
		db_update_data("ko_leute", "WHERE `id` = '$leute_id'", $data);
		ko_log_diff("edit_person", $data, $person);
		//Update datafields
		foreach($df as $dfid => $dfdata) {
			unset($dfdata["id"]);
			//Check for entry to update or insert a new one
			$cur = db_select_data("ko_groups_datafields_data", "WHERE `id` = '$dfid'", "*", "", "", TRUE);
			if($cur["id"] == $dfid) {
				db_update_data("ko_groups_datafields_data", "WHERE `id` = '$dfid'", $dfdata);
			} else {
				db_insert_data("ko_groups_datafields_data", $dfdata);
			}
		}
		//Delete datafields added since this version
		$dfdiff = array_diff(array_keys((array)$df_current), array_keys((array)$df));
		foreach($dfdiff as $dfid) {
			if(!$dfid) continue;
			db_delete_data("ko_groups_datafields_data", "WHERE `id` = '$dfid'");
		}
	break;  //rollback




	case 'set_fastfilter':
		$_SESSION['filter'] = array();

		foreach($FAST_FILTER_IDS as $id) {
			if($_POST['fastfilter'.$id]) {
				$_SESSION['filter'][] = array($id, array('', str_replace('*', '.*', format_userinput($_POST['fastfilter'.$id], 'text'))), 0);
			}
		}
		$_SESSION['show_start'] = 1;
		$_SESSION['show'] = 'show_all';
	break;





	//Submenus
  case "move_sm_left":
  case "move_sm_right":
    ko_submenu_actions("leute", $do_action);
  break;



	//Default:
	default:
		if(!hook_action_handler($do_action))
      include_once($ko_path."inc/abuse.inc");
	break;

}//switch(action)


//HOOK: Plugins erlauben, die bestehenden Actions zu erweitern
hook_action_handler_add($do_action);


//***Rechte neu auslesen:
list($item_view, $item_new, $item_edit) = ko_get_admin("leute", $_SESSION["ses_userid"], $group_view, $group_new, $group_edit, $group_mod);
if(ko_module_installed("kg")) ko_get_admin("kg", $_SESSION["ses_userid"], $kg_view, $kg_new, $kg_edit, $kg_mod);
if(ko_module_installed("groups")) ko_get_admin("groups", $_SESSION["ses_userid"], $g_view, $g_new, $g_edit, $g_mod);
if(ko_module_installed("dp")) ko_get_admin("dp", $_SESSION["ses_userid"], $d_view, $d_new, $d_edit, $d_mod);




//***Default-Settings auslesen, falls in dieser Session noch nicht gesetzt
if($_SESSION["show_leute_cols"] == "") {
	$show_leute_cols_string = ko_get_userpref($_SESSION["ses_userid"], "show_leute_cols");
	if($show_leute_cols_string) {
		$_SESSION["show_leute_cols"] = explode(",", $show_leute_cols_string);
	} else {
		$_SESSION["show_leute_cols"] = explode(",", ko_get_setting("show_leute_cols"));
	}
}

if($_SESSION["show_kg_cols"] == "") {
	$show_kg_cols_string = ko_get_userpref($_SESSION["ses_userid"], "show_kg_cols");
	if($show_kg_cols_string) {
		$_SESSION["show_kg_cols"] = explode(",", $show_kg_cols_string);
	} else {
		//Display all columns by default
		$_SESSION["show_kg_cols"] = array('name', 'alter', 'geschlecht', 'ort');
	}
}

if($_SESSION["show_leute_chart"] == "") {
	$userpref = ko_get_userpref($_SESSION["ses_userid"], "show_leute_chart");
	if($userpref) {
		$_SESSION["show_leute_chart"] = explode(",", $userpref);
		foreach($_SESSION["show_leute_chart"] as $i => $chart) {
			if(!in_array($chart, $LEUTE_CHART_TYPES)) unset($_SESSION["show_leute_chart"][$i]);
		}
	} else {
		$_SESSION["show_leute_chart"] = $LEUTE_CHART_TYPES;
	}
}

$_SESSION["show_limit"] = ko_get_userpref($_SESSION["ses_userid"], "show_limit_leute");
if(!$_SESSION["show_limit"]) $_SESSION["show_limit"] = ko_get_setting("show_limit_leute");

if(!$_SESSION["show_start"]) {
	$_SESSION["show_start"] = 1;
}

$_SESSION["show_kg_limit"] = ko_get_userpref($_SESSION["ses_userid"], "show_limit_kg");
if(!$_SESSION["show_kg_limit"]) $_SESSION["show_kg_limit"] = ko_get_setting("show_limit_kg");

if(!$_SESSION["show_kg_start"]) {
	$_SESSION["show_kg_start"] = 1;
}

if($_SESSION["sort_leute"][0] == "") {
	$_SESSION["sort_leute"][] = "nachname";
}
if($_SESSION["sort_leute_order"][0] == "") {
	$_SESSION["sort_leute_order"][] = "ASC";
}
if($_SESSION["sort_kg"] == "") {
	$_SESSION["sort_kg"] = "name";
}
if($_SESSION["sort_kg_order"] == "") {
	$_SESSION["sort_kg_order"] = "ASC";
}
if($_SESSION["sort_geburtstage"] == "") {
	$_SESSION["sort_geburtstage"] = "deadline";
}
if(!$_SESSION["filter_akt"]) {
	$hidden_filter = explode(",", ko_get_userpref($_SESSION["ses_userid"], "hide_leute_filter"));
	ko_get_filters($f_, "leute");
	$all_filter = array_keys($f_);
	$shown_filter = array_diff($all_filter, $hidden_filter);
	$first_shown = array_shift($shown_filter);
	$first_all = array_shift($all_filter);
	$_SESSION["filter_akt"] = $first_shown ? $first_shown : $first_all;
}
if(!$_SESSION["show_adressliste_cols"]) {
	$_SESSION["show_adressliste_cols"] = $LEUTE_ADRESSLISTE;
}

if(!isset($_SESSION["my_list"])) {
	if(ko_check_userpref($_SESSION["ses_userid"], "leute_my_list")) {
		$_SESSION["my_list"] = unserialize(ko_get_userpref($_SESSION["ses_userid"], "leute_my_list"));
	} else {
		$_SESSION["my_list"] = array();
	}
}
if(!$_SESSION["filter"]["link"]) $_SESSION["filter"]["link"] = "and";

//Include submenus
ko_set_submenues();

//HOOK: Submenus einlesen
$hooks = hook_include_sm();
if(sizeof($hooks) > 0) foreach($hooks as $hook) include($hook);
?>




<!DOCTYPE html 
  PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN"
  "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml" xml:lang="<?php print $_SESSION["lang"]; ?>" lang="<?php print $_SESSION["lang"]; ?>">
<head>
<meta http-equiv="Content-Type" content="text/html; charset=ISO-8859-1" />
<title><?php print "$HTML_TITLE: ".getLL("module_".$ko_menu_akt); ?></title>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>kOOL.css" />
<!--[if lte IE 6]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie6.css" />
<![endif]-->
<!--[if IE 7]>
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ie7.css" />
<![endif]-->
<link rel="stylesheet" type="text/css" href="<?php print $ko_path; ?>ko.css" />
<?php
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/kOOL.js\'></script>';
include($ko_path.'inc/js-sessiontimeout.inc');
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/popup.js\'></script>';
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/ajax.js\'></script>';
include("inc/js-leute.inc");
//Load JS files for js_calendar
$js_calendar->load_files();

//prepare group select for formular and group filter
print '<script type=\'text/javascript\' src=\''.$ko_path.'inc/selectmenu.js\'></script>';
$list_id = 1;
$orig_value = ko_get_setting("show_passed_groups");

if($_SESSION["show"] == "neue_person" || $_SESSION["show"] == "edit_person") {
	$show_all_types = FALSE;
	//Beim Einteilen die vergangenen Gruppen nie anzeigen
	ko_set_setting("show_passed_groups", 0);
	include("inc/js-groupmenu.inc");
	ko_set_setting("show_passed_groups", $orig_value);
	$loadcode = "initList($list_id, document.formular.sel_ds0_input_groups);";
	$onload_code = $loadcode.$onload_code;
} else {
	ko_get_filter_by_id($_SESSION["filter_akt"], $akt_filter);
	if($akt_filter["sql1"] == "groups REGEXP '[VAR1][g:0-9]*[VAR2]'") {
		$loadcode = "initList($list_id, document.formular.var1);";
		$onload_code = $loadcode.$onload_code;
	}
	//Beim Filter die vergangenen Gruppen gemss Einstellung zeigen
	//allerdings auch Platzhalter-Gruppen anzeigen
	$show_all_types = TRUE;
	include("inc/js-groupmenu.inc");
}
?>
</head>

<body onload="session_time_init();<?php if(isset($onload_code)) print $onload_code; ?>">

<script language="javaScript" type="text/javascript" src="<?php print $ko_path."inc/";?>tooltip.js"></script>

<?php
/*
 * Gibt bei erfolgreichem Login das Men aus, sonst einfach die Loginfelder
 */
include($ko_path . "menu.php");
?>


<form action="index.php" method="post" name="formular" enctype="multipart/form-data">  <!-- Hauptformular -->
<input type="hidden" name="action" id="action" value="" />
<input type="hidden" name="id" id="id" value="" />

<table width="100%">
<tr>

<td class="main_left" name="main_left" id="main_left">
<?php
print ko_get_submenu_code("leute", "left");
?>
</td>


<td class="main" name="main_content" id="main_content">
<?php
if($info) {
	if ($info <> 99 ) {
		$info_txt = getLL('info_leute_' . $info);
	}
	print '<div class="infotxt">'.$info_txt.'</div><br />';
}

if($error) {
	$error_txt = getLL('error_leute_' . $error);
	ko_error_log(getLL("module_leute"), $error, $error_txt, $do_action);
	print '<div class="errortxt">'.$error_txt.'</div><br />';
}

switch($_SESSION["show"]) {
	case "show_all":
		ko_list_personen();
	break;

	case "show_adressliste":
		ko_list_personen("adressliste");
	break;

	case "show_my_list":
		ko_list_personen("my_list");
	break;

	case "geburtstagsliste":
		//ko_list_geburtstage();
		ko_list_personen('birthdays');
	break;

	case "single_view":
		ko_leute_show_single($single_id);
	break;

	case "neue_person":
		$edit_titel = "Neue Person";
		$edit_submit_value = "Speichern";
		ko_formular_leute("neu");
	break;

	case "edit_person":
		$edit_titel = getLL("leute_labels_edit_pers");
		$edit_submit_value = "ndern";
		ko_formular_leute("edit", format_userinput($_POST["id"], "uint"));
	break;

	case "etiketten_optionen":
		$smarty->display("ko_formular_etiketten.tpl");
	break;

	case "mailmerge":
		$smarty->assign('label_title', getLL('leute_mailmerge_title').' ('.sizeof($_SESSION['mailmerge_data']).')');
		$smarty->assign('label_title_reuse', getLL('leute_mailmerge_title_reuse'));
		$smarty->assign('label_title_new', getLL('leute_mailmerge_title_new'));
		$smarty->assign('label_title_legend', getLL('leute_mailmerge_title_legend'));
		$smarty->assign('label_title_invalid', getLL('leute_mailmerge_title_invalid'));
		$smarty->assign('label_invalid_addresses', getLL('leute_mailmerge_invalid_addresses'));
		$smarty->assign('label_export_to_mylist', getLL('leute_mailmerge_label_export_to_mylist'));
		$smarty->assign('label_reuse_letter', getLL('leute_mailmerge_reuse_letter'));
		$smarty->assign('label_confirm_reuse', getLL('leute_mailmerge_confirm_reuse'));
		$smarty->assign('label_preset', getLL('leute_mailmerge_preset'));
		$smarty->assign('label_opening', getLL('leute_mailmerge_label_opening'));
		$smarty->assign('label_opening_formal', getLL('leute_mailmerge_label_opening_formal'));
		$smarty->assign('label_opening_informal', getLL('leute_mailmerge_label_opening_informal'));
		$smarty->assign('label_subject', getLL('leute_mailmerge_label_subject'));
		$smarty->assign('label_sender', getLL('leute_mailmerge_label_sender'));
		$smarty->assign('label_text', getLL('leute_mailmerge_label_text'));
		$smarty->assign('label_enlarge_right', getLL('leute_mailmerge_text_enlarge_right'));
		$smarty->assign('label_enlarge_down', getLL('leute_mailmerge_text_enlarge_down'));
		$smarty->assign('label_closing', getLL('leute_mailmerge_label_closing'));
		$smarty->assign('label_signature', getLL('leute_mailmerge_label_signature'));
		$smarty->assign('label_sig_file', getLL('leute_mailmerge_label_sig_file'));
		$smarty->assign('label_chk_sig_file', getLL('leute_mailmerge_label_chk_sig_file'));
		$smarty->assign('label_submit', getLL('leute_mailmerge_submit'));
		$smarty->assign('label_cancel', getLL('cancel'));
		$smarty->assign('tpl_cancel', 'show_all');
		$smarty->assign('sesid', session_id());
		$smarty->assign('help', ko_get_help('leute', 'mailmerge'));
		$smarty->display("ko_mailmerge.tpl");
	break;

	case "sms_versand":
		$smarty->assign("tpl_send_sms", getLL('leute_sms_send'));
		$smarty->assign("tpl_sms_bal", getLL('leute_sms_balance'));
		$smarty->assign("tpl_sms_receiver", getLL('leute_sms_receiver'));
		$smarty->assign("tpl_sms_add_receiver", getLL('leute_sms_add_receiver'));
		$smarty->assign("tpl_sms_no_number", getLL('leute_sms_no_number'));
		$smarty->assign("tpl_sms_excel_file", getLL('leute_sms_excel_file'));
		$smarty->assign("tpl_sms_my_export", getLL('leute_sms_my_export'));
		$smarty->assign("tpl_sms_my_add", getLL('leute_sms_my_add'));
		$smarty->assign("tpl_sms_text", getLL('leute_sms_text'));
		$smarty->assign("tpl_sms_submit", getLL('leute_sms_submit'));
		$smarty->display("ko_formular_sms.tpl");
	break;

	case "email_versand":
		$smarty->assign("tpl_title1", getLL('leute_email_title1'));
		$smarty->assign("tpl_body1", getLL('leute_email_body1'));
		$smarty->assign("tpl_all_recip", getLL('leute_email_all_recipients'));
		$smarty->assign("tpl_no_email", getLL('leute_email_no_email'));
		$smarty->assign("tpl_xls_file", getLL('leute_email_xls_file'));
		$smarty->assign("tpl_title2", getLL('leute_email_title2'));
		$smarty->assign("tpl_body2", getLL('leute_email_body2'));
		$smarty->assign("tpl_more", getLL('leute_email_more'));
		$smarty->assign("tpl_to", getLL('leute_email_to'));
		$smarty->assign("tpl_cc", getLL('leute_email_cc'));
		$smarty->assign("tpl_bcc", getLL('leute_email_bcc'));
		$smarty->assign("tpl_subject", getLL('leute_email_subject'));
		$smarty->assign("tpl_text", getLL('leute_email_text'));
		$smarty->assign("tpl_bcc_me", getLL('leute_email_bcc_me'));
		$smarty->assign("tpl_yes", getLL('yes'));
		$smarty->assign("tpl_no", getLL('no'));
		$smarty->assign("tpl_send", getLL('leute_email_send'));
		$smarty->assign("tpl_error_no_subject", getLL("leute_email_error_no_subject"));
		$smarty->display("ko_formular_email.tpl");
	break;

	case "export_pdf":
		ko_export_leute_as_pdf_settings($layout_id);
	break;

	case "mutationsliste":
		ko_list_mod_leute();
	break;

	case "groupsubscriptions":
		ko_list_groupsubscriptions();
	break;

	case "list_kg":
		ko_list_kg();
	break;

	case "chart_kg":
		print ko_kg_chart();
	break;

	case "neue_kg":
		ko_kg_formular("neu");
	break;

	case "edit_kg":
		ko_kg_formular("edit", $edit_id);
	break;

	case "multiedit":
		ko_multiedit_formular("ko_leute", $do_columns, $do_ids, $order, array("cancel" => "show_all"));
	break;

	case "multiedit_kg":
		ko_multiedit_formular("ko_kleingruppen", $do_columns, $do_ids, $order, array("cancel" => "list_kg"));
	break;

	case "import":
		ko_leute_import($_SESSION["import_state"], $_SESSION["import_mode"]);
	break;  //import

	case "chart":
		print ko_leute_chart();
	break;

	default:
		//HOOK: Plugins erlauben, neue Show-Cases zu definieren
		hook_show_case($_SESSION["show"]);
	break;
}//switch(show)

//HOOK: Plugins erlauben, neue Show-Cases zu definieren
hook_show_case_add($_SESSION["show"]);

?>
</td>

<td class="main_right" name="main_right" id="main_right">

<?php
print ko_get_submenu_code("leute", "right");
?>

</td>
</tr>

<?php include($ko_path . "footer.php"); ?>

</table>
</form> <!-- //Hauptformular -->

</body>
</html>
